# Copyright (c) (2011,2012,2015,2016,2018,2019,2021) Apple Inc. All rights reserved.
#
# corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
# is contained in the License.txt file distributed with corecrypto) and only to
# people who accept that license. IMPORTANT:  Any license rights granted to you by
# Apple Inc. (if any) are limited to internal use within your organization only on
# devices and computers you own or control, for the sole purpose of verifying the
# security characteristics and correct functioning of the Apple Software.  You may
# not, directly or indirectly, redistribute the Apple Software or any portions thereof.

#include <corecrypto/cc_config.h>

// This file was generated by MakeData.c.

        CC_ASM_SECTION_CONST


// Round constants.
	.globl	_AESRcon
	CC_ASM_PRIVATE_EXTERN _AESRcon
_AESRcon:
	.byte	0	// Not used, included for indexing simplicity.
	.byte	0x01
	.byte	0x02
	.byte	0x04
	.byte	0x08
	.byte	0x10
	.byte	0x20
	.byte	0x40
	.byte	0x80
	.byte	0x1b
	.byte	0x36


// Tables for InvMixColumn.
	.globl	_AESInvMixColumnTable
	CC_ASM_PRIVATE_EXTERN	_AESInvMixColumnTable
	.p2align	2
_AESInvMixColumnTable:
	// Table 0.
	.long	0x00000000
	.long	0x0b0d090e
	.long	0x161a121c
	.long	0x1d171b12
	.long	0x2c342438
	.long	0x27392d36
	.long	0x3a2e3624
	.long	0x31233f2a
	.long	0x58684870
	.long	0x5365417e
	.long	0x4e725a6c
	.long	0x457f5362
	.long	0x745c6c48
	.long	0x7f516546
	.long	0x62467e54
	.long	0x694b775a
	.long	0xb0d090e0
	.long	0xbbdd99ee
	.long	0xa6ca82fc
	.long	0xadc78bf2
	.long	0x9ce4b4d8
	.long	0x97e9bdd6
	.long	0x8afea6c4
	.long	0x81f3afca
	.long	0xe8b8d890
	.long	0xe3b5d19e
	.long	0xfea2ca8c
	.long	0xf5afc382
	.long	0xc48cfca8
	.long	0xcf81f5a6
	.long	0xd296eeb4
	.long	0xd99be7ba
	.long	0x7bbb3bdb
	.long	0x70b632d5
	.long	0x6da129c7
	.long	0x66ac20c9
	.long	0x578f1fe3
	.long	0x5c8216ed
	.long	0x41950dff
	.long	0x4a9804f1
	.long	0x23d373ab
	.long	0x28de7aa5
	.long	0x35c961b7
	.long	0x3ec468b9
	.long	0x0fe75793
	.long	0x04ea5e9d
	.long	0x19fd458f
	.long	0x12f04c81
	.long	0xcb6bab3b
	.long	0xc066a235
	.long	0xdd71b927
	.long	0xd67cb029
	.long	0xe75f8f03
	.long	0xec52860d
	.long	0xf1459d1f
	.long	0xfa489411
	.long	0x9303e34b
	.long	0x980eea45
	.long	0x8519f157
	.long	0x8e14f859
	.long	0xbf37c773
	.long	0xb43ace7d
	.long	0xa92dd56f
	.long	0xa220dc61
	.long	0xf66d76ad
	.long	0xfd607fa3
	.long	0xe07764b1
	.long	0xeb7a6dbf
	.long	0xda595295
	.long	0xd1545b9b
	.long	0xcc434089
	.long	0xc74e4987
	.long	0xae053edd
	.long	0xa50837d3
	.long	0xb81f2cc1
	.long	0xb31225cf
	.long	0x82311ae5
	.long	0x893c13eb
	.long	0x942b08f9
	.long	0x9f2601f7
	.long	0x46bde64d
	.long	0x4db0ef43
	.long	0x50a7f451
	.long	0x5baafd5f
	.long	0x6a89c275
	.long	0x6184cb7b
	.long	0x7c93d069
	.long	0x779ed967
	.long	0x1ed5ae3d
	.long	0x15d8a733
	.long	0x08cfbc21
	.long	0x03c2b52f
	.long	0x32e18a05
	.long	0x39ec830b
	.long	0x24fb9819
	.long	0x2ff69117
	.long	0x8dd64d76
	.long	0x86db4478
	.long	0x9bcc5f6a
	.long	0x90c15664
	.long	0xa1e2694e
	.long	0xaaef6040
	.long	0xb7f87b52
	.long	0xbcf5725c
	.long	0xd5be0506
	.long	0xdeb30c08
	.long	0xc3a4171a
	.long	0xc8a91e14
	.long	0xf98a213e
	.long	0xf2872830
	.long	0xef903322
	.long	0xe49d3a2c
	.long	0x3d06dd96
	.long	0x360bd498
	.long	0x2b1ccf8a
	.long	0x2011c684
	.long	0x1132f9ae
	.long	0x1a3ff0a0
	.long	0x0728ebb2
	.long	0x0c25e2bc
	.long	0x656e95e6
	.long	0x6e639ce8
	.long	0x737487fa
	.long	0x78798ef4
	.long	0x495ab1de
	.long	0x4257b8d0
	.long	0x5f40a3c2
	.long	0x544daacc
	.long	0xf7daec41
	.long	0xfcd7e54f
	.long	0xe1c0fe5d
	.long	0xeacdf753
	.long	0xdbeec879
	.long	0xd0e3c177
	.long	0xcdf4da65
	.long	0xc6f9d36b
	.long	0xafb2a431
	.long	0xa4bfad3f
	.long	0xb9a8b62d
	.long	0xb2a5bf23
	.long	0x83868009
	.long	0x888b8907
	.long	0x959c9215
	.long	0x9e919b1b
	.long	0x470a7ca1
	.long	0x4c0775af
	.long	0x51106ebd
	.long	0x5a1d67b3
	.long	0x6b3e5899
	.long	0x60335197
	.long	0x7d244a85
	.long	0x7629438b
	.long	0x1f6234d1
	.long	0x146f3ddf
	.long	0x097826cd
	.long	0x02752fc3
	.long	0x335610e9
	.long	0x385b19e7
	.long	0x254c02f5
	.long	0x2e410bfb
	.long	0x8c61d79a
	.long	0x876cde94
	.long	0x9a7bc586
	.long	0x9176cc88
	.long	0xa055f3a2
	.long	0xab58faac
	.long	0xb64fe1be
	.long	0xbd42e8b0
	.long	0xd4099fea
	.long	0xdf0496e4
	.long	0xc2138df6
	.long	0xc91e84f8
	.long	0xf83dbbd2
	.long	0xf330b2dc
	.long	0xee27a9ce
	.long	0xe52aa0c0
	.long	0x3cb1477a
	.long	0x37bc4e74
	.long	0x2aab5566
	.long	0x21a65c68
	.long	0x10856342
	.long	0x1b886a4c
	.long	0x069f715e
	.long	0x0d927850
	.long	0x64d90f0a
	.long	0x6fd40604
	.long	0x72c31d16
	.long	0x79ce1418
	.long	0x48ed2b32
	.long	0x43e0223c
	.long	0x5ef7392e
	.long	0x55fa3020
	.long	0x01b79aec
	.long	0x0aba93e2
	.long	0x17ad88f0
	.long	0x1ca081fe
	.long	0x2d83bed4
	.long	0x268eb7da
	.long	0x3b99acc8
	.long	0x3094a5c6
	.long	0x59dfd29c
	.long	0x52d2db92
	.long	0x4fc5c080
	.long	0x44c8c98e
	.long	0x75ebf6a4
	.long	0x7ee6ffaa
	.long	0x63f1e4b8
	.long	0x68fcedb6
	.long	0xb1670a0c
	.long	0xba6a0302
	.long	0xa77d1810
	.long	0xac70111e
	.long	0x9d532e34
	.long	0x965e273a
	.long	0x8b493c28
	.long	0x80443526
	.long	0xe90f427c
	.long	0xe2024b72
	.long	0xff155060
	.long	0xf418596e
	.long	0xc53b6644
	.long	0xce366f4a
	.long	0xd3217458
	.long	0xd82c7d56
	.long	0x7a0ca137
	.long	0x7101a839
	.long	0x6c16b32b
	.long	0x671bba25
	.long	0x5638850f
	.long	0x5d358c01
	.long	0x40229713
	.long	0x4b2f9e1d
	.long	0x2264e947
	.long	0x2969e049
	.long	0x347efb5b
	.long	0x3f73f255
	.long	0x0e50cd7f
	.long	0x055dc471
	.long	0x184adf63
	.long	0x1347d66d
	.long	0xcadc31d7
	.long	0xc1d138d9
	.long	0xdcc623cb
	.long	0xd7cb2ac5
	.long	0xe6e815ef
	.long	0xede51ce1
	.long	0xf0f207f3
	.long	0xfbff0efd
	.long	0x92b479a7
	.long	0x99b970a9
	.long	0x84ae6bbb
	.long	0x8fa362b5
	.long	0xbe805d9f
	.long	0xb58d5491
	.long	0xa89a4f83
	.long	0xa397468d
	// Table 1.
	.long	0x00000000
	.long	0x0d090e0b
	.long	0x1a121c16
	.long	0x171b121d
	.long	0x3424382c
	.long	0x392d3627
	.long	0x2e36243a
	.long	0x233f2a31
	.long	0x68487058
	.long	0x65417e53
	.long	0x725a6c4e
	.long	0x7f536245
	.long	0x5c6c4874
	.long	0x5165467f
	.long	0x467e5462
	.long	0x4b775a69
	.long	0xd090e0b0
	.long	0xdd99eebb
	.long	0xca82fca6
	.long	0xc78bf2ad
	.long	0xe4b4d89c
	.long	0xe9bdd697
	.long	0xfea6c48a
	.long	0xf3afca81
	.long	0xb8d890e8
	.long	0xb5d19ee3
	.long	0xa2ca8cfe
	.long	0xafc382f5
	.long	0x8cfca8c4
	.long	0x81f5a6cf
	.long	0x96eeb4d2
	.long	0x9be7bad9
	.long	0xbb3bdb7b
	.long	0xb632d570
	.long	0xa129c76d
	.long	0xac20c966
	.long	0x8f1fe357
	.long	0x8216ed5c
	.long	0x950dff41
	.long	0x9804f14a
	.long	0xd373ab23
	.long	0xde7aa528
	.long	0xc961b735
	.long	0xc468b93e
	.long	0xe757930f
	.long	0xea5e9d04
	.long	0xfd458f19
	.long	0xf04c8112
	.long	0x6bab3bcb
	.long	0x66a235c0
	.long	0x71b927dd
	.long	0x7cb029d6
	.long	0x5f8f03e7
	.long	0x52860dec
	.long	0x459d1ff1
	.long	0x489411fa
	.long	0x03e34b93
	.long	0x0eea4598
	.long	0x19f15785
	.long	0x14f8598e
	.long	0x37c773bf
	.long	0x3ace7db4
	.long	0x2dd56fa9
	.long	0x20dc61a2
	.long	0x6d76adf6
	.long	0x607fa3fd
	.long	0x7764b1e0
	.long	0x7a6dbfeb
	.long	0x595295da
	.long	0x545b9bd1
	.long	0x434089cc
	.long	0x4e4987c7
	.long	0x053eddae
	.long	0x0837d3a5
	.long	0x1f2cc1b8
	.long	0x1225cfb3
	.long	0x311ae582
	.long	0x3c13eb89
	.long	0x2b08f994
	.long	0x2601f79f
	.long	0xbde64d46
	.long	0xb0ef434d
	.long	0xa7f45150
	.long	0xaafd5f5b
	.long	0x89c2756a
	.long	0x84cb7b61
	.long	0x93d0697c
	.long	0x9ed96777
	.long	0xd5ae3d1e
	.long	0xd8a73315
	.long	0xcfbc2108
	.long	0xc2b52f03
	.long	0xe18a0532
	.long	0xec830b39
	.long	0xfb981924
	.long	0xf691172f
	.long	0xd64d768d
	.long	0xdb447886
	.long	0xcc5f6a9b
	.long	0xc1566490
	.long	0xe2694ea1
	.long	0xef6040aa
	.long	0xf87b52b7
	.long	0xf5725cbc
	.long	0xbe0506d5
	.long	0xb30c08de
	.long	0xa4171ac3
	.long	0xa91e14c8
	.long	0x8a213ef9
	.long	0x872830f2
	.long	0x903322ef
	.long	0x9d3a2ce4
	.long	0x06dd963d
	.long	0x0bd49836
	.long	0x1ccf8a2b
	.long	0x11c68420
	.long	0x32f9ae11
	.long	0x3ff0a01a
	.long	0x28ebb207
	.long	0x25e2bc0c
	.long	0x6e95e665
	.long	0x639ce86e
	.long	0x7487fa73
	.long	0x798ef478
	.long	0x5ab1de49
	.long	0x57b8d042
	.long	0x40a3c25f
	.long	0x4daacc54
	.long	0xdaec41f7
	.long	0xd7e54ffc
	.long	0xc0fe5de1
	.long	0xcdf753ea
	.long	0xeec879db
	.long	0xe3c177d0
	.long	0xf4da65cd
	.long	0xf9d36bc6
	.long	0xb2a431af
	.long	0xbfad3fa4
	.long	0xa8b62db9
	.long	0xa5bf23b2
	.long	0x86800983
	.long	0x8b890788
	.long	0x9c921595
	.long	0x919b1b9e
	.long	0x0a7ca147
	.long	0x0775af4c
	.long	0x106ebd51
	.long	0x1d67b35a
	.long	0x3e58996b
	.long	0x33519760
	.long	0x244a857d
	.long	0x29438b76
	.long	0x6234d11f
	.long	0x6f3ddf14
	.long	0x7826cd09
	.long	0x752fc302
	.long	0x5610e933
	.long	0x5b19e738
	.long	0x4c02f525
	.long	0x410bfb2e
	.long	0x61d79a8c
	.long	0x6cde9487
	.long	0x7bc5869a
	.long	0x76cc8891
	.long	0x55f3a2a0
	.long	0x58faacab
	.long	0x4fe1beb6
	.long	0x42e8b0bd
	.long	0x099fead4
	.long	0x0496e4df
	.long	0x138df6c2
	.long	0x1e84f8c9
	.long	0x3dbbd2f8
	.long	0x30b2dcf3
	.long	0x27a9ceee
	.long	0x2aa0c0e5
	.long	0xb1477a3c
	.long	0xbc4e7437
	.long	0xab55662a
	.long	0xa65c6821
	.long	0x85634210
	.long	0x886a4c1b
	.long	0x9f715e06
	.long	0x9278500d
	.long	0xd90f0a64
	.long	0xd406046f
	.long	0xc31d1672
	.long	0xce141879
	.long	0xed2b3248
	.long	0xe0223c43
	.long	0xf7392e5e
	.long	0xfa302055
	.long	0xb79aec01
	.long	0xba93e20a
	.long	0xad88f017
	.long	0xa081fe1c
	.long	0x83bed42d
	.long	0x8eb7da26
	.long	0x99acc83b
	.long	0x94a5c630
	.long	0xdfd29c59
	.long	0xd2db9252
	.long	0xc5c0804f
	.long	0xc8c98e44
	.long	0xebf6a475
	.long	0xe6ffaa7e
	.long	0xf1e4b863
	.long	0xfcedb668
	.long	0x670a0cb1
	.long	0x6a0302ba
	.long	0x7d1810a7
	.long	0x70111eac
	.long	0x532e349d
	.long	0x5e273a96
	.long	0x493c288b
	.long	0x44352680
	.long	0x0f427ce9
	.long	0x024b72e2
	.long	0x155060ff
	.long	0x18596ef4
	.long	0x3b6644c5
	.long	0x366f4ace
	.long	0x217458d3
	.long	0x2c7d56d8
	.long	0x0ca1377a
	.long	0x01a83971
	.long	0x16b32b6c
	.long	0x1bba2567
	.long	0x38850f56
	.long	0x358c015d
	.long	0x22971340
	.long	0x2f9e1d4b
	.long	0x64e94722
	.long	0x69e04929
	.long	0x7efb5b34
	.long	0x73f2553f
	.long	0x50cd7f0e
	.long	0x5dc47105
	.long	0x4adf6318
	.long	0x47d66d13
	.long	0xdc31d7ca
	.long	0xd138d9c1
	.long	0xc623cbdc
	.long	0xcb2ac5d7
	.long	0xe815efe6
	.long	0xe51ce1ed
	.long	0xf207f3f0
	.long	0xff0efdfb
	.long	0xb479a792
	.long	0xb970a999
	.long	0xae6bbb84
	.long	0xa362b58f
	.long	0x805d9fbe
	.long	0x8d5491b5
	.long	0x9a4f83a8
	.long	0x97468da3
	// Table 2.
	.long	0x00000000
	.long	0x090e0b0d
	.long	0x121c161a
	.long	0x1b121d17
	.long	0x24382c34
	.long	0x2d362739
	.long	0x36243a2e
	.long	0x3f2a3123
	.long	0x48705868
	.long	0x417e5365
	.long	0x5a6c4e72
	.long	0x5362457f
	.long	0x6c48745c
	.long	0x65467f51
	.long	0x7e546246
	.long	0x775a694b
	.long	0x90e0b0d0
	.long	0x99eebbdd
	.long	0x82fca6ca
	.long	0x8bf2adc7
	.long	0xb4d89ce4
	.long	0xbdd697e9
	.long	0xa6c48afe
	.long	0xafca81f3
	.long	0xd890e8b8
	.long	0xd19ee3b5
	.long	0xca8cfea2
	.long	0xc382f5af
	.long	0xfca8c48c
	.long	0xf5a6cf81
	.long	0xeeb4d296
	.long	0xe7bad99b
	.long	0x3bdb7bbb
	.long	0x32d570b6
	.long	0x29c76da1
	.long	0x20c966ac
	.long	0x1fe3578f
	.long	0x16ed5c82
	.long	0x0dff4195
	.long	0x04f14a98
	.long	0x73ab23d3
	.long	0x7aa528de
	.long	0x61b735c9
	.long	0x68b93ec4
	.long	0x57930fe7
	.long	0x5e9d04ea
	.long	0x458f19fd
	.long	0x4c8112f0
	.long	0xab3bcb6b
	.long	0xa235c066
	.long	0xb927dd71
	.long	0xb029d67c
	.long	0x8f03e75f
	.long	0x860dec52
	.long	0x9d1ff145
	.long	0x9411fa48
	.long	0xe34b9303
	.long	0xea45980e
	.long	0xf1578519
	.long	0xf8598e14
	.long	0xc773bf37
	.long	0xce7db43a
	.long	0xd56fa92d
	.long	0xdc61a220
	.long	0x76adf66d
	.long	0x7fa3fd60
	.long	0x64b1e077
	.long	0x6dbfeb7a
	.long	0x5295da59
	.long	0x5b9bd154
	.long	0x4089cc43
	.long	0x4987c74e
	.long	0x3eddae05
	.long	0x37d3a508
	.long	0x2cc1b81f
	.long	0x25cfb312
	.long	0x1ae58231
	.long	0x13eb893c
	.long	0x08f9942b
	.long	0x01f79f26
	.long	0xe64d46bd
	.long	0xef434db0
	.long	0xf45150a7
	.long	0xfd5f5baa
	.long	0xc2756a89
	.long	0xcb7b6184
	.long	0xd0697c93
	.long	0xd967779e
	.long	0xae3d1ed5
	.long	0xa73315d8
	.long	0xbc2108cf
	.long	0xb52f03c2
	.long	0x8a0532e1
	.long	0x830b39ec
	.long	0x981924fb
	.long	0x91172ff6
	.long	0x4d768dd6
	.long	0x447886db
	.long	0x5f6a9bcc
	.long	0x566490c1
	.long	0x694ea1e2
	.long	0x6040aaef
	.long	0x7b52b7f8
	.long	0x725cbcf5
	.long	0x0506d5be
	.long	0x0c08deb3
	.long	0x171ac3a4
	.long	0x1e14c8a9
	.long	0x213ef98a
	.long	0x2830f287
	.long	0x3322ef90
	.long	0x3a2ce49d
	.long	0xdd963d06
	.long	0xd498360b
	.long	0xcf8a2b1c
	.long	0xc6842011
	.long	0xf9ae1132
	.long	0xf0a01a3f
	.long	0xebb20728
	.long	0xe2bc0c25
	.long	0x95e6656e
	.long	0x9ce86e63
	.long	0x87fa7374
	.long	0x8ef47879
	.long	0xb1de495a
	.long	0xb8d04257
	.long	0xa3c25f40
	.long	0xaacc544d
	.long	0xec41f7da
	.long	0xe54ffcd7
	.long	0xfe5de1c0
	.long	0xf753eacd
	.long	0xc879dbee
	.long	0xc177d0e3
	.long	0xda65cdf4
	.long	0xd36bc6f9
	.long	0xa431afb2
	.long	0xad3fa4bf
	.long	0xb62db9a8
	.long	0xbf23b2a5
	.long	0x80098386
	.long	0x8907888b
	.long	0x9215959c
	.long	0x9b1b9e91
	.long	0x7ca1470a
	.long	0x75af4c07
	.long	0x6ebd5110
	.long	0x67b35a1d
	.long	0x58996b3e
	.long	0x51976033
	.long	0x4a857d24
	.long	0x438b7629
	.long	0x34d11f62
	.long	0x3ddf146f
	.long	0x26cd0978
	.long	0x2fc30275
	.long	0x10e93356
	.long	0x19e7385b
	.long	0x02f5254c
	.long	0x0bfb2e41
	.long	0xd79a8c61
	.long	0xde94876c
	.long	0xc5869a7b
	.long	0xcc889176
	.long	0xf3a2a055
	.long	0xfaacab58
	.long	0xe1beb64f
	.long	0xe8b0bd42
	.long	0x9fead409
	.long	0x96e4df04
	.long	0x8df6c213
	.long	0x84f8c91e
	.long	0xbbd2f83d
	.long	0xb2dcf330
	.long	0xa9ceee27
	.long	0xa0c0e52a
	.long	0x477a3cb1
	.long	0x4e7437bc
	.long	0x55662aab
	.long	0x5c6821a6
	.long	0x63421085
	.long	0x6a4c1b88
	.long	0x715e069f
	.long	0x78500d92
	.long	0x0f0a64d9
	.long	0x06046fd4
	.long	0x1d1672c3
	.long	0x141879ce
	.long	0x2b3248ed
	.long	0x223c43e0
	.long	0x392e5ef7
	.long	0x302055fa
	.long	0x9aec01b7
	.long	0x93e20aba
	.long	0x88f017ad
	.long	0x81fe1ca0
	.long	0xbed42d83
	.long	0xb7da268e
	.long	0xacc83b99
	.long	0xa5c63094
	.long	0xd29c59df
	.long	0xdb9252d2
	.long	0xc0804fc5
	.long	0xc98e44c8
	.long	0xf6a475eb
	.long	0xffaa7ee6
	.long	0xe4b863f1
	.long	0xedb668fc
	.long	0x0a0cb167
	.long	0x0302ba6a
	.long	0x1810a77d
	.long	0x111eac70
	.long	0x2e349d53
	.long	0x273a965e
	.long	0x3c288b49
	.long	0x35268044
	.long	0x427ce90f
	.long	0x4b72e202
	.long	0x5060ff15
	.long	0x596ef418
	.long	0x6644c53b
	.long	0x6f4ace36
	.long	0x7458d321
	.long	0x7d56d82c
	.long	0xa1377a0c
	.long	0xa8397101
	.long	0xb32b6c16
	.long	0xba25671b
	.long	0x850f5638
	.long	0x8c015d35
	.long	0x97134022
	.long	0x9e1d4b2f
	.long	0xe9472264
	.long	0xe0492969
	.long	0xfb5b347e
	.long	0xf2553f73
	.long	0xcd7f0e50
	.long	0xc471055d
	.long	0xdf63184a
	.long	0xd66d1347
	.long	0x31d7cadc
	.long	0x38d9c1d1
	.long	0x23cbdcc6
	.long	0x2ac5d7cb
	.long	0x15efe6e8
	.long	0x1ce1ede5
	.long	0x07f3f0f2
	.long	0x0efdfbff
	.long	0x79a792b4
	.long	0x70a999b9
	.long	0x6bbb84ae
	.long	0x62b58fa3
	.long	0x5d9fbe80
	.long	0x5491b58d
	.long	0x4f83a89a
	.long	0x468da397
	// Table 3.
	.long	0x00000000
	.long	0x0e0b0d09
	.long	0x1c161a12
	.long	0x121d171b
	.long	0x382c3424
	.long	0x3627392d
	.long	0x243a2e36
	.long	0x2a31233f
	.long	0x70586848
	.long	0x7e536541
	.long	0x6c4e725a
	.long	0x62457f53
	.long	0x48745c6c
	.long	0x467f5165
	.long	0x5462467e
	.long	0x5a694b77
	.long	0xe0b0d090
	.long	0xeebbdd99
	.long	0xfca6ca82
	.long	0xf2adc78b
	.long	0xd89ce4b4
	.long	0xd697e9bd
	.long	0xc48afea6
	.long	0xca81f3af
	.long	0x90e8b8d8
	.long	0x9ee3b5d1
	.long	0x8cfea2ca
	.long	0x82f5afc3
	.long	0xa8c48cfc
	.long	0xa6cf81f5
	.long	0xb4d296ee
	.long	0xbad99be7
	.long	0xdb7bbb3b
	.long	0xd570b632
	.long	0xc76da129
	.long	0xc966ac20
	.long	0xe3578f1f
	.long	0xed5c8216
	.long	0xff41950d
	.long	0xf14a9804
	.long	0xab23d373
	.long	0xa528de7a
	.long	0xb735c961
	.long	0xb93ec468
	.long	0x930fe757
	.long	0x9d04ea5e
	.long	0x8f19fd45
	.long	0x8112f04c
	.long	0x3bcb6bab
	.long	0x35c066a2
	.long	0x27dd71b9
	.long	0x29d67cb0
	.long	0x03e75f8f
	.long	0x0dec5286
	.long	0x1ff1459d
	.long	0x11fa4894
	.long	0x4b9303e3
	.long	0x45980eea
	.long	0x578519f1
	.long	0x598e14f8
	.long	0x73bf37c7
	.long	0x7db43ace
	.long	0x6fa92dd5
	.long	0x61a220dc
	.long	0xadf66d76
	.long	0xa3fd607f
	.long	0xb1e07764
	.long	0xbfeb7a6d
	.long	0x95da5952
	.long	0x9bd1545b
	.long	0x89cc4340
	.long	0x87c74e49
	.long	0xddae053e
	.long	0xd3a50837
	.long	0xc1b81f2c
	.long	0xcfb31225
	.long	0xe582311a
	.long	0xeb893c13
	.long	0xf9942b08
	.long	0xf79f2601
	.long	0x4d46bde6
	.long	0x434db0ef
	.long	0x5150a7f4
	.long	0x5f5baafd
	.long	0x756a89c2
	.long	0x7b6184cb
	.long	0x697c93d0
	.long	0x67779ed9
	.long	0x3d1ed5ae
	.long	0x3315d8a7
	.long	0x2108cfbc
	.long	0x2f03c2b5
	.long	0x0532e18a
	.long	0x0b39ec83
	.long	0x1924fb98
	.long	0x172ff691
	.long	0x768dd64d
	.long	0x7886db44
	.long	0x6a9bcc5f
	.long	0x6490c156
	.long	0x4ea1e269
	.long	0x40aaef60
	.long	0x52b7f87b
	.long	0x5cbcf572
	.long	0x06d5be05
	.long	0x08deb30c
	.long	0x1ac3a417
	.long	0x14c8a91e
	.long	0x3ef98a21
	.long	0x30f28728
	.long	0x22ef9033
	.long	0x2ce49d3a
	.long	0x963d06dd
	.long	0x98360bd4
	.long	0x8a2b1ccf
	.long	0x842011c6
	.long	0xae1132f9
	.long	0xa01a3ff0
	.long	0xb20728eb
	.long	0xbc0c25e2
	.long	0xe6656e95
	.long	0xe86e639c
	.long	0xfa737487
	.long	0xf478798e
	.long	0xde495ab1
	.long	0xd04257b8
	.long	0xc25f40a3
	.long	0xcc544daa
	.long	0x41f7daec
	.long	0x4ffcd7e5
	.long	0x5de1c0fe
	.long	0x53eacdf7
	.long	0x79dbeec8
	.long	0x77d0e3c1
	.long	0x65cdf4da
	.long	0x6bc6f9d3
	.long	0x31afb2a4
	.long	0x3fa4bfad
	.long	0x2db9a8b6
	.long	0x23b2a5bf
	.long	0x09838680
	.long	0x07888b89
	.long	0x15959c92
	.long	0x1b9e919b
	.long	0xa1470a7c
	.long	0xaf4c0775
	.long	0xbd51106e
	.long	0xb35a1d67
	.long	0x996b3e58
	.long	0x97603351
	.long	0x857d244a
	.long	0x8b762943
	.long	0xd11f6234
	.long	0xdf146f3d
	.long	0xcd097826
	.long	0xc302752f
	.long	0xe9335610
	.long	0xe7385b19
	.long	0xf5254c02
	.long	0xfb2e410b
	.long	0x9a8c61d7
	.long	0x94876cde
	.long	0x869a7bc5
	.long	0x889176cc
	.long	0xa2a055f3
	.long	0xacab58fa
	.long	0xbeb64fe1
	.long	0xb0bd42e8
	.long	0xead4099f
	.long	0xe4df0496
	.long	0xf6c2138d
	.long	0xf8c91e84
	.long	0xd2f83dbb
	.long	0xdcf330b2
	.long	0xceee27a9
	.long	0xc0e52aa0
	.long	0x7a3cb147
	.long	0x7437bc4e
	.long	0x662aab55
	.long	0x6821a65c
	.long	0x42108563
	.long	0x4c1b886a
	.long	0x5e069f71
	.long	0x500d9278
	.long	0x0a64d90f
	.long	0x046fd406
	.long	0x1672c31d
	.long	0x1879ce14
	.long	0x3248ed2b
	.long	0x3c43e022
	.long	0x2e5ef739
	.long	0x2055fa30
	.long	0xec01b79a
	.long	0xe20aba93
	.long	0xf017ad88
	.long	0xfe1ca081
	.long	0xd42d83be
	.long	0xda268eb7
	.long	0xc83b99ac
	.long	0xc63094a5
	.long	0x9c59dfd2
	.long	0x9252d2db
	.long	0x804fc5c0
	.long	0x8e44c8c9
	.long	0xa475ebf6
	.long	0xaa7ee6ff
	.long	0xb863f1e4
	.long	0xb668fced
	.long	0x0cb1670a
	.long	0x02ba6a03
	.long	0x10a77d18
	.long	0x1eac7011
	.long	0x349d532e
	.long	0x3a965e27
	.long	0x288b493c
	.long	0x26804435
	.long	0x7ce90f42
	.long	0x72e2024b
	.long	0x60ff1550
	.long	0x6ef41859
	.long	0x44c53b66
	.long	0x4ace366f
	.long	0x58d32174
	.long	0x56d82c7d
	.long	0x377a0ca1
	.long	0x397101a8
	.long	0x2b6c16b3
	.long	0x25671bba
	.long	0x0f563885
	.long	0x015d358c
	.long	0x13402297
	.long	0x1d4b2f9e
	.long	0x472264e9
	.long	0x492969e0
	.long	0x5b347efb
	.long	0x553f73f2
	.long	0x7f0e50cd
	.long	0x71055dc4
	.long	0x63184adf
	.long	0x6d1347d6
	.long	0xd7cadc31
	.long	0xd9c1d138
	.long	0xcbdcc623
	.long	0xc5d7cb2a
	.long	0xefe6e815
	.long	0xe1ede51c
	.long	0xf3f0f207
	.long	0xfdfbff0e
	.long	0xa792b479
	.long	0xa999b970
	.long	0xbb84ae6b
	.long	0xb58fa362
	.long	0x9fbe805d
	.long	0x91b58d54
	.long	0x83a89a4f
	.long	0x8da39746


// SubBytes embedded in words tables.
	.globl	_AESSubBytesWordTable
	CC_ASM_PRIVATE_EXTERN	_AESSubBytesWordTable
	.p2align	2
_AESSubBytesWordTable:
	// Table 0.
	.long	0x00000063
	.long	0x0000007c
	.long	0x00000077
	.long	0x0000007b
	.long	0x000000f2
	.long	0x0000006b
	.long	0x0000006f
	.long	0x000000c5
	.long	0x00000030
	.long	0x00000001
	.long	0x00000067
	.long	0x0000002b
	.long	0x000000fe
	.long	0x000000d7
	.long	0x000000ab
	.long	0x00000076
	.long	0x000000ca
	.long	0x00000082
	.long	0x000000c9
	.long	0x0000007d
	.long	0x000000fa
	.long	0x00000059
	.long	0x00000047
	.long	0x000000f0
	.long	0x000000ad
	.long	0x000000d4
	.long	0x000000a2
	.long	0x000000af
	.long	0x0000009c
	.long	0x000000a4
	.long	0x00000072
	.long	0x000000c0
	.long	0x000000b7
	.long	0x000000fd
	.long	0x00000093
	.long	0x00000026
	.long	0x00000036
	.long	0x0000003f
	.long	0x000000f7
	.long	0x000000cc
	.long	0x00000034
	.long	0x000000a5
	.long	0x000000e5
	.long	0x000000f1
	.long	0x00000071
	.long	0x000000d8
	.long	0x00000031
	.long	0x00000015
	.long	0x00000004
	.long	0x000000c7
	.long	0x00000023
	.long	0x000000c3
	.long	0x00000018
	.long	0x00000096
	.long	0x00000005
	.long	0x0000009a
	.long	0x00000007
	.long	0x00000012
	.long	0x00000080
	.long	0x000000e2
	.long	0x000000eb
	.long	0x00000027
	.long	0x000000b2
	.long	0x00000075
	.long	0x00000009
	.long	0x00000083
	.long	0x0000002c
	.long	0x0000001a
	.long	0x0000001b
	.long	0x0000006e
	.long	0x0000005a
	.long	0x000000a0
	.long	0x00000052
	.long	0x0000003b
	.long	0x000000d6
	.long	0x000000b3
	.long	0x00000029
	.long	0x000000e3
	.long	0x0000002f
	.long	0x00000084
	.long	0x00000053
	.long	0x000000d1
	.long	0x00000000
	.long	0x000000ed
	.long	0x00000020
	.long	0x000000fc
	.long	0x000000b1
	.long	0x0000005b
	.long	0x0000006a
	.long	0x000000cb
	.long	0x000000be
	.long	0x00000039
	.long	0x0000004a
	.long	0x0000004c
	.long	0x00000058
	.long	0x000000cf
	.long	0x000000d0
	.long	0x000000ef
	.long	0x000000aa
	.long	0x000000fb
	.long	0x00000043
	.long	0x0000004d
	.long	0x00000033
	.long	0x00000085
	.long	0x00000045
	.long	0x000000f9
	.long	0x00000002
	.long	0x0000007f
	.long	0x00000050
	.long	0x0000003c
	.long	0x0000009f
	.long	0x000000a8
	.long	0x00000051
	.long	0x000000a3
	.long	0x00000040
	.long	0x0000008f
	.long	0x00000092
	.long	0x0000009d
	.long	0x00000038
	.long	0x000000f5
	.long	0x000000bc
	.long	0x000000b6
	.long	0x000000da
	.long	0x00000021
	.long	0x00000010
	.long	0x000000ff
	.long	0x000000f3
	.long	0x000000d2
	.long	0x000000cd
	.long	0x0000000c
	.long	0x00000013
	.long	0x000000ec
	.long	0x0000005f
	.long	0x00000097
	.long	0x00000044
	.long	0x00000017
	.long	0x000000c4
	.long	0x000000a7
	.long	0x0000007e
	.long	0x0000003d
	.long	0x00000064
	.long	0x0000005d
	.long	0x00000019
	.long	0x00000073
	.long	0x00000060
	.long	0x00000081
	.long	0x0000004f
	.long	0x000000dc
	.long	0x00000022
	.long	0x0000002a
	.long	0x00000090
	.long	0x00000088
	.long	0x00000046
	.long	0x000000ee
	.long	0x000000b8
	.long	0x00000014
	.long	0x000000de
	.long	0x0000005e
	.long	0x0000000b
	.long	0x000000db
	.long	0x000000e0
	.long	0x00000032
	.long	0x0000003a
	.long	0x0000000a
	.long	0x00000049
	.long	0x00000006
	.long	0x00000024
	.long	0x0000005c
	.long	0x000000c2
	.long	0x000000d3
	.long	0x000000ac
	.long	0x00000062
	.long	0x00000091
	.long	0x00000095
	.long	0x000000e4
	.long	0x00000079
	.long	0x000000e7
	.long	0x000000c8
	.long	0x00000037
	.long	0x0000006d
	.long	0x0000008d
	.long	0x000000d5
	.long	0x0000004e
	.long	0x000000a9
	.long	0x0000006c
	.long	0x00000056
	.long	0x000000f4
	.long	0x000000ea
	.long	0x00000065
	.long	0x0000007a
	.long	0x000000ae
	.long	0x00000008
	.long	0x000000ba
	.long	0x00000078
	.long	0x00000025
	.long	0x0000002e
	.long	0x0000001c
	.long	0x000000a6
	.long	0x000000b4
	.long	0x000000c6
	.long	0x000000e8
	.long	0x000000dd
	.long	0x00000074
	.long	0x0000001f
	.long	0x0000004b
	.long	0x000000bd
	.long	0x0000008b
	.long	0x0000008a
	.long	0x00000070
	.long	0x0000003e
	.long	0x000000b5
	.long	0x00000066
	.long	0x00000048
	.long	0x00000003
	.long	0x000000f6
	.long	0x0000000e
	.long	0x00000061
	.long	0x00000035
	.long	0x00000057
	.long	0x000000b9
	.long	0x00000086
	.long	0x000000c1
	.long	0x0000001d
	.long	0x0000009e
	.long	0x000000e1
	.long	0x000000f8
	.long	0x00000098
	.long	0x00000011
	.long	0x00000069
	.long	0x000000d9
	.long	0x0000008e
	.long	0x00000094
	.long	0x0000009b
	.long	0x0000001e
	.long	0x00000087
	.long	0x000000e9
	.long	0x000000ce
	.long	0x00000055
	.long	0x00000028
	.long	0x000000df
	.long	0x0000008c
	.long	0x000000a1
	.long	0x00000089
	.long	0x0000000d
	.long	0x000000bf
	.long	0x000000e6
	.long	0x00000042
	.long	0x00000068
	.long	0x00000041
	.long	0x00000099
	.long	0x0000002d
	.long	0x0000000f
	.long	0x000000b0
	.long	0x00000054
	.long	0x000000bb
	.long	0x00000016
	// Table 1.
	.long	0x00006300
	.long	0x00007c00
	.long	0x00007700
	.long	0x00007b00
	.long	0x0000f200
	.long	0x00006b00
	.long	0x00006f00
	.long	0x0000c500
	.long	0x00003000
	.long	0x00000100
	.long	0x00006700
	.long	0x00002b00
	.long	0x0000fe00
	.long	0x0000d700
	.long	0x0000ab00
	.long	0x00007600
	.long	0x0000ca00
	.long	0x00008200
	.long	0x0000c900
	.long	0x00007d00
	.long	0x0000fa00
	.long	0x00005900
	.long	0x00004700
	.long	0x0000f000
	.long	0x0000ad00
	.long	0x0000d400
	.long	0x0000a200
	.long	0x0000af00
	.long	0x00009c00
	.long	0x0000a400
	.long	0x00007200
	.long	0x0000c000
	.long	0x0000b700
	.long	0x0000fd00
	.long	0x00009300
	.long	0x00002600
	.long	0x00003600
	.long	0x00003f00
	.long	0x0000f700
	.long	0x0000cc00
	.long	0x00003400
	.long	0x0000a500
	.long	0x0000e500
	.long	0x0000f100
	.long	0x00007100
	.long	0x0000d800
	.long	0x00003100
	.long	0x00001500
	.long	0x00000400
	.long	0x0000c700
	.long	0x00002300
	.long	0x0000c300
	.long	0x00001800
	.long	0x00009600
	.long	0x00000500
	.long	0x00009a00
	.long	0x00000700
	.long	0x00001200
	.long	0x00008000
	.long	0x0000e200
	.long	0x0000eb00
	.long	0x00002700
	.long	0x0000b200
	.long	0x00007500
	.long	0x00000900
	.long	0x00008300
	.long	0x00002c00
	.long	0x00001a00
	.long	0x00001b00
	.long	0x00006e00
	.long	0x00005a00
	.long	0x0000a000
	.long	0x00005200
	.long	0x00003b00
	.long	0x0000d600
	.long	0x0000b300
	.long	0x00002900
	.long	0x0000e300
	.long	0x00002f00
	.long	0x00008400
	.long	0x00005300
	.long	0x0000d100
	.long	0x00000000
	.long	0x0000ed00
	.long	0x00002000
	.long	0x0000fc00
	.long	0x0000b100
	.long	0x00005b00
	.long	0x00006a00
	.long	0x0000cb00
	.long	0x0000be00
	.long	0x00003900
	.long	0x00004a00
	.long	0x00004c00
	.long	0x00005800
	.long	0x0000cf00
	.long	0x0000d000
	.long	0x0000ef00
	.long	0x0000aa00
	.long	0x0000fb00
	.long	0x00004300
	.long	0x00004d00
	.long	0x00003300
	.long	0x00008500
	.long	0x00004500
	.long	0x0000f900
	.long	0x00000200
	.long	0x00007f00
	.long	0x00005000
	.long	0x00003c00
	.long	0x00009f00
	.long	0x0000a800
	.long	0x00005100
	.long	0x0000a300
	.long	0x00004000
	.long	0x00008f00
	.long	0x00009200
	.long	0x00009d00
	.long	0x00003800
	.long	0x0000f500
	.long	0x0000bc00
	.long	0x0000b600
	.long	0x0000da00
	.long	0x00002100
	.long	0x00001000
	.long	0x0000ff00
	.long	0x0000f300
	.long	0x0000d200
	.long	0x0000cd00
	.long	0x00000c00
	.long	0x00001300
	.long	0x0000ec00
	.long	0x00005f00
	.long	0x00009700
	.long	0x00004400
	.long	0x00001700
	.long	0x0000c400
	.long	0x0000a700
	.long	0x00007e00
	.long	0x00003d00
	.long	0x00006400
	.long	0x00005d00
	.long	0x00001900
	.long	0x00007300
	.long	0x00006000
	.long	0x00008100
	.long	0x00004f00
	.long	0x0000dc00
	.long	0x00002200
	.long	0x00002a00
	.long	0x00009000
	.long	0x00008800
	.long	0x00004600
	.long	0x0000ee00
	.long	0x0000b800
	.long	0x00001400
	.long	0x0000de00
	.long	0x00005e00
	.long	0x00000b00
	.long	0x0000db00
	.long	0x0000e000
	.long	0x00003200
	.long	0x00003a00
	.long	0x00000a00
	.long	0x00004900
	.long	0x00000600
	.long	0x00002400
	.long	0x00005c00
	.long	0x0000c200
	.long	0x0000d300
	.long	0x0000ac00
	.long	0x00006200
	.long	0x00009100
	.long	0x00009500
	.long	0x0000e400
	.long	0x00007900
	.long	0x0000e700
	.long	0x0000c800
	.long	0x00003700
	.long	0x00006d00
	.long	0x00008d00
	.long	0x0000d500
	.long	0x00004e00
	.long	0x0000a900
	.long	0x00006c00
	.long	0x00005600
	.long	0x0000f400
	.long	0x0000ea00
	.long	0x00006500
	.long	0x00007a00
	.long	0x0000ae00
	.long	0x00000800
	.long	0x0000ba00
	.long	0x00007800
	.long	0x00002500
	.long	0x00002e00
	.long	0x00001c00
	.long	0x0000a600
	.long	0x0000b400
	.long	0x0000c600
	.long	0x0000e800
	.long	0x0000dd00
	.long	0x00007400
	.long	0x00001f00
	.long	0x00004b00
	.long	0x0000bd00
	.long	0x00008b00
	.long	0x00008a00
	.long	0x00007000
	.long	0x00003e00
	.long	0x0000b500
	.long	0x00006600
	.long	0x00004800
	.long	0x00000300
	.long	0x0000f600
	.long	0x00000e00
	.long	0x00006100
	.long	0x00003500
	.long	0x00005700
	.long	0x0000b900
	.long	0x00008600
	.long	0x0000c100
	.long	0x00001d00
	.long	0x00009e00
	.long	0x0000e100
	.long	0x0000f800
	.long	0x00009800
	.long	0x00001100
	.long	0x00006900
	.long	0x0000d900
	.long	0x00008e00
	.long	0x00009400
	.long	0x00009b00
	.long	0x00001e00
	.long	0x00008700
	.long	0x0000e900
	.long	0x0000ce00
	.long	0x00005500
	.long	0x00002800
	.long	0x0000df00
	.long	0x00008c00
	.long	0x0000a100
	.long	0x00008900
	.long	0x00000d00
	.long	0x0000bf00
	.long	0x0000e600
	.long	0x00004200
	.long	0x00006800
	.long	0x00004100
	.long	0x00009900
	.long	0x00002d00
	.long	0x00000f00
	.long	0x0000b000
	.long	0x00005400
	.long	0x0000bb00
	.long	0x00001600
	// Table 2.
	.long	0x00630000
	.long	0x007c0000
	.long	0x00770000
	.long	0x007b0000
	.long	0x00f20000
	.long	0x006b0000
	.long	0x006f0000
	.long	0x00c50000
	.long	0x00300000
	.long	0x00010000
	.long	0x00670000
	.long	0x002b0000
	.long	0x00fe0000
	.long	0x00d70000
	.long	0x00ab0000
	.long	0x00760000
	.long	0x00ca0000
	.long	0x00820000
	.long	0x00c90000
	.long	0x007d0000
	.long	0x00fa0000
	.long	0x00590000
	.long	0x00470000
	.long	0x00f00000
	.long	0x00ad0000
	.long	0x00d40000
	.long	0x00a20000
	.long	0x00af0000
	.long	0x009c0000
	.long	0x00a40000
	.long	0x00720000
	.long	0x00c00000
	.long	0x00b70000
	.long	0x00fd0000
	.long	0x00930000
	.long	0x00260000
	.long	0x00360000
	.long	0x003f0000
	.long	0x00f70000
	.long	0x00cc0000
	.long	0x00340000
	.long	0x00a50000
	.long	0x00e50000
	.long	0x00f10000
	.long	0x00710000
	.long	0x00d80000
	.long	0x00310000
	.long	0x00150000
	.long	0x00040000
	.long	0x00c70000
	.long	0x00230000
	.long	0x00c30000
	.long	0x00180000
	.long	0x00960000
	.long	0x00050000
	.long	0x009a0000
	.long	0x00070000
	.long	0x00120000
	.long	0x00800000
	.long	0x00e20000
	.long	0x00eb0000
	.long	0x00270000
	.long	0x00b20000
	.long	0x00750000
	.long	0x00090000
	.long	0x00830000
	.long	0x002c0000
	.long	0x001a0000
	.long	0x001b0000
	.long	0x006e0000
	.long	0x005a0000
	.long	0x00a00000
	.long	0x00520000
	.long	0x003b0000
	.long	0x00d60000
	.long	0x00b30000
	.long	0x00290000
	.long	0x00e30000
	.long	0x002f0000
	.long	0x00840000
	.long	0x00530000
	.long	0x00d10000
	.long	0x00000000
	.long	0x00ed0000
	.long	0x00200000
	.long	0x00fc0000
	.long	0x00b10000
	.long	0x005b0000
	.long	0x006a0000
	.long	0x00cb0000
	.long	0x00be0000
	.long	0x00390000
	.long	0x004a0000
	.long	0x004c0000
	.long	0x00580000
	.long	0x00cf0000
	.long	0x00d00000
	.long	0x00ef0000
	.long	0x00aa0000
	.long	0x00fb0000
	.long	0x00430000
	.long	0x004d0000
	.long	0x00330000
	.long	0x00850000
	.long	0x00450000
	.long	0x00f90000
	.long	0x00020000
	.long	0x007f0000
	.long	0x00500000
	.long	0x003c0000
	.long	0x009f0000
	.long	0x00a80000
	.long	0x00510000
	.long	0x00a30000
	.long	0x00400000
	.long	0x008f0000
	.long	0x00920000
	.long	0x009d0000
	.long	0x00380000
	.long	0x00f50000
	.long	0x00bc0000
	.long	0x00b60000
	.long	0x00da0000
	.long	0x00210000
	.long	0x00100000
	.long	0x00ff0000
	.long	0x00f30000
	.long	0x00d20000
	.long	0x00cd0000
	.long	0x000c0000
	.long	0x00130000
	.long	0x00ec0000
	.long	0x005f0000
	.long	0x00970000
	.long	0x00440000
	.long	0x00170000
	.long	0x00c40000
	.long	0x00a70000
	.long	0x007e0000
	.long	0x003d0000
	.long	0x00640000
	.long	0x005d0000
	.long	0x00190000
	.long	0x00730000
	.long	0x00600000
	.long	0x00810000
	.long	0x004f0000
	.long	0x00dc0000
	.long	0x00220000
	.long	0x002a0000
	.long	0x00900000
	.long	0x00880000
	.long	0x00460000
	.long	0x00ee0000
	.long	0x00b80000
	.long	0x00140000
	.long	0x00de0000
	.long	0x005e0000
	.long	0x000b0000
	.long	0x00db0000
	.long	0x00e00000
	.long	0x00320000
	.long	0x003a0000
	.long	0x000a0000
	.long	0x00490000
	.long	0x00060000
	.long	0x00240000
	.long	0x005c0000
	.long	0x00c20000
	.long	0x00d30000
	.long	0x00ac0000
	.long	0x00620000
	.long	0x00910000
	.long	0x00950000
	.long	0x00e40000
	.long	0x00790000
	.long	0x00e70000
	.long	0x00c80000
	.long	0x00370000
	.long	0x006d0000
	.long	0x008d0000
	.long	0x00d50000
	.long	0x004e0000
	.long	0x00a90000
	.long	0x006c0000
	.long	0x00560000
	.long	0x00f40000
	.long	0x00ea0000
	.long	0x00650000
	.long	0x007a0000
	.long	0x00ae0000
	.long	0x00080000
	.long	0x00ba0000
	.long	0x00780000
	.long	0x00250000
	.long	0x002e0000
	.long	0x001c0000
	.long	0x00a60000
	.long	0x00b40000
	.long	0x00c60000
	.long	0x00e80000
	.long	0x00dd0000
	.long	0x00740000
	.long	0x001f0000
	.long	0x004b0000
	.long	0x00bd0000
	.long	0x008b0000
	.long	0x008a0000
	.long	0x00700000
	.long	0x003e0000
	.long	0x00b50000
	.long	0x00660000
	.long	0x00480000
	.long	0x00030000
	.long	0x00f60000
	.long	0x000e0000
	.long	0x00610000
	.long	0x00350000
	.long	0x00570000
	.long	0x00b90000
	.long	0x00860000
	.long	0x00c10000
	.long	0x001d0000
	.long	0x009e0000
	.long	0x00e10000
	.long	0x00f80000
	.long	0x00980000
	.long	0x00110000
	.long	0x00690000
	.long	0x00d90000
	.long	0x008e0000
	.long	0x00940000
	.long	0x009b0000
	.long	0x001e0000
	.long	0x00870000
	.long	0x00e90000
	.long	0x00ce0000
	.long	0x00550000
	.long	0x00280000
	.long	0x00df0000
	.long	0x008c0000
	.long	0x00a10000
	.long	0x00890000
	.long	0x000d0000
	.long	0x00bf0000
	.long	0x00e60000
	.long	0x00420000
	.long	0x00680000
	.long	0x00410000
	.long	0x00990000
	.long	0x002d0000
	.long	0x000f0000
	.long	0x00b00000
	.long	0x00540000
	.long	0x00bb0000
	.long	0x00160000
	// Table 3.
	.long	0x63000000
	.long	0x7c000000
	.long	0x77000000
	.long	0x7b000000
	.long	0xf2000000
	.long	0x6b000000
	.long	0x6f000000
	.long	0xc5000000
	.long	0x30000000
	.long	0x01000000
	.long	0x67000000
	.long	0x2b000000
	.long	0xfe000000
	.long	0xd7000000
	.long	0xab000000
	.long	0x76000000
	.long	0xca000000
	.long	0x82000000
	.long	0xc9000000
	.long	0x7d000000
	.long	0xfa000000
	.long	0x59000000
	.long	0x47000000
	.long	0xf0000000
	.long	0xad000000
	.long	0xd4000000
	.long	0xa2000000
	.long	0xaf000000
	.long	0x9c000000
	.long	0xa4000000
	.long	0x72000000
	.long	0xc0000000
	.long	0xb7000000
	.long	0xfd000000
	.long	0x93000000
	.long	0x26000000
	.long	0x36000000
	.long	0x3f000000
	.long	0xf7000000
	.long	0xcc000000
	.long	0x34000000
	.long	0xa5000000
	.long	0xe5000000
	.long	0xf1000000
	.long	0x71000000
	.long	0xd8000000
	.long	0x31000000
	.long	0x15000000
	.long	0x04000000
	.long	0xc7000000
	.long	0x23000000
	.long	0xc3000000
	.long	0x18000000
	.long	0x96000000
	.long	0x05000000
	.long	0x9a000000
	.long	0x07000000
	.long	0x12000000
	.long	0x80000000
	.long	0xe2000000
	.long	0xeb000000
	.long	0x27000000
	.long	0xb2000000
	.long	0x75000000
	.long	0x09000000
	.long	0x83000000
	.long	0x2c000000
	.long	0x1a000000
	.long	0x1b000000
	.long	0x6e000000
	.long	0x5a000000
	.long	0xa0000000
	.long	0x52000000
	.long	0x3b000000
	.long	0xd6000000
	.long	0xb3000000
	.long	0x29000000
	.long	0xe3000000
	.long	0x2f000000
	.long	0x84000000
	.long	0x53000000
	.long	0xd1000000
	.long	0x00000000
	.long	0xed000000
	.long	0x20000000
	.long	0xfc000000
	.long	0xb1000000
	.long	0x5b000000
	.long	0x6a000000
	.long	0xcb000000
	.long	0xbe000000
	.long	0x39000000
	.long	0x4a000000
	.long	0x4c000000
	.long	0x58000000
	.long	0xcf000000
	.long	0xd0000000
	.long	0xef000000
	.long	0xaa000000
	.long	0xfb000000
	.long	0x43000000
	.long	0x4d000000
	.long	0x33000000
	.long	0x85000000
	.long	0x45000000
	.long	0xf9000000
	.long	0x02000000
	.long	0x7f000000
	.long	0x50000000
	.long	0x3c000000
	.long	0x9f000000
	.long	0xa8000000
	.long	0x51000000
	.long	0xa3000000
	.long	0x40000000
	.long	0x8f000000
	.long	0x92000000
	.long	0x9d000000
	.long	0x38000000
	.long	0xf5000000
	.long	0xbc000000
	.long	0xb6000000
	.long	0xda000000
	.long	0x21000000
	.long	0x10000000
	.long	0xff000000
	.long	0xf3000000
	.long	0xd2000000
	.long	0xcd000000
	.long	0x0c000000
	.long	0x13000000
	.long	0xec000000
	.long	0x5f000000
	.long	0x97000000
	.long	0x44000000
	.long	0x17000000
	.long	0xc4000000
	.long	0xa7000000
	.long	0x7e000000
	.long	0x3d000000
	.long	0x64000000
	.long	0x5d000000
	.long	0x19000000
	.long	0x73000000
	.long	0x60000000
	.long	0x81000000
	.long	0x4f000000
	.long	0xdc000000
	.long	0x22000000
	.long	0x2a000000
	.long	0x90000000
	.long	0x88000000
	.long	0x46000000
	.long	0xee000000
	.long	0xb8000000
	.long	0x14000000
	.long	0xde000000
	.long	0x5e000000
	.long	0x0b000000
	.long	0xdb000000
	.long	0xe0000000
	.long	0x32000000
	.long	0x3a000000
	.long	0x0a000000
	.long	0x49000000
	.long	0x06000000
	.long	0x24000000
	.long	0x5c000000
	.long	0xc2000000
	.long	0xd3000000
	.long	0xac000000
	.long	0x62000000
	.long	0x91000000
	.long	0x95000000
	.long	0xe4000000
	.long	0x79000000
	.long	0xe7000000
	.long	0xc8000000
	.long	0x37000000
	.long	0x6d000000
	.long	0x8d000000
	.long	0xd5000000
	.long	0x4e000000
	.long	0xa9000000
	.long	0x6c000000
	.long	0x56000000
	.long	0xf4000000
	.long	0xea000000
	.long	0x65000000
	.long	0x7a000000
	.long	0xae000000
	.long	0x08000000
	.long	0xba000000
	.long	0x78000000
	.long	0x25000000
	.long	0x2e000000
	.long	0x1c000000
	.long	0xa6000000
	.long	0xb4000000
	.long	0xc6000000
	.long	0xe8000000
	.long	0xdd000000
	.long	0x74000000
	.long	0x1f000000
	.long	0x4b000000
	.long	0xbd000000
	.long	0x8b000000
	.long	0x8a000000
	.long	0x70000000
	.long	0x3e000000
	.long	0xb5000000
	.long	0x66000000
	.long	0x48000000
	.long	0x03000000
	.long	0xf6000000
	.long	0x0e000000
	.long	0x61000000
	.long	0x35000000
	.long	0x57000000
	.long	0xb9000000
	.long	0x86000000
	.long	0xc1000000
	.long	0x1d000000
	.long	0x9e000000
	.long	0xe1000000
	.long	0xf8000000
	.long	0x98000000
	.long	0x11000000
	.long	0x69000000
	.long	0xd9000000
	.long	0x8e000000
	.long	0x94000000
	.long	0x9b000000
	.long	0x1e000000
	.long	0x87000000
	.long	0xe9000000
	.long	0xce000000
	.long	0x55000000
	.long	0x28000000
	.long	0xdf000000
	.long	0x8c000000
	.long	0xa1000000
	.long	0x89000000
	.long	0x0d000000
	.long	0xbf000000
	.long	0xe6000000
	.long	0x42000000
	.long	0x68000000
	.long	0x41000000
	.long	0x99000000
	.long	0x2d000000
	.long	0x0f000000
	.long	0xb0000000
	.long	0x54000000
	.long	0xbb000000
	.long	0x16000000
