/* Copyright (c) (2016-2019,2021) Apple Inc. All rights reserved.
*
* corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
* is contained in the License.txt file distributed with corecrypto) and only to
* people who accept that license. IMPORTANT:  Any license rights granted to you by
* Apple Inc. (if any) are limited to internal use within your organization only on
* devices and computers you own or control, for the sole purpose of verifying the
* security characteristics and correct functioning of the Apple Software.  You may
* not, directly or indirectly, redistribute the Apple Software or any portions thereof.
*/

/* Autogenerated file - Use scheme ccdh_gen_gp to regenerate */
#include "ccdh_internal.h"
#include <corecrypto/ccdh_gp.h>

static ccdh_gp_decl_static(768) _ccdh_gp_apple768 =
{
    .hp = {
        .n = ccn_nof(768),
        .bitlen = 768,
        .funcs = CCZP_FUNCS_DEFAULT
    },
    .p = {
        /* prime */
        CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff),CCN64_C(ec,14,ad,08,4d,0a,47,6d),
        CCN64_C(b7,99,6e,88,52,9b,1a,37),CCN64_C(cb,f6,08,fb,89,4c,72,97),
        CCN64_C(33,2d,de,fd,aa,e9,76,63),CCN64_C(bb,13,32,a7,10,44,f8,68),
        CCN64_C(55,2a,24,e1,69,ee,30,91),CCN64_C(66,c5,05,db,be,af,8d,dc),
        CCN64_C(94,61,9e,6e,28,fc,cd,a3),CCN64_C(d4,a0,df,17,fc,cd,b0,9a),
        CCN64_C(65,75,08,9b,a8,f8,37,3b),CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff)
    },
    .p0inv = (cc_unit)1U,
    .r2 = {
        /* r2 */
        CCN64_C(a7,5d,fd,8e,10,5b,6a,bf),CCN64_C(87,1a,09,bf,23,85,28,23),
        CCN64_C(27,99,d0,f1,79,b0,0f,8b),CCN64_C(b7,24,40,37,53,7f,5d,74),
        CCN64_C(cc,bd,13,3c,17,c0,af,7c),CCN64_C(15,1a,5c,aa,c4,50,41,bc),
        CCN64_C(07,9c,bb,5f,84,ac,49,37),CCN64_C(8f,ba,0f,4e,76,2f,da,fc),
        CCN64_C(42,4c,f5,2b,4d,38,c3,71),CCN64_C(31,33,54,f4,7a,ed,b1,fe),
        CCN64_C(3e,ae,79,c4,ae,a1,8b,1c),CCN64_C(cb,b4,79,6e,60,cc,a4,af)
    },
    .g = {
        /* g */
        CCN64_C(00,00,00,00,00,00,00,02),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .q = {
        /* q */
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .l = 160,
};

ccdh_const_gp_t ccdh_gp_apple768(void)
{
    return (ccdh_const_gp_t)&_ccdh_gp_apple768;
}
