/* Copyright (c) (2011,2015-2019,2021) Apple Inc. All rights reserved.
*
* corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
* is contained in the License.txt file distributed with corecrypto) and only to
* people who accept that license. IMPORTANT:  Any license rights granted to you by
* Apple Inc. (if any) are limited to internal use within your organization only on
* devices and computers you own or control, for the sole purpose of verifying the
* security characteristics and correct functioning of the Apple Software.  You may
* not, directly or indirectly, redistribute the Apple Software or any portions thereof.
*/

/* Autogenerated file - Use scheme ccdh_gen_gp to regenerate */
#include "ccdh_internal.h"
#include <corecrypto/ccdh_gp.h>

static ccdh_gp_decl_static(3072) _ccdh_gp_rfc3526group15 =
{
    .hp = {
        .n = ccn_nof(3072),
        .bitlen = 3072,
        .funcs = CCZP_FUNCS_DEFAULT
    },
    .p = {
        /* prime */
        CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff),CCN64_C(4b,82,d1,20,a9,3a,d2,ca),
        CCN64_C(43,db,5b,fc,e0,fd,10,8e),CCN64_C(08,e2,4f,a0,74,e5,ab,31),
        CCN64_C(77,09,88,c0,ba,d9,46,e2),CCN64_C(bb,e1,17,57,7a,61,5d,6c),
        CCN64_C(52,1f,2b,18,17,7b,20,0c),CCN64_C(d8,76,02,73,3e,c8,6a,64),
        CCN64_C(f1,2f,fa,06,d9,8a,08,64),CCN64_C(ce,e3,d2,26,1a,d2,ee,6b),
        CCN64_C(1e,8c,94,e0,4a,25,61,9d),CCN64_C(ab,f5,ae,8c,db,09,33,d7),
        CCN64_C(b3,97,0f,85,a6,e1,e4,c7),CCN64_C(8a,ea,71,57,5d,06,0c,7d),
        CCN64_C(ec,fb,85,04,58,db,ef,0a),CCN64_C(a8,55,21,ab,df,1c,ba,64),
        CCN64_C(ad,33,17,0d,04,50,7a,33),CCN64_C(15,72,8e,5a,8a,aa,c4,2d),
        CCN64_C(15,d2,26,18,98,fa,05,10),CCN64_C(39,95,49,7c,ea,95,6a,e5),
        CCN64_C(de,2b,cb,f6,95,58,17,18),CCN64_C(b5,c5,5d,f0,6f,4c,52,c9),
        CCN64_C(9b,27,83,a2,ec,07,a2,8f),CCN64_C(e3,9e,77,2c,18,0e,86,03),
        CCN64_C(32,90,5e,46,2e,36,ce,3b),CCN64_C(f1,74,6c,08,ca,18,21,7c),
        CCN64_C(67,0c,35,4e,4a,bc,98,04),CCN64_C(9e,d5,29,07,70,96,96,6d),
        CCN64_C(1c,62,f3,56,20,85,52,bb),CCN64_C(83,65,5d,23,dc,a3,ad,96),
        CCN64_C(69,16,3f,a8,fd,24,cf,5f),CCN64_C(98,da,48,36,1c,55,d3,9a),
        CCN64_C(c2,00,7c,b8,a1,63,bf,05),CCN64_C(49,28,66,51,ec,e4,5b,3d),
        CCN64_C(ae,9f,24,11,7c,4b,1f,e6),CCN64_C(ee,38,6b,fb,5a,89,9f,a5),
        CCN64_C(0b,ff,5c,b6,f4,06,b7,ed),CCN64_C(f4,4c,42,e9,a6,37,ed,6b),
        CCN64_C(e4,85,b5,76,62,5e,7e,c6),CCN64_C(4f,e1,35,6d,6d,51,c2,45),
        CCN64_C(30,2b,0a,6d,f2,5f,14,37),CCN64_C(ef,95,19,b3,cd,3a,43,1b),
        CCN64_C(51,4a,08,79,8e,34,04,dd),CCN64_C(02,0b,be,a6,3b,13,9b,22),
        CCN64_C(29,02,4e,08,8a,67,cc,74),CCN64_C(c4,c6,62,8b,80,dc,1c,d1),
        CCN64_C(c9,0f,da,a2,21,68,c2,34),CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff)
    },
    .p0inv = (cc_unit)1U,
    .r2 = {
        /* r2 */
        CCN64_C(26,97,ca,91,38,d2,41,cd),CCN64_C(35,87,f0,69,60,e7,f1,38),
        CCN64_C(4f,30,b9,20,e5,c1,db,66),CCN64_C(95,82,32,15,b1,5b,a5,77),
        CCN64_C(43,35,aa,cb,64,89,4d,96),CCN64_C(ae,12,84,02,3c,6e,d6,a3),
        CCN64_C(fc,11,87,a5,fa,84,06,ab),CCN64_C(68,2a,ab,9a,15,b1,7f,fa),
        CCN64_C(bc,2b,64,cf,26,e3,35,d7),CCN64_C(8a,a6,13,91,ab,b0,b7,6a),
        CCN64_C(1e,f2,25,71,e4,1a,52,b2),CCN64_C(1d,93,07,5a,a9,93,d1,47),
        CCN64_C(fe,a5,18,7f,a7,7d,ed,da),CCN64_C(af,80,d4,b5,44,35,61,c6),
        CCN64_C(b1,86,42,4b,83,df,28,59),CCN64_C(1c,ae,fc,18,8a,59,bc,7f),
        CCN64_C(1b,9d,01,27,1d,18,f0,c8),CCN64_C(3e,fe,f2,9d,c3,c0,b3,f4),
        CCN64_C(78,54,83,c6,08,10,8c,0c),CCN64_C(4f,12,76,82,56,e8,8b,53),
        CCN64_C(bf,d9,61,d5,38,d6,fc,dd),CCN64_C(b4,1a,05,f0,78,02,42,08),
        CCN64_C(19,cc,8d,59,56,37,06,fb),CCN64_C(5a,77,95,d8,6e,cc,49,87),
        CCN64_C(9a,67,8b,f4,43,9f,12,eb),CCN64_C(7c,da,50,2e,c0,43,f9,9c),
        CCN64_C(06,72,a3,3d,61,e3,7f,74),CCN64_C(19,c2,88,3e,ef,c8,02,af),
        CCN64_C(7d,ed,48,9e,67,0d,9c,6f),CCN64_C(a7,3d,01,03,2c,4b,8e,90),
        CCN64_C(8c,6c,bd,34,d5,96,51,34),CCN64_C(77,a5,c7,47,d8,5b,0a,83),
        CCN64_C(10,9d,09,9e,16,fd,75,68),CCN64_C(a5,da,f7,36,bc,8d,5e,9e),
        CCN64_C(71,39,d0,ab,24,b7,e4,95),CCN64_C(49,cd,9d,70,5d,a1,84,d5),
        CCN64_C(22,76,cb,40,57,1f,2c,1c),CCN64_C(af,0e,c4,5c,dc,39,60,86),
        CCN64_C(aa,05,da,05,c2,7f,dd,33),CCN64_C(98,75,d4,c1,67,db,7e,dc),
        CCN64_C(5c,aa,69,00,9f,bf,54,3f),CCN64_C(fa,02,23,36,f2,8d,e7,72),
        CCN64_C(fa,e1,cd,10,64,8b,ee,54),CCN64_C(2a,d4,79,fe,69,69,5c,75),
        CCN64_C(84,89,5a,7c,55,42,f9,6c),CCN64_C(a3,32,e8,e3,e0,66,9e,0f),
        CCN64_C(44,c4,e4,e4,31,ad,02,95),CCN64_C(5a,c8,b4,fb,51,df,35,da)
    },
    .g = {
        /* g */
        CCN64_C(00,00,00,00,00,00,00,02),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .q = {
        /* q */
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .l = 420,
};

ccdh_const_gp_t ccdh_gp_rfc3526group15(void)
{
    return (ccdh_const_gp_t)&_ccdh_gp_rfc3526group15;
}
