/* Copyright (c) (2011,2015-2019,2021) Apple Inc. All rights reserved.
*
* corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
* is contained in the License.txt file distributed with corecrypto) and only to
* people who accept that license. IMPORTANT:  Any license rights granted to you by
* Apple Inc. (if any) are limited to internal use within your organization only on
* devices and computers you own or control, for the sole purpose of verifying the
* security characteristics and correct functioning of the Apple Software.  You may
* not, directly or indirectly, redistribute the Apple Software or any portions thereof.
*/

/* Autogenerated file - Use scheme ccdh_gen_gp to regenerate */
#include "ccdh_internal.h"
#include <corecrypto/ccdh_gp.h>

static ccdh_gp_decl_static(8192) _ccdh_gp_rfc3526group18 =
{
    .hp = {
        .n = ccn_nof(8192),
        .bitlen = 8192,
        .funcs = CCZP_FUNCS_DEFAULT
    },
    .p = {
        /* prime */
        CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff),CCN64_C(60,c9,80,dd,98,ed,d3,df),
        CCN64_C(c8,1f,56,e8,80,b9,6e,71),CCN64_C(9e,30,50,e2,76,56,94,df),
        CCN64_C(95,58,e4,47,56,77,e9,aa),CCN64_C(c9,19,0d,a6,fc,02,6e,47),
        CCN64_C(88,9a,00,2e,d5,ee,38,2b),CCN64_C(40,09,43,8b,48,1c,6c,d7),
        CCN64_C(35,90,46,f4,eb,87,9f,92),CCN64_C(fa,f3,6b,c3,1e,cf,a2,68),
        CCN64_C(b1,d5,10,bd,7e,e7,4d,73),CCN64_C(f9,ab,48,19,5d,ed,7e,a1),
        CCN64_C(64,f3,1c,c5,08,46,85,1d),CCN64_C(45,97,e8,99,a0,25,5d,c1),
        CCN64_C(df,31,0e,e0,74,ab,6a,36),CCN64_C(6d,2a,13,f8,3f,44,f8,2d),
        CCN64_C(06,2b,3c,f5,b3,a2,78,a6),CCN64_C(79,68,33,03,ed,5b,dd,3a),
        CCN64_C(fa,9d,4b,7f,a2,c0,87,e8),CCN64_C(4b,cb,c8,86,2f,83,85,dd),
        CCN64_C(34,73,fc,64,6c,ea,30,6b),CCN64_C(13,eb,57,a8,1a,23,f0,c7),
        CCN64_C(22,22,2e,04,a4,03,7c,07),CCN64_C(e3,fd,b8,be,fc,84,8a,d9),
        CCN64_C(23,8f,16,cb,e3,9d,65,2d),CCN64_C(34,23,b4,74,2b,f1,c9,78),
        CCN64_C(3a,ab,63,9c,5a,e4,f5,68),CCN64_C(25,76,f6,93,6b,a4,24,66),
        CCN64_C(74,1f,a7,bf,8a,fc,47,ed),CCN64_C(3b,c8,32,b6,8d,9d,d3,00),
        CCN64_C(d8,be,c4,d0,73,b9,31,ba),CCN64_C(38,77,7c,b6,a9,32,df,8c),
        CCN64_C(74,a3,92,6f,12,fe,e5,e4),CCN64_C(e6,94,f9,1e,6d,be,11,59),
        CCN64_C(12,bf,2d,5b,0b,74,74,d6),CCN64_C(04,3e,8f,66,3f,48,60,ee),
        CCN64_C(38,7f,e8,d7,6e,3c,04,68),CCN64_C(da,56,c9,ec,2e,f2,96,32),
        CCN64_C(eb,19,cc,b1,a3,13,d5,5c),CCN64_C(f5,50,aa,3d,8a,1f,bf,f0),
        CCN64_C(06,a1,d5,8b,b7,c5,da,76),CCN64_C(a7,97,15,ee,f2,9b,e3,28),
        CCN64_C(14,cc,5e,d2,0f,80,37,e0),CCN64_C(cc,8f,6d,7e,bf,48,e1,d8),
        CCN64_C(4b,d4,07,b2,2b,41,54,aa),CCN64_C(0f,1d,45,b7,ff,58,5a,c5),
        CCN64_C(23,a9,7a,7e,36,cc,88,be),CCN64_C(59,e7,c9,7f,be,c7,e8,f3),
        CCN64_C(b5,a8,40,31,90,0b,1c,9e),CCN64_C(d5,5e,70,2f,46,98,0c,82),
        CCN64_C(f4,82,d7,ce,6e,74,fe,f6),CCN64_C(f0,32,ea,15,d1,72,1d,03),
        CCN64_C(59,83,ca,01,c6,4b,92,ec),CCN64_C(6f,b8,f4,01,37,8c,d2,bf),
        CCN64_C(33,20,51,51,2b,d7,af,42),CCN64_C(db,7f,14,47,e6,cc,25,4b),
        CCN64_C(44,ce,6c,ba,ce,d4,bb,1b),CCN64_C(da,3e,db,eb,cf,9b,14,ed),
        CCN64_C(17,97,27,b0,86,5a,89,18),CCN64_C(b0,6a,53,ed,90,27,d8,31),
        CCN64_C(e5,db,38,2f,41,30,01,ae),CCN64_C(f8,ff,94,06,ad,9e,53,0e),
        CCN64_C(c9,75,1e,76,3d,ba,37,bd),CCN64_C(c1,d4,dc,b2,60,26,46,de),
        CCN64_C(36,c3,fa,b4,d2,7c,70,26),CCN64_C(4d,f4,35,c9,34,02,84,92),
        CCN64_C(86,ff,b7,dc,90,a6,c0,8f),CCN64_C(93,b4,ea,98,8d,8f,dd,c1),
        CCN64_C(d0,06,91,27,d5,b0,5a,a9),CCN64_C(b8,1b,dd,76,21,70,48,1c),
        CCN64_C(1f,61,29,70,ce,e2,d7,af),CCN64_C(23,3b,a1,86,51,5b,e7,ed),
        CCN64_C(99,b2,96,4f,a0,90,c3,a2),CCN64_C(28,7c,59,47,4e,6b,c0,5d),
        CCN64_C(2e,8e,fc,14,1f,be,ca,a6),CCN64_C(db,bb,c2,db,04,de,8e,f9),
        CCN64_C(25,83,e9,ca,2a,d4,4c,e8),CCN64_C(1a,94,68,34,b6,15,0b,da),
        CCN64_C(99,c3,27,18,6a,f4,e2,3c),CCN64_C(88,71,9a,10,bd,ba,5b,26),
        CCN64_C(1a,72,3c,12,a7,87,e6,d7),CCN64_C(4b,82,d1,20,a9,21,08,01),
        CCN64_C(43,db,5b,fc,e0,fd,10,8e),CCN64_C(08,e2,4f,a0,74,e5,ab,31),
        CCN64_C(77,09,88,c0,ba,d9,46,e2),CCN64_C(bb,e1,17,57,7a,61,5d,6c),
        CCN64_C(52,1f,2b,18,17,7b,20,0c),CCN64_C(d8,76,02,73,3e,c8,6a,64),
        CCN64_C(f1,2f,fa,06,d9,8a,08,64),CCN64_C(ce,e3,d2,26,1a,d2,ee,6b),
        CCN64_C(1e,8c,94,e0,4a,25,61,9d),CCN64_C(ab,f5,ae,8c,db,09,33,d7),
        CCN64_C(b3,97,0f,85,a6,e1,e4,c7),CCN64_C(8a,ea,71,57,5d,06,0c,7d),
        CCN64_C(ec,fb,85,04,58,db,ef,0a),CCN64_C(a8,55,21,ab,df,1c,ba,64),
        CCN64_C(ad,33,17,0d,04,50,7a,33),CCN64_C(15,72,8e,5a,8a,aa,c4,2d),
        CCN64_C(15,d2,26,18,98,fa,05,10),CCN64_C(39,95,49,7c,ea,95,6a,e5),
        CCN64_C(de,2b,cb,f6,95,58,17,18),CCN64_C(b5,c5,5d,f0,6f,4c,52,c9),
        CCN64_C(9b,27,83,a2,ec,07,a2,8f),CCN64_C(e3,9e,77,2c,18,0e,86,03),
        CCN64_C(32,90,5e,46,2e,36,ce,3b),CCN64_C(f1,74,6c,08,ca,18,21,7c),
        CCN64_C(67,0c,35,4e,4a,bc,98,04),CCN64_C(9e,d5,29,07,70,96,96,6d),
        CCN64_C(1c,62,f3,56,20,85,52,bb),CCN64_C(83,65,5d,23,dc,a3,ad,96),
        CCN64_C(69,16,3f,a8,fd,24,cf,5f),CCN64_C(98,da,48,36,1c,55,d3,9a),
        CCN64_C(c2,00,7c,b8,a1,63,bf,05),CCN64_C(49,28,66,51,ec,e4,5b,3d),
        CCN64_C(ae,9f,24,11,7c,4b,1f,e6),CCN64_C(ee,38,6b,fb,5a,89,9f,a5),
        CCN64_C(0b,ff,5c,b6,f4,06,b7,ed),CCN64_C(f4,4c,42,e9,a6,37,ed,6b),
        CCN64_C(e4,85,b5,76,62,5e,7e,c6),CCN64_C(4f,e1,35,6d,6d,51,c2,45),
        CCN64_C(30,2b,0a,6d,f2,5f,14,37),CCN64_C(ef,95,19,b3,cd,3a,43,1b),
        CCN64_C(51,4a,08,79,8e,34,04,dd),CCN64_C(02,0b,be,a6,3b,13,9b,22),
        CCN64_C(29,02,4e,08,8a,67,cc,74),CCN64_C(c4,c6,62,8b,80,dc,1c,d1),
        CCN64_C(c9,0f,da,a2,21,68,c2,34),CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff)
    },
    .p0inv = (cc_unit)1U,
    .r2 = {
        /* r2 */
        CCN64_C(08,9a,fc,52,a9,ca,fe,e8),CCN64_C(21,c0,90,d2,5e,13,96,0f),
        CCN64_C(81,1c,7f,d7,55,a9,28,f1),CCN64_C(fe,05,c9,f1,88,e7,86,c2),
        CCN64_C(a0,09,b6,31,2f,6c,23,50),CCN64_C(f0,a0,e2,5b,2a,3a,14,f3),
        CCN64_C(7a,20,a5,2c,b0,63,ad,98),CCN64_C(d7,ff,43,4f,f4,92,65,60),
        CCN64_C(92,32,f9,fd,50,0f,ed,c5),CCN64_C(7d,97,d4,c4,31,8f,22,e7),
        CCN64_C(af,a4,ca,86,54,7d,05,7b),CCN64_C(f2,8f,54,77,c0,86,52,1e),
        CCN64_C(26,e1,ae,2d,49,a5,2e,3f),CCN64_C(f8,e0,f2,7e,32,f7,ca,b7),
        CCN64_C(d6,8c,1f,bc,17,30,4e,6f),CCN64_C(c5,d0,51,c4,f6,59,12,9f),
        CCN64_C(89,0d,f1,30,78,a4,15,be),CCN64_C(5f,0d,55,7d,21,c0,79,aa),
        CCN64_C(37,0b,c4,a2,cd,ea,6a,14),CCN64_C(41,1c,e8,14,91,60,80,9d),
        CCN64_C(f2,cc,7f,a9,4b,8f,23,ca),CCN64_C(25,e8,a7,a9,18,19,10,c0),
        CCN64_C(86,e7,b9,83,86,cc,b4,43),CCN64_C(e3,92,2d,99,4b,ec,45,27),
        CCN64_C(2d,71,54,1a,00,73,2d,c5),CCN64_C(8a,9b,ba,0c,31,dd,9d,27),
        CCN64_C(5f,eb,69,0f,70,58,d9,13),CCN64_C(04,03,98,57,b2,89,39,f6),
        CCN64_C(58,7b,56,b7,30,46,4b,28),CCN64_C(78,4e,cb,a5,02,ab,7b,0c),
        CCN64_C(47,52,18,5f,9a,9b,f0,3a),CCN64_C(e2,38,51,a7,d6,a8,72,0a),
        CCN64_C(2a,38,4f,7c,10,10,18,6a),CCN64_C(e3,6f,75,2b,91,6b,d4,32),
        CCN64_C(85,1c,4b,6c,83,0a,e8,c3),CCN64_C(34,a0,63,b9,01,53,26,57),
        CCN64_C(71,fa,c8,62,b3,b8,81,3d),CCN64_C(9e,ce,3f,f2,16,a2,27,43),
        CCN64_C(5f,60,07,82,50,3c,2e,ec),CCN64_C(bf,60,df,70,0a,08,c5,ff),
        CCN64_C(e4,88,85,20,d6,0d,34,34),CCN64_C(66,70,64,b0,f5,c5,64,c3),
        CCN64_C(cd,62,2a,64,06,43,98,6e),CCN64_C(81,d1,a6,ab,c0,8e,41,a1),
        CCN64_C(42,30,45,8a,a6,54,47,06),CCN64_C(da,b4,6b,50,11,6b,ba,c4),
        CCN64_C(46,5f,63,57,32,88,68,72),CCN64_C(85,af,e3,99,30,f5,b7,fa),
        CCN64_C(7c,46,ef,97,4d,01,0c,90),CCN64_C(c7,66,37,b4,f7,19,bd,82),
        CCN64_C(26,99,d4,8d,fa,da,8a,6d),CCN64_C(fa,62,3e,65,d4,45,a3,ad),
        CCN64_C(bd,d0,df,25,07,fe,f8,d0),CCN64_C(db,6b,19,da,34,c8,a4,97),
        CCN64_C(ce,80,5b,29,a2,e2,d6,e9),CCN64_C(db,0e,ae,68,15,28,0f,d6),
        CCN64_C(cc,da,eb,d4,4a,fe,d4,6e),CCN64_C(37,f2,4c,5c,b4,e4,a5,ac),
        CCN64_C(08,43,26,c7,65,9b,f9,3f),CCN64_C(5d,6e,12,fb,db,a7,03,6a),
        CCN64_C(49,c2,df,dc,77,01,46,4d),CCN64_C(97,ed,23,c9,56,11,2d,ab),
        CCN64_C(27,99,37,2d,28,2f,2d,b1),CCN64_C(82,75,f3,0d,0d,04,b7,03),
        CCN64_C(28,80,69,20,70,cd,ae,86),CCN64_C(c6,d4,d3,3f,4f,ae,b6,6c),
        CCN64_C(f1,21,14,36,0d,32,7f,15),CCN64_C(ca,93,6a,f4,72,5f,0d,47),
        CCN64_C(9f,cd,11,61,08,6c,11,ff),CCN64_C(86,05,6c,c4,0f,bb,c4,43),
        CCN64_C(56,91,a8,14,73,d8,a6,15),CCN64_C(f5,56,39,44,14,aa,a6,68),
        CCN64_C(d8,bd,35,36,9c,d1,d2,86),CCN64_C(3a,87,7f,c4,2f,a1,b2,d7),
        CCN64_C(3e,65,70,1c,b4,44,78,e0),CCN64_C(c9,52,46,09,4b,31,8f,fb),
        CCN64_C(c0,69,55,df,9b,15,d7,c1),CCN64_C(be,97,48,dd,7b,85,7f,b7),
        CCN64_C(05,1c,a4,4e,be,1c,6c,a1),CCN64_C(c8,46,0f,b0,b8,a8,d9,d0),
        CCN64_C(19,fa,98,cf,e7,ff,4c,de),CCN64_C(4a,fd,21,46,85,94,26,b2),
        CCN64_C(27,99,28,69,dd,0d,bb,1d),CCN64_C(01,50,0b,71,4f,b8,b2,9a),
        CCN64_C(0b,13,a2,f4,1f,7f,7e,d6),CCN64_C(95,fb,f7,c0,71,73,ae,50),
        CCN64_C(b8,fb,ea,a1,23,3e,25,22),CCN64_C(31,df,70,6d,0c,e4,8e,20),
        CCN64_C(b7,4e,1a,92,00,2e,1f,01),CCN64_C(13,d9,9e,a0,2d,4d,bc,93),
        CCN64_C(34,e4,0f,b8,e3,06,37,1e),CCN64_C(66,6b,5e,04,2d,32,96,4f),
        CCN64_C(b5,6e,af,cf,4b,8a,1c,87),CCN64_C(ee,5f,8e,38,3e,99,bb,13),
        CCN64_C(95,5b,00,c2,4b,8e,23,9d),CCN64_C(59,68,7c,a0,7d,2b,6a,60),
        CCN64_C(f6,bb,ad,53,49,67,43,86),CCN64_C(2e,32,c1,3e,b8,70,dd,ba),
        CCN64_C(8f,7a,fb,0c,79,5a,5c,db),CCN64_C(ac,26,53,33,28,39,e6,2f),
        CCN64_C(e3,0e,c9,6d,72,0c,3d,0f),CCN64_C(02,87,b9,53,ab,ae,39,d0),
        CCN64_C(ae,67,3d,b7,c9,cd,44,d5),CCN64_C(b6,b1,1d,9a,a1,9b,ca,87),
        CCN64_C(4d,be,19,e7,9d,dc,a0,fb),CCN64_C(93,50,af,30,b2,8f,ed,61),
        CCN64_C(73,ba,3a,6c,1d,91,7d,22),CCN64_C(48,61,6a,55,4f,77,7c,61),
        CCN64_C(23,a5,67,c5,6e,31,44,6e),CCN64_C(ce,05,a8,47,f7,12,29,bf),
        CCN64_C(29,c1,10,6e,fe,ac,64,0a),CCN64_C(ae,ca,66,bf,c9,71,28,77),
        CCN64_C(17,2b,17,6e,19,38,f7,e9),CCN64_C(6a,87,4b,1f,32,fc,c6,09),
        CCN64_C(2c,77,47,fc,1f,d5,67,a4),CCN64_C(45,e8,79,b2,2f,f7,80,c7),
        CCN64_C(e0,83,8c,36,6a,15,29,d8),CCN64_C(52,79,83,23,3d,ab,0b,78),
        CCN64_C(ae,67,98,47,79,1b,04,76),CCN64_C(cc,f3,68,2a,86,5d,28,b1),
        CCN64_C(90,bb,82,d9,3e,22,21,08),CCN64_C(d2,ff,cb,a7,f9,88,e4,9e),
        CCN64_C(53,f2,92,f6,78,3e,7d,7e),CCN64_C(f0,67,59,97,ac,e4,a1,d2),
        CCN64_C(72,44,d8,00,46,f0,e3,0a),CCN64_C(41,3e,ed,4f,de,6c,40,7d),
        CCN64_C(e4,cb,da,86,c3,b8,66,84),CCN64_C(16,d2,e4,aa,74,33,fd,52)
    },
    .g = {
        /* g */
        CCN64_C(00,00,00,00,00,00,00,02),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .q = {
        /* q */
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .l = 620,
};

ccdh_const_gp_t ccdh_gp_rfc3526group18(void)
{
    return (ccdh_const_gp_t)&_ccdh_gp_rfc3526group18;
}
