/* Copyright (c) (2011,2015-2019,2021) Apple Inc. All rights reserved.
*
* corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
* is contained in the License.txt file distributed with corecrypto) and only to
* people who accept that license. IMPORTANT:  Any license rights granted to you by
* Apple Inc. (if any) are limited to internal use within your organization only on
* devices and computers you own or control, for the sole purpose of verifying the
* security characteristics and correct functioning of the Apple Software.  You may
* not, directly or indirectly, redistribute the Apple Software or any portions thereof.
*/

/* Autogenerated file - Use scheme ccdh_gen_gp to regenerate */
#include "ccdh_internal.h"
#include <corecrypto/ccdh_gp.h>

static ccdh_gp_decl_static(1024) _ccdh_gp_rfc5114_MODP_1024_160 =
{
    .hp = {
        .n = ccn_nof(1024),
        .bitlen = 1024,
        .funcs = CCZP_FUNCS_DEFAULT
    },
    .p = {
        /* prime */
        CCN64_C(df,1f,b2,bc,2e,4a,43,71),CCN64_C(e6,8c,fd,a7,6d,4d,a7,08),
        CCN64_C(45,bf,37,df,36,5c,1a,65),CCN64_C(a1,51,af,5f,0d,c8,b4,bd),
        CCN64_C(fa,a3,1a,4f,f5,5b,cc,c0),CCN64_C(4e,ff,d6,fa,e5,64,47,38),
        CCN64_C(98,48,8e,9c,21,9a,73,72),CCN64_C(ac,cb,dd,7d,90,c4,bd,70),
        CCN64_C(24,97,5c,3c,d4,9b,83,bf),CCN64_C(13,ec,b4,ae,a9,06,11,23),
        CCN64_C(98,38,ef,1e,2e,e6,52,c0),CCN64_C(60,73,e2,86,75,a2,3d,18),
        CCN64_C(9a,6a,9d,ca,52,d2,3b,61),CCN64_C(52,c9,9f,bc,fb,06,a3,c6),
        CCN64_C(de,92,de,5e,ae,5d,54,ec),CCN64_C(b1,0b,8f,96,a0,80,e0,1d)
    },
    .p0inv = (cc_unit)8498437842751709807U,
    .r2 = {
        /* r2 */
        CCN64_C(c8,58,a5,23,74,aa,53,19),CCN64_C(e8,96,da,d3,b7,60,6c,c5),
        CCN64_C(c8,1f,66,fb,c4,6c,ff,7c),CCN64_C(88,a4,e1,b0,38,88,60,2d),
        CCN64_C(58,e1,33,b0,01,a1,32,5d),CCN64_C(88,91,3e,20,ee,24,e0,6c),
        CCN64_C(56,91,60,e0,db,52,6d,c0),CCN64_C(aa,2e,e8,4b,c6,75,10,9f),
        CCN64_C(bb,f7,24,b4,ea,07,36,ad),CCN64_C(b6,a3,bb,99,4d,bd,7c,a7),
        CCN64_C(6c,a2,18,41,ba,19,88,11),CCN64_C(d6,69,f2,24,e3,93,9e,0c),
        CCN64_C(c4,56,f4,36,3a,bd,32,e2),CCN64_C(8f,62,49,9e,d1,80,62,af),
        CCN64_C(63,1d,f2,a3,ab,9f,57,c1),CCN64_C(a6,a2,4d,2d,93,59,aa,23)
    },
    .g = {
        /* g */
        CCN64_C(85,5e,6e,eb,22,b3,b2,e5),CCN64_C(85,8f,4d,ce,f9,7c,2a,24),
        CCN64_C(2d,77,9d,59,18,d0,8b,c8),CCN64_C(d6,62,a4,d1,8e,73,af,a3),
        CCN64_C(1d,bf,0a,01,69,b6,a2,8a),CCN64_C(a6,a2,4c,08,7a,09,1f,53),
        CCN64_C(90,9d,0d,22,63,f8,0a,76),CCN64_C(d7,fb,d7,d3,b9,a9,2e,e1),
        CCN64_C(5e,91,54,7f,9e,27,49,f4),CCN64_C(16,02,17,b4,b0,1b,88,6a),
        CCN64_C(77,7e,69,0f,55,04,f2,13),CCN64_C(26,6f,ea,1e,5c,41,56,4b),
        CCN64_C(d6,40,6c,ff,14,26,6d,31),CCN64_C(f8,10,4d,d2,58,ac,50,7f),
        CCN64_C(67,65,a4,42,ef,b9,99,05),CCN64_C(a4,d1,cb,d5,c3,fd,34,12)
    },
    .q = {
        /* q */
        CCN64_C(64,b7,cb,9d,49,46,23,53),CCN64_C(81,a8,df,27,8a,ba,4e,7d),
        CCN64_C(00,00,00,00,f5,18,aa,87),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .l = 0,
};

ccdh_const_gp_t ccdh_gp_rfc5114_MODP_1024_160(void)
{
    return (ccdh_const_gp_t)&_ccdh_gp_rfc5114_MODP_1024_160;
}
