/* Copyright (c) (2011,2015-2019,2021) Apple Inc. All rights reserved.
*
* corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
* is contained in the License.txt file distributed with corecrypto) and only to
* people who accept that license. IMPORTANT:  Any license rights granted to you by
* Apple Inc. (if any) are limited to internal use within your organization only on
* devices and computers you own or control, for the sole purpose of verifying the
* security characteristics and correct functioning of the Apple Software.  You may
* not, directly or indirectly, redistribute the Apple Software or any portions thereof.
*/

/* Autogenerated file - Use scheme ccdh_gen_gp to regenerate */
#include "ccdh_internal.h"
#include <corecrypto/ccdh_gp.h>

static ccdh_gp_decl_static(2048) _ccdh_gp_rfc5114_MODP_2048_224 =
{
    .hp = {
        .n = ccn_nof(2048),
        .bitlen = 2048,
        .funcs = CCZP_FUNCS_DEFAULT
    },
    .p = {
        /* prime */
        CCN64_C(0a,c4,df,fe,0c,10,e6,4f),CCN64_C(cf,9d,e5,38,4e,71,b8,1c),
        CCN64_C(7e,f3,63,e2,ff,a3,1f,71),CCN64_C(e3,fb,73,c1,6b,8e,75,b9),
        CCN64_C(c9,b5,3d,cf,4b,a8,0a,29),CCN64_C(23,f1,0b,0e,16,e7,97,63),
        CCN64_C(c5,21,72,e4,13,04,2e,9b),CCN64_C(be,60,e6,9c,c9,28,b2,b9),
        CCN64_C(80,cd,86,a1,b9,e5,87,e8),CCN64_C(31,5d,75,e1,98,c6,41,a4),
        CCN64_C(cd,f9,3a,cc,44,32,83,87),CCN64_C(15,98,7d,9a,dc,0a,48,6d),
        CCN64_C(73,10,f7,12,1f,d5,a0,74),CCN64_C(27,82,73,c7,de,31,ef,dc),
        CCN64_C(16,02,e7,14,41,5d,93,30),CCN64_C(81,28,61,30,bc,89,85,db),
        CCN64_C(b3,bf,8a,31,70,91,88,36),CCN64_C(6a,00,e0,a0,b9,c4,97,08),
        CCN64_C(c6,ba,0b,2c,8b,bc,27,be),CCN64_C(c9,f9,8d,11,ed,34,db,f6),
        CCN64_C(7a,d5,b7,d0,b6,c1,22,07),CCN64_C(d9,1e,8f,ef,55,b7,39,4b),
        CCN64_C(90,37,c9,ed,ef,da,4d,f8),CCN64_C(6d,3f,81,52,ad,6a,c2,12),
        CCN64_C(1d,e6,b8,5a,12,74,a0,a6),CCN64_C(eb,3d,68,8a,30,9c,18,0e),
        CCN64_C(af,9a,3c,40,7b,a1,df,15),CCN64_C(e6,fa,14,1d,f9,5a,56,db),
        CCN64_C(b5,4b,15,97,b6,1d,0a,75),CCN64_C(a2,0d,64,e5,68,3b,9f,d1),
        CCN64_C(d6,60,fa,a7,95,59,c5,1f),CCN64_C(ad,10,7e,1e,91,23,a9,d0)
    },
    .p0inv = (cc_unit)14605616773445160785U,
    .r2 = {
        /* r2 */
        CCN64_C(3b,b4,8b,69,2e,c2,bd,6b),CCN64_C(44,c7,34,b8,43,83,65,29),
        CCN64_C(2b,52,25,29,d8,c6,71,aa),CCN64_C(1b,1c,6b,bc,fe,7d,0a,78),
        CCN64_C(f3,55,42,d9,cf,4c,e6,40),CCN64_C(3a,db,12,5b,7f,8c,85,9c),
        CCN64_C(2f,e7,4e,bd,e7,6d,cc,8f),CCN64_C(78,2b,7d,91,f0,0e,dc,9a),
        CCN64_C(98,3d,71,a4,bf,74,62,99),CCN64_C(fc,d6,5f,0e,e0,b8,f7,80),
        CCN64_C(0e,59,df,3e,a9,86,61,1d),CCN64_C(ed,a9,13,b2,36,bb,3c,fa),
        CCN64_C(09,6f,63,67,25,af,ae,57),CCN64_C(1f,0d,d8,7c,4f,1f,69,d4),
        CCN64_C(f3,26,17,6d,f6,c2,23,c3),CCN64_C(34,2e,a7,d4,60,c9,e8,a5),
        CCN64_C(61,3c,18,87,70,3f,2f,11),CCN64_C(4d,0b,5e,bc,60,54,02,4f),
        CCN64_C(43,29,76,4c,d3,b6,69,4a),CCN64_C(8a,9b,8c,76,d8,4e,86,c1),
        CCN64_C(36,85,8f,c9,ed,c7,6b,42),CCN64_C(3f,46,2a,f2,64,7c,04,52),
        CCN64_C(35,e4,7d,0c,58,ec,b8,d4),CCN64_C(8c,87,3d,52,eb,59,e6,16),
        CCN64_C(66,b2,55,57,03,ae,ab,8d),CCN64_C(3b,f4,32,96,cd,27,8a,9d),
        CCN64_C(7d,04,e4,c9,6d,86,b7,a2),CCN64_C(32,a3,d5,f2,92,7b,a6,30),
        CCN64_C(d5,52,f3,6a,16,00,80,64),CCN64_C(f9,4d,cf,8d,59,e8,48,17),
        CCN64_C(0c,ba,f2,cd,c1,49,de,ad),CCN64_C(9c,d7,f3,20,de,5c,80,27)
    },
    .g = {
        /* g */
        CCN64_C(84,b8,90,d3,19,1f,2b,fa),CCN64_C(81,bc,08,7f,2a,70,65,b3),
        CCN64_C(19,c4,18,e1,f6,ec,01,79),CCN64_C(7b,5a,0f,1c,71,cf,ff,4c),
        CCN64_C(ed,fe,72,fe,9b,6a,a4,bd),CCN64_C(81,e1,bc,fe,94,b3,02,69),
        CCN64_C(56,6a,fb,b4,8d,6c,01,91),CCN64_C(b5,39,cc,e3,40,9d,13,cd),
        CCN64_C(6a,a2,1e,7f,5f,2f,f3,81),CCN64_C(d9,e2,63,e4,77,05,89,ef),
        CCN64_C(10,e1,83,ed,d1,99,63,dd),CCN64_C(b7,0a,81,37,15,0b,8e,eb),
        CCN64_C(05,1a,e3,d4,28,c8,f8,ac),CCN64_C(bb,77,a8,6f,0c,1a,b1,5b),
        CCN64_C(6e,30,25,e3,16,a3,30,ef),CCN64_C(19,52,9a,45,d6,f8,34,56),
        CCN64_C(f1,80,eb,34,11,8e,98,d1),CCN64_C(b5,f6,c6,b2,50,71,7c,be),
        CCN64_C(09,93,9d,54,da,74,60,cd),CCN64_C(e2,47,15,04,22,ea,1e,d4),
        CCN64_C(b8,a7,62,d0,52,1b,c9,8a),CCN64_C(f4,d0,27,27,5a,c1,34,8b),
        CCN64_C(c1,76,69,10,19,99,02,4a),CCN64_C(be,5e,90,01,a8,d6,6a,d7),
        CCN64_C(c5,7d,b1,7c,62,0a,86,52),CCN64_C(ab,73,9d,77,00,c2,9f,52),
        CCN64_C(dd,92,1f,01,a7,0c,4a,fa),CCN64_C(a6,82,4a,4e,10,b9,a6,f0),
        CCN64_C(74,86,6a,08,cf,e4,ff,e3),CCN64_C(6c,de,be,7b,89,99,8c,af),
        CCN64_C(9d,f3,0b,5c,8f,fd,ac,50),CCN64_C(ac,40,32,ef,4f,2d,9a,e3)
    },
    .q = {
        /* q */
        CCN64_C(bf,38,9a,99,b3,63,71,eb),CCN64_C(1f,80,53,5a,47,38,ce,bc),
        CCN64_C(c5,8d,93,fe,99,71,77,10),CCN64_C(00,00,00,00,80,1c,0d,34),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .l = 0,
};

ccdh_const_gp_t ccdh_gp_rfc5114_MODP_2048_224(void)
{
    return (ccdh_const_gp_t)&_ccdh_gp_rfc5114_MODP_2048_224;
}
