/* Copyright (c) (2011,2012,2015-2019,2021) Apple Inc. All rights reserved.
*
* corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
* is contained in the License.txt file distributed with corecrypto) and only to
* people who accept that license. IMPORTANT:  Any license rights granted to you by
* Apple Inc. (if any) are limited to internal use within your organization only on
* devices and computers you own or control, for the sole purpose of verifying the
* security characteristics and correct functioning of the Apple Software.  You may
* not, directly or indirectly, redistribute the Apple Software or any portions thereof.
*/

/* Autogenerated file - Use scheme ccdh_gen_gp to regenerate */
#include "ccdh_internal.h"
#include <corecrypto/ccsrp_gp.h>

static ccdh_gp_decl_static(4096) _ccsrp_gp_rfc5054_4096 =
{
    .hp = {
        .n = ccn_nof(4096),
        .bitlen = 4096,
        .funcs = CCZP_FUNCS_DEFAULT
    },
    .p = {
        /* prime */
        CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff),CCN64_C(4d,f4,35,c9,34,06,31,99),
        CCN64_C(86,ff,b7,dc,90,a6,c0,8f),CCN64_C(93,b4,ea,98,8d,8f,dd,c1),
        CCN64_C(d0,06,91,27,d5,b0,5a,a9),CCN64_C(b8,1b,dd,76,21,70,48,1c),
        CCN64_C(1f,61,29,70,ce,e2,d7,af),CCN64_C(23,3b,a1,86,51,5b,e7,ed),
        CCN64_C(99,b2,96,4f,a0,90,c3,a2),CCN64_C(28,7c,59,47,4e,6b,c0,5d),
        CCN64_C(2e,8e,fc,14,1f,be,ca,a6),CCN64_C(db,bb,c2,db,04,de,8e,f9),
        CCN64_C(25,83,e9,ca,2a,d4,4c,e8),CCN64_C(1a,94,68,34,b6,15,0b,da),
        CCN64_C(99,c3,27,18,6a,f4,e2,3c),CCN64_C(88,71,9a,10,bd,ba,5b,26),
        CCN64_C(1a,72,3c,12,a7,87,e6,d7),CCN64_C(4b,82,d1,20,a9,21,08,01),
        CCN64_C(43,db,5b,fc,e0,fd,10,8e),CCN64_C(08,e2,4f,a0,74,e5,ab,31),
        CCN64_C(77,09,88,c0,ba,d9,46,e2),CCN64_C(bb,e1,17,57,7a,61,5d,6c),
        CCN64_C(52,1f,2b,18,17,7b,20,0c),CCN64_C(d8,76,02,73,3e,c8,6a,64),
        CCN64_C(f1,2f,fa,06,d9,8a,08,64),CCN64_C(ce,e3,d2,26,1a,d2,ee,6b),
        CCN64_C(1e,8c,94,e0,4a,25,61,9d),CCN64_C(ab,f5,ae,8c,db,09,33,d7),
        CCN64_C(b3,97,0f,85,a6,e1,e4,c7),CCN64_C(8a,ea,71,57,5d,06,0c,7d),
        CCN64_C(ec,fb,85,04,58,db,ef,0a),CCN64_C(a8,55,21,ab,df,1c,ba,64),
        CCN64_C(ad,33,17,0d,04,50,7a,33),CCN64_C(15,72,8e,5a,8a,aa,c4,2d),
        CCN64_C(15,d2,26,18,98,fa,05,10),CCN64_C(39,95,49,7c,ea,95,6a,e5),
        CCN64_C(de,2b,cb,f6,95,58,17,18),CCN64_C(b5,c5,5d,f0,6f,4c,52,c9),
        CCN64_C(9b,27,83,a2,ec,07,a2,8f),CCN64_C(e3,9e,77,2c,18,0e,86,03),
        CCN64_C(32,90,5e,46,2e,36,ce,3b),CCN64_C(f1,74,6c,08,ca,18,21,7c),
        CCN64_C(67,0c,35,4e,4a,bc,98,04),CCN64_C(9e,d5,29,07,70,96,96,6d),
        CCN64_C(1c,62,f3,56,20,85,52,bb),CCN64_C(83,65,5d,23,dc,a3,ad,96),
        CCN64_C(69,16,3f,a8,fd,24,cf,5f),CCN64_C(98,da,48,36,1c,55,d3,9a),
        CCN64_C(c2,00,7c,b8,a1,63,bf,05),CCN64_C(49,28,66,51,ec,e4,5b,3d),
        CCN64_C(ae,9f,24,11,7c,4b,1f,e6),CCN64_C(ee,38,6b,fb,5a,89,9f,a5),
        CCN64_C(0b,ff,5c,b6,f4,06,b7,ed),CCN64_C(f4,4c,42,e9,a6,37,ed,6b),
        CCN64_C(e4,85,b5,76,62,5e,7e,c6),CCN64_C(4f,e1,35,6d,6d,51,c2,45),
        CCN64_C(30,2b,0a,6d,f2,5f,14,37),CCN64_C(ef,95,19,b3,cd,3a,43,1b),
        CCN64_C(51,4a,08,79,8e,34,04,dd),CCN64_C(02,0b,be,a6,3b,13,9b,22),
        CCN64_C(29,02,4e,08,8a,67,cc,74),CCN64_C(c4,c6,62,8b,80,dc,1c,d1),
        CCN64_C(c9,0f,da,a2,21,68,c2,34),CCN64_C(ff,ff,ff,ff,ff,ff,ff,ff)
    },
    .p0inv = (cc_unit)1U,
    .r2 = {
        /* r2 */
        CCN64_C(c1,4a,b0,dd,cc,03,aa,20),CCN64_C(8a,1a,c0,24,b3,0e,9b,12),
        CCN64_C(fa,8f,75,f0,06,7e,82,b1),CCN64_C(37,bf,90,fe,52,07,4f,19),
        CCN64_C(55,ea,6f,75,41,c4,f8,2b),CCN64_C(b8,50,de,95,d9,7a,c4,0a),
        CCN64_C(35,49,c5,77,7a,17,fb,04),CCN64_C(2a,43,4c,eb,23,0b,2d,fe),
        CCN64_C(52,4e,7c,7a,7e,d3,6c,41),CCN64_C(e4,40,40,92,1c,1e,46,7c),
        CCN64_C(a7,96,d1,82,04,a6,36,f7),CCN64_C(c9,c7,7f,0c,35,2d,40,8c),
        CCN64_C(51,e7,5d,99,98,f0,01,db),CCN64_C(82,67,53,7d,4a,61,2a,18),
        CCN64_C(91,2a,04,91,3e,9e,bd,87),CCN64_C(2e,52,98,9e,cc,f8,5f,34),
        CCN64_C(d2,03,a9,e0,d7,ce,25,d0),CCN64_C(53,c4,4f,ab,73,48,10,f7),
        CCN64_C(20,bd,72,b9,b2,1e,6b,3d),CCN64_C(62,d2,18,77,12,96,ef,6a),
        CCN64_C(85,63,21,5f,72,c8,d9,89),CCN64_C(04,ba,04,4a,eb,4e,ef,d4),
        CCN64_C(ae,01,e0,f3,63,a9,31,5d),CCN64_C(5f,66,61,46,cb,44,1f,59),
        CCN64_C(e6,0c,6e,fd,ff,b7,a9,a9),CCN64_C(6c,79,51,a5,23,ce,f7,85),
        CCN64_C(09,95,48,43,20,e7,39,f4),CCN64_C(fd,c6,5a,26,9b,51,c1,ef),
        CCN64_C(c9,39,19,d1,2a,4b,1a,67),CCN64_C(b1,8a,9e,f1,50,c8,95,3a),
        CCN64_C(1d,7d,37,a2,3f,b8,cf,61),CCN64_C(46,bd,b7,33,6e,84,52,d9),
        CCN64_C(8b,d7,05,62,da,60,e3,92),CCN64_C(4f,02,41,93,78,7a,82,78),
        CCN64_C(ca,06,da,91,c2,b3,e7,e2),CCN64_C(8f,b4,83,2e,f8,27,de,84),
        CCN64_C(7e,2c,75,a5,8e,25,f1,42),CCN64_C(34,72,08,69,90,da,cf,1a),
        CCN64_C(e8,10,54,64,e9,f8,0a,5f),CCN64_C(b6,16,d6,fa,8b,e2,c9,1d),
        CCN64_C(f1,d2,7d,0b,5c,7d,c9,c2),CCN64_C(9e,10,fd,e2,8e,54,80,6b),
        CCN64_C(e4,fc,cf,1d,63,8f,45,66),CCN64_C(6c,09,06,0d,41,05,86,39),
        CCN64_C(c2,8a,61,d4,74,11,40,2d),CCN64_C(67,de,8f,a0,23,86,47,14),
        CCN64_C(91,a4,f5,57,29,29,b9,0c),CCN64_C(be,ac,d4,6f,3c,dd,11,96),
        CCN64_C(a8,9d,1d,cd,9d,38,1c,c5),CCN64_C(cb,22,51,76,25,9e,08,0f),
        CCN64_C(18,c3,dc,e2,01,88,d8,4c),CCN64_C(91,f3,0c,52,f7,98,da,6a),
        CCN64_C(3a,d3,6f,d8,22,c3,9f,34),CCN64_C(fe,a8,0d,9a,6e,c9,fc,d3),
        CCN64_C(f3,e5,6c,c2,bd,9f,04,8c),CCN64_C(70,b5,6f,52,7f,6f,60,4f),
        CCN64_C(54,01,ea,4f,3e,d7,3a,2f),CCN64_C(52,6a,65,3a,7a,67,4b,d5),
        CCN64_C(4c,2d,e6,7d,ad,47,52,7e),CCN64_C(aa,7f,bd,95,62,05,9f,1f),
        CCN64_C(f8,b1,17,25,33,9e,bc,93),CCN64_C(b7,b7,68,c8,99,31,d7,8d),
        CCN64_C(e6,5b,cc,3a,b7,8f,da,a9),CCN64_C(3d,a9,76,59,e2,80,db,0b)
    },
    .g = {
        /* g */
        CCN64_C(00,00,00,00,00,00,00,05),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .q = {
        /* q */
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN64_C(00,00,00,00,00,00,00,00),
        CCN64_C(00,00,00,00,00,00,00,00),CCN8_C(00)
    },
    .l = 384,
};

ccdh_const_gp_t ccsrp_gp_rfc5054_4096(void)
{
    return (ccdh_const_gp_t)&_ccsrp_gp_rfc5054_4096;
}
