/* Copyright (c) (2021,2023) Apple Inc. All rights reserved.
 *
 * corecrypto is licensed under Apple Inc.’s Internal Use License Agreement (which
 * is contained in the License.txt file distributed with corecrypto) and only to
 * people who accept that license. IMPORTANT:  Any license rights granted to you by
 * Apple Inc. (if any) are limited to internal use within your organization only on
 * devices and computers you own or control, for the sole purpose of verifying the
 * security characteristics and correct functioning of the Apple Software.  You may
 * not, directly or indirectly, redistribute the Apple Software or any portions thereof.
 */

{
    .id = 0,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3121,
    .sample_nbytes = 45,
    .add_nsamples = 13,
    .nadds = 240,
},
{
    .id = 1,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2618,
    .sample_nbytes = 36,
    .add_nsamples = 178,
    .nadds = 14,
},
{
    .id = 2,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1561,
    .sample_nbytes = 47,
    .add_nsamples = 127,
    .nadds = 12,
},
{
    .id = 3,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3931,
    .sample_nbytes = 63,
    .add_nsamples = 3,
    .nadds = 1311,
},
{
    .id = 4,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 926,
    .sample_nbytes = 21,
    .add_nsamples = 115,
    .nadds = 8,
},
{
    .id = 5,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3203,
    .sample_nbytes = 12,
    .add_nsamples = 119,
    .nadds = 27,
},
{
    .id = 6,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1420,
    .sample_nbytes = 3,
    .add_nsamples = 155,
    .nadds = 9,
},
{
    .id = 7,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 915,
    .sample_nbytes = 62,
    .add_nsamples = 105,
    .nadds = 8,
},
{
    .id = 8,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3822,
    .sample_nbytes = 35,
    .add_nsamples = 98,
    .nadds = 38,
},
{
    .id = 9,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3439,
    .sample_nbytes = 20,
    .add_nsamples = 137,
    .nadds = 25,
},
{
    .id = 10,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 388,
    .sample_nbytes = 54,
    .add_nsamples = 41,
    .nadds = 10,
},
{
    .id = 11,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1481,
    .sample_nbytes = 10,
    .add_nsamples = 90,
    .nadds = 16,
},
{
    .id = 12,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 874,
    .sample_nbytes = 60,
    .add_nsamples = 195,
    .nadds = 4,
},
{
    .id = 13,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 264,
    .sample_nbytes = 25,
    .add_nsamples = 50,
    .nadds = 6,
},
{
    .id = 14,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 421,
    .sample_nbytes = 12,
    .add_nsamples = 123,
    .nadds = 4,
},
{
    .id = 15,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1290,
    .sample_nbytes = 50,
    .add_nsamples = 105,
    .nadds = 13,
},
{
    .id = 16,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2149,
    .sample_nbytes = 26,
    .add_nsamples = 166,
    .nadds = 13,
},
{
    .id = 17,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1109,
    .sample_nbytes = 6,
    .add_nsamples = 135,
    .nadds = 9,
},
{
    .id = 18,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 226,
    .sample_nbytes = 33,
    .add_nsamples = 113,
    .nadds = 1,
},
{
    .id = 19,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 197,
    .sample_nbytes = 6,
    .add_nsamples = 43,
    .nadds = 5,
},
{
    .id = 20,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1922,
    .sample_nbytes = 2,
    .add_nsamples = 164,
    .nadds = 11,
},
{
    .id = 21,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3725,
    .sample_nbytes = 39,
    .add_nsamples = 176,
    .nadds = 21,
},
{
    .id = 22,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 643,
    .sample_nbytes = 56,
    .add_nsamples = 93,
    .nadds = 6,
},
{
    .id = 23,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1637,
    .sample_nbytes = 8,
    .add_nsamples = 172,
    .nadds = 9,
},
{
    .id = 24,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 466,
    .sample_nbytes = 53,
    .add_nsamples = 19,
    .nadds = 24,
},
{
    .id = 25,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 606,
    .sample_nbytes = 53,
    .add_nsamples = 32,
    .nadds = 18,
},
{
    .id = 26,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1376,
    .sample_nbytes = 1,
    .add_nsamples = 90,
    .nadds = 15,
},
{
    .id = 27,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3497,
    .sample_nbytes = 40,
    .add_nsamples = 66,
    .nadds = 52,
},
{
    .id = 28,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 61,
    .sample_nbytes = 18,
    .add_nsamples = 117,
    .nadds = 1,
},
{
    .id = 29,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2475,
    .sample_nbytes = 30,
    .add_nsamples = 129,
    .nadds = 19,
},
{
    .id = 30,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1255,
    .sample_nbytes = 4,
    .add_nsamples = 190,
    .nadds = 7,
},
{
    .id = 31,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2258,
    .sample_nbytes = 52,
    .add_nsamples = 101,
    .nadds = 22,
},
{
    .id = 32,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3149,
    .sample_nbytes = 21,
    .add_nsamples = 151,
    .nadds = 21,
},
{
    .id = 33,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1175,
    .sample_nbytes = 57,
    .add_nsamples = 196,
    .nadds = 5,
},
{
    .id = 34,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2993,
    .sample_nbytes = 8,
    .add_nsamples = 133,
    .nadds = 23,
},
{
    .id = 35,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2275,
    .sample_nbytes = 48,
    .add_nsamples = 115,
    .nadds = 19,
},
{
    .id = 36,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3860,
    .sample_nbytes = 11,
    .add_nsamples = 69,
    .nadds = 56,
},
{
    .id = 37,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2262,
    .sample_nbytes = 4,
    .add_nsamples = 26,
    .nadds = 86,
},
{
    .id = 38,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3632,
    .sample_nbytes = 24,
    .add_nsamples = 41,
    .nadds = 89,
},
{
    .id = 39,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 364,
    .sample_nbytes = 40,
    .add_nsamples = 196,
    .nadds = 2,
},
{
    .id = 40,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2727,
    .sample_nbytes = 43,
    .add_nsamples = 73,
    .nadds = 37,
},
{
    .id = 41,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2478,
    .sample_nbytes = 61,
    .add_nsamples = 190,
    .nadds = 14,
},
{
    .id = 42,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1870,
    .sample_nbytes = 61,
    .add_nsamples = 114,
    .nadds = 17,
},
{
    .id = 43,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2296,
    .sample_nbytes = 18,
    .add_nsamples = 79,
    .nadds = 29,
},
{
    .id = 44,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3591,
    .sample_nbytes = 24,
    .add_nsamples = 145,
    .nadds = 24,
},
{
    .id = 45,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2509,
    .sample_nbytes = 57,
    .add_nsamples = 12,
    .nadds = 209,
},
{
    .id = 46,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3466,
    .sample_nbytes = 32,
    .add_nsamples = 3,
    .nadds = 1155,
},
{
    .id = 47,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2858,
    .sample_nbytes = 23,
    .add_nsamples = 196,
    .nadds = 15,
},
{
    .id = 48,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1781,
    .sample_nbytes = 9,
    .add_nsamples = 130,
    .nadds = 13,
},
{
    .id = 49,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2771,
    .sample_nbytes = 25,
    .add_nsamples = 181,
    .nadds = 15,
},
{
    .id = 50,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3221,
    .sample_nbytes = 53,
    .add_nsamples = 26,
    .nadds = 124,
},
{
    .id = 51,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2327,
    .sample_nbytes = 14,
    .add_nsamples = 70,
    .nadds = 34,
},
{
    .id = 52,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 281,
    .sample_nbytes = 4,
    .add_nsamples = 38,
    .nadds = 8,
},
{
    .id = 53,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2637,
    .sample_nbytes = 16,
    .add_nsamples = 195,
    .nadds = 13,
},
{
    .id = 54,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2511,
    .sample_nbytes = 30,
    .add_nsamples = 57,
    .nadds = 45,
},
{
    .id = 55,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3716,
    .sample_nbytes = 16,
    .add_nsamples = 184,
    .nadds = 20,
},
{
    .id = 56,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2350,
    .sample_nbytes = 42,
    .add_nsamples = 27,
    .nadds = 87,
},
{
    .id = 57,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1097,
    .sample_nbytes = 32,
    .add_nsamples = 174,
    .nadds = 6,
},
{
    .id = 58,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3200,
    .sample_nbytes = 61,
    .add_nsamples = 45,
    .nadds = 72,
},
{
    .id = 59,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 954,
    .sample_nbytes = 47,
    .add_nsamples = 85,
    .nadds = 12,
},
{
    .id = 60,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3119,
    .sample_nbytes = 18,
    .add_nsamples = 87,
    .nadds = 36,
},
{
    .id = 61,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2477,
    .sample_nbytes = 20,
    .add_nsamples = 181,
    .nadds = 13,
},
{
    .id = 62,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3509,
    .sample_nbytes = 42,
    .add_nsamples = 67,
    .nadds = 52,
},
{
    .id = 63,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 350,
    .sample_nbytes = 17,
    .add_nsamples = 179,
    .nadds = 2,
},
{
    .id = 64,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3173,
    .sample_nbytes = 40,
    .add_nsamples = 108,
    .nadds = 29,
},
{
    .id = 65,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2065,
    .sample_nbytes = 22,
    .add_nsamples = 110,
    .nadds = 19,
},
{
    .id = 66,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 607,
    .sample_nbytes = 4,
    .add_nsamples = 31,
    .nadds = 19,
},
{
    .id = 67,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1248,
    .sample_nbytes = 6,
    .add_nsamples = 110,
    .nadds = 11,
},
{
    .id = 68,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3553,
    .sample_nbytes = 37,
    .add_nsamples = 24,
    .nadds = 149,
},
{
    .id = 69,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1788,
    .sample_nbytes = 7,
    .add_nsamples = 104,
    .nadds = 18,
},
{
    .id = 70,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1592,
    .sample_nbytes = 30,
    .add_nsamples = 116,
    .nadds = 13,
},
{
    .id = 71,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 502,
    .sample_nbytes = 36,
    .add_nsamples = 49,
    .nadds = 11,
},
{
    .id = 72,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1190,
    .sample_nbytes = 54,
    .add_nsamples = 64,
    .nadds = 18,
},
{
    .id = 73,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2101,
    .sample_nbytes = 13,
    .add_nsamples = 129,
    .nadds = 17,
},
{
    .id = 74,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2829,
    .sample_nbytes = 4,
    .add_nsamples = 98,
    .nadds = 28,
},
{
    .id = 75,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 923,
    .sample_nbytes = 9,
    .add_nsamples = 130,
    .nadds = 8,
},
{
    .id = 76,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2789,
    .sample_nbytes = 20,
    .add_nsamples = 161,
    .nadds = 18,
},
{
    .id = 77,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1002,
    .sample_nbytes = 64,
    .add_nsamples = 74,
    .nadds = 14,
},
{
    .id = 78,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2069,
    .sample_nbytes = 57,
    .add_nsamples = 171,
    .nadds = 13,
},
{
    .id = 79,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2184,
    .sample_nbytes = 38,
    .add_nsamples = 106,
    .nadds = 20,
},
{
    .id = 80,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2519,
    .sample_nbytes = 54,
    .add_nsamples = 59,
    .nadds = 43,
},
{
    .id = 81,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 100,
    .sample_nbytes = 48,
    .add_nsamples = 113,
    .nadds = 0,
},
{
    .id = 82,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 573,
    .sample_nbytes = 8,
    .add_nsamples = 156,
    .nadds = 4,
},
{
    .id = 83,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2105,
    .sample_nbytes = 41,
    .add_nsamples = 192,
    .nadds = 10,
},
{
    .id = 84,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2595,
    .sample_nbytes = 54,
    .add_nsamples = 65,
    .nadds = 39,
},
{
    .id = 85,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 168,
    .sample_nbytes = 53,
    .add_nsamples = 153,
    .nadds = 2,
},
{
    .id = 86,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 868,
    .sample_nbytes = 4,
    .add_nsamples = 168,
    .nadds = 6,
},
{
    .id = 87,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1825,
    .sample_nbytes = 22,
    .add_nsamples = 100,
    .nadds = 19,
},
{
    .id = 88,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 374,
    .sample_nbytes = 1,
    .add_nsamples = 35,
    .nadds = 10,
},
{
    .id = 89,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 812,
    .sample_nbytes = 27,
    .add_nsamples = 3,
    .nadds = 271,
},
{
    .id = 90,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3657,
    .sample_nbytes = 62,
    .add_nsamples = 184,
    .nadds = 19,
},
{
    .id = 91,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2675,
    .sample_nbytes = 51,
    .add_nsamples = 92,
    .nadds = 29,
},
{
    .id = 92,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1819,
    .sample_nbytes = 33,
    .add_nsamples = 21,
    .nadds = 87,
},
{
    .id = 93,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2435,
    .sample_nbytes = 7,
    .add_nsamples = 125,
    .nadds = 19,
},
{
    .id = 94,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 625,
    .sample_nbytes = 52,
    .add_nsamples = 111,
    .nadds = 6,
},
{
    .id = 95,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3394,
    .sample_nbytes = 3,
    .add_nsamples = 88,
    .nadds = 39,
},
{
    .id = 96,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3598,
    .sample_nbytes = 50,
    .add_nsamples = 142,
    .nadds = 26,
},
{
    .id = 97,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1517,
    .sample_nbytes = 20,
    .add_nsamples = 74,
    .nadds = 20,
},
{
    .id = 98,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1096,
    .sample_nbytes = 29,
    .add_nsamples = 31,
    .nadds = 35,
},
{
    .id = 99,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 489,
    .sample_nbytes = 63,
    .add_nsamples = 93,
    .nadds = 6,
},
{
    .id = 100,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 875,
    .sample_nbytes = 21,
    .add_nsamples = 107,
    .nadds = 9,
},
{
    .id = 101,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3067,
    .sample_nbytes = 60,
    .add_nsamples = 37,
    .nadds = 82,
},
{
    .id = 102,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 139,
    .sample_nbytes = 25,
    .add_nsamples = 165,
    .nadds = 1,
},
{
    .id = 103,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3551,
    .sample_nbytes = 45,
    .add_nsamples = 111,
    .nadds = 32,
},
{
    .id = 104,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 493,
    .sample_nbytes = 34,
    .add_nsamples = 47,
    .nadds = 10,
},
{
    .id = 105,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1346,
    .sample_nbytes = 38,
    .add_nsamples = 116,
    .nadds = 12,
},
{
    .id = 106,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3163,
    .sample_nbytes = 3,
    .add_nsamples = 137,
    .nadds = 23,
},
{
    .id = 107,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3632,
    .sample_nbytes = 43,
    .add_nsamples = 5,
    .nadds = 726,
},
{
    .id = 108,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2231,
    .sample_nbytes = 17,
    .add_nsamples = 189,
    .nadds = 12,
},
{
    .id = 109,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1130,
    .sample_nbytes = 45,
    .add_nsamples = 108,
    .nadds = 11,
},
{
    .id = 110,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3792,
    .sample_nbytes = 18,
    .add_nsamples = 77,
    .nadds = 49,
},
{
    .id = 111,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3077,
    .sample_nbytes = 21,
    .add_nsamples = 57,
    .nadds = 54,
},
{
    .id = 112,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1648,
    .sample_nbytes = 32,
    .add_nsamples = 42,
    .nadds = 39,
},
{
    .id = 113,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 465,
    .sample_nbytes = 41,
    .add_nsamples = 173,
    .nadds = 3,
},
{
    .id = 114,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3690,
    .sample_nbytes = 36,
    .add_nsamples = 32,
    .nadds = 116,
},
{
    .id = 115,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3995,
    .sample_nbytes = 60,
    .add_nsamples = 129,
    .nadds = 30,
},
{
    .id = 116,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2008,
    .sample_nbytes = 21,
    .add_nsamples = 152,
    .nadds = 14,
},
{
    .id = 117,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3675,
    .sample_nbytes = 4,
    .add_nsamples = 51,
    .nadds = 72,
},
{
    .id = 118,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3242,
    .sample_nbytes = 11,
    .add_nsamples = 153,
    .nadds = 22,
},
{
    .id = 119,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3493,
    .sample_nbytes = 18,
    .add_nsamples = 130,
    .nadds = 26,
},
{
    .id = 120,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1635,
    .sample_nbytes = 49,
    .add_nsamples = 3,
    .nadds = 545,
},
{
    .id = 121,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3224,
    .sample_nbytes = 4,
    .add_nsamples = 150,
    .nadds = 22,
},
{
    .id = 122,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3413,
    .sample_nbytes = 60,
    .add_nsamples = 190,
    .nadds = 18,
},
{
    .id = 123,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3952,
    .sample_nbytes = 22,
    .add_nsamples = 77,
    .nadds = 51,
},
{
    .id = 124,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 970,
    .sample_nbytes = 37,
    .add_nsamples = 168,
    .nadds = 6,
},
{
    .id = 125,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2870,
    .sample_nbytes = 42,
    .add_nsamples = 147,
    .nadds = 19,
},
{
    .id = 126,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1792,
    .sample_nbytes = 14,
    .add_nsamples = 129,
    .nadds = 13,
},
{
    .id = 127,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2502,
    .sample_nbytes = 64,
    .add_nsamples = 67,
    .nadds = 38,
},
{
    .id = 128,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 453,
    .sample_nbytes = 9,
    .add_nsamples = 143,
    .nadds = 3,
},
{
    .id = 129,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 824,
    .sample_nbytes = 10,
    .add_nsamples = 181,
    .nadds = 5,
},
{
    .id = 130,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1787,
    .sample_nbytes = 25,
    .add_nsamples = 103,
    .nadds = 18,
},
{
    .id = 131,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 151,
    .sample_nbytes = 36,
    .add_nsamples = 4,
    .nadds = 38,
},
{
    .id = 132,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 768,
    .sample_nbytes = 39,
    .add_nsamples = 23,
    .nadds = 34,
},
{
    .id = 133,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2083,
    .sample_nbytes = 49,
    .add_nsamples = 11,
    .nadds = 190,
},
{
    .id = 134,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1272,
    .sample_nbytes = 55,
    .add_nsamples = 194,
    .nadds = 6,
},
{
    .id = 135,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3512,
    .sample_nbytes = 28,
    .add_nsamples = 50,
    .nadds = 71,
},
{
    .id = 136,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3827,
    .sample_nbytes = 55,
    .add_nsamples = 39,
    .nadds = 98,
},
{
    .id = 137,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3180,
    .sample_nbytes = 50,
    .add_nsamples = 61,
    .nadds = 52,
},
{
    .id = 138,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 65,
    .sample_nbytes = 24,
    .add_nsamples = 130,
    .nadds = 0,
},
{
    .id = 139,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2786,
    .sample_nbytes = 8,
    .add_nsamples = 162,
    .nadds = 18,
},
{
    .id = 140,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2044,
    .sample_nbytes = 64,
    .add_nsamples = 13,
    .nadds = 158,
},
{
    .id = 141,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1026,
    .sample_nbytes = 55,
    .add_nsamples = 190,
    .nadds = 5,
},
{
    .id = 142,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2809,
    .sample_nbytes = 56,
    .add_nsamples = 73,
    .nadds = 39,
},
{
    .id = 143,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 637,
    .sample_nbytes = 16,
    .add_nsamples = 163,
    .nadds = 4,
},
{
    .id = 144,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3567,
    .sample_nbytes = 30,
    .add_nsamples = 160,
    .nadds = 23,
},
{
    .id = 145,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3527,
    .sample_nbytes = 54,
    .add_nsamples = 141,
    .nadds = 25,
},
{
    .id = 146,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3940,
    .sample_nbytes = 55,
    .add_nsamples = 159,
    .nadds = 24,
},
{
    .id = 147,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3858,
    .sample_nbytes = 55,
    .add_nsamples = 151,
    .nadds = 26,
},
{
    .id = 148,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1590,
    .sample_nbytes = 17,
    .add_nsamples = 91,
    .nadds = 18,
},
{
    .id = 149,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1738,
    .sample_nbytes = 60,
    .add_nsamples = 137,
    .nadds = 13,
},
{
    .id = 150,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 251,
    .sample_nbytes = 27,
    .add_nsamples = 27,
    .nadds = 10,
},
{
    .id = 151,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2750,
    .sample_nbytes = 33,
    .add_nsamples = 110,
    .nadds = 24,
},
{
    .id = 152,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3877,
    .sample_nbytes = 62,
    .add_nsamples = 139,
    .nadds = 27,
},
{
    .id = 153,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1861,
    .sample_nbytes = 2,
    .add_nsamples = 100,
    .nadds = 18,
},
{
    .id = 154,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 17,
    .sample_nbytes = 6,
    .add_nsamples = 46,
    .nadds = 1,
},
{
    .id = 155,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2555,
    .sample_nbytes = 54,
    .add_nsamples = 9,
    .nadds = 284,
},
{
    .id = 156,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2725,
    .sample_nbytes = 8,
    .add_nsamples = 167,
    .nadds = 17,
},
{
    .id = 157,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1360,
    .sample_nbytes = 1,
    .add_nsamples = 138,
    .nadds = 10,
},
{
    .id = 158,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1246,
    .sample_nbytes = 23,
    .add_nsamples = 92,
    .nadds = 13,
},
{
    .id = 159,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1358,
    .sample_nbytes = 52,
    .add_nsamples = 47,
    .nadds = 29,
},
{
    .id = 160,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1571,
    .sample_nbytes = 44,
    .add_nsamples = 21,
    .nadds = 75,
},
{
    .id = 161,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1249,
    .sample_nbytes = 56,
    .add_nsamples = 96,
    .nadds = 14,
},
{
    .id = 162,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2357,
    .sample_nbytes = 58,
    .add_nsamples = 167,
    .nadds = 15,
},
{
    .id = 163,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2578,
    .sample_nbytes = 3,
    .add_nsamples = 31,
    .nadds = 84,
},
{
    .id = 164,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 86,
    .sample_nbytes = 47,
    .add_nsamples = 40,
    .nadds = 2,
},
{
    .id = 165,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1660,
    .sample_nbytes = 42,
    .add_nsamples = 47,
    .nadds = 35,
},
{
    .id = 166,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 343,
    .sample_nbytes = 5,
    .add_nsamples = 140,
    .nadds = 3,
},
{
    .id = 167,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2816,
    .sample_nbytes = 26,
    .add_nsamples = 174,
    .nadds = 16,
},
{
    .id = 168,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 572,
    .sample_nbytes = 27,
    .add_nsamples = 99,
    .nadds = 6,
},
{
    .id = 169,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2290,
    .sample_nbytes = 62,
    .add_nsamples = 8,
    .nadds = 287,
},
{
    .id = 170,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2837,
    .sample_nbytes = 57,
    .add_nsamples = 191,
    .nadds = 15,
},
{
    .id = 171,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 614,
    .sample_nbytes = 11,
    .add_nsamples = 184,
    .nadds = 4,
},
{
    .id = 172,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2320,
    .sample_nbytes = 25,
    .add_nsamples = 114,
    .nadds = 21,
},
{
    .id = 173,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1631,
    .sample_nbytes = 6,
    .add_nsamples = 77,
    .nadds = 22,
},
{
    .id = 174,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 54,
    .sample_nbytes = 54,
    .add_nsamples = 11,
    .nadds = 5,
},
{
    .id = 175,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3539,
    .sample_nbytes = 51,
    .add_nsamples = 199,
    .nadds = 17,
},
{
    .id = 176,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 650,
    .sample_nbytes = 34,
    .add_nsamples = 39,
    .nadds = 16,
},
{
    .id = 177,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1257,
    .sample_nbytes = 32,
    .add_nsamples = 54,
    .nadds = 23,
},
{
    .id = 178,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 897,
    .sample_nbytes = 2,
    .add_nsamples = 44,
    .nadds = 20,
},
{
    .id = 179,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 973,
    .sample_nbytes = 10,
    .add_nsamples = 50,
    .nadds = 20,
},
{
    .id = 180,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3588,
    .sample_nbytes = 23,
    .add_nsamples = 16,
    .nadds = 224,
},
{
    .id = 181,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2332,
    .sample_nbytes = 15,
    .add_nsamples = 170,
    .nadds = 14,
},
{
    .id = 182,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3548,
    .sample_nbytes = 10,
    .add_nsamples = 111,
    .nadds = 32,
},
{
    .id = 183,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3957,
    .sample_nbytes = 31,
    .add_nsamples = 154,
    .nadds = 26,
},
{
    .id = 184,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1409,
    .sample_nbytes = 60,
    .add_nsamples = 126,
    .nadds = 11,
},
{
    .id = 185,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3693,
    .sample_nbytes = 39,
    .add_nsamples = 148,
    .nadds = 25,
},
{
    .id = 186,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 376,
    .sample_nbytes = 12,
    .add_nsamples = 9,
    .nadds = 42,
},
{
    .id = 187,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1518,
    .sample_nbytes = 56,
    .add_nsamples = 141,
    .nadds = 11,
},
{
    .id = 188,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 981,
    .sample_nbytes = 45,
    .add_nsamples = 27,
    .nadds = 36,
},
{
    .id = 189,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 831,
    .sample_nbytes = 23,
    .add_nsamples = 49,
    .nadds = 17,
},
{
    .id = 190,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1382,
    .sample_nbytes = 23,
    .add_nsamples = 160,
    .nadds = 8,
},
{
    .id = 191,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 411,
    .sample_nbytes = 51,
    .add_nsamples = 138,
    .nadds = 2,
},
{
    .id = 192,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3554,
    .sample_nbytes = 23,
    .add_nsamples = 70,
    .nadds = 50,
},
{
    .id = 193,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 968,
    .sample_nbytes = 11,
    .add_nsamples = 58,
    .nadds = 17,
},
{
    .id = 194,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2815,
    .sample_nbytes = 20,
    .add_nsamples = 200,
    .nadds = 14,
},
{
    .id = 195,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 662,
    .sample_nbytes = 37,
    .add_nsamples = 196,
    .nadds = 4,
},
{
    .id = 196,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 866,
    .sample_nbytes = 26,
    .add_nsamples = 151,
    .nadds = 5,
},
{
    .id = 197,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3761,
    .sample_nbytes = 56,
    .add_nsamples = 3,
    .nadds = 1253,
},
{
    .id = 198,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 107,
    .sample_nbytes = 27,
    .add_nsamples = 59,
    .nadds = 2,
},
{
    .id = 199,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 273,
    .sample_nbytes = 22,
    .add_nsamples = 64,
    .nadds = 4,
},
{
    .id = 200,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1060,
    .sample_nbytes = 21,
    .add_nsamples = 154,
    .nadds = 7,
},
{
    .id = 201,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3003,
    .sample_nbytes = 48,
    .add_nsamples = 165,
    .nadds = 19,
},
{
    .id = 202,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1253,
    .sample_nbytes = 27,
    .add_nsamples = 113,
    .nadds = 11,
},
{
    .id = 203,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 679,
    .sample_nbytes = 20,
    .add_nsamples = 75,
    .nadds = 10,
},
{
    .id = 204,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3195,
    .sample_nbytes = 20,
    .add_nsamples = 8,
    .nadds = 399,
},
{
    .id = 205,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3863,
    .sample_nbytes = 61,
    .add_nsamples = 31,
    .nadds = 124,
},
{
    .id = 206,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3298,
    .sample_nbytes = 48,
    .add_nsamples = 56,
    .nadds = 58,
},
{
    .id = 207,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2350,
    .sample_nbytes = 60,
    .add_nsamples = 185,
    .nadds = 13,
},
{
    .id = 208,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3693,
    .sample_nbytes = 30,
    .add_nsamples = 102,
    .nadds = 37,
},
{
    .id = 209,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2003,
    .sample_nbytes = 49,
    .add_nsamples = 182,
    .nadds = 11,
},
{
    .id = 210,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3259,
    .sample_nbytes = 6,
    .add_nsamples = 24,
    .nadds = 135,
},
{
    .id = 211,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2007,
    .sample_nbytes = 22,
    .add_nsamples = 121,
    .nadds = 17,
},
{
    .id = 212,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2632,
    .sample_nbytes = 48,
    .add_nsamples = 96,
    .nadds = 28,
},
{
    .id = 213,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1286,
    .sample_nbytes = 39,
    .add_nsamples = 8,
    .nadds = 160,
},
{
    .id = 214,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2132,
    .sample_nbytes = 23,
    .add_nsamples = 198,
    .nadds = 10,
},
{
    .id = 215,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 820,
    .sample_nbytes = 7,
    .add_nsamples = 78,
    .nadds = 10,
},
{
    .id = 216,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 218,
    .sample_nbytes = 41,
    .add_nsamples = 27,
    .nadds = 9,
},
{
    .id = 217,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1402,
    .sample_nbytes = 61,
    .add_nsamples = 64,
    .nadds = 21,
},
{
    .id = 218,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1582,
    .sample_nbytes = 41,
    .add_nsamples = 172,
    .nadds = 10,
},
{
    .id = 219,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2829,
    .sample_nbytes = 1,
    .add_nsamples = 27,
    .nadds = 104,
},
{
    .id = 220,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 4,
    .sample_nbytes = 18,
    .add_nsamples = 104,
    .nadds = 1,
},
{
    .id = 221,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 311,
    .sample_nbytes = 45,
    .add_nsamples = 186,
    .nadds = 2,
},
{
    .id = 222,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3210,
    .sample_nbytes = 27,
    .add_nsamples = 42,
    .nadds = 77,
},
{
    .id = 223,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 658,
    .sample_nbytes = 34,
    .add_nsamples = 43,
    .nadds = 15,
},
{
    .id = 224,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1764,
    .sample_nbytes = 7,
    .add_nsamples = 95,
    .nadds = 18,
},
{
    .id = 225,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3497,
    .sample_nbytes = 56,
    .add_nsamples = 102,
    .nadds = 34,
},
{
    .id = 226,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2592,
    .sample_nbytes = 61,
    .add_nsamples = 169,
    .nadds = 15,
},
{
    .id = 227,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3813,
    .sample_nbytes = 59,
    .add_nsamples = 97,
    .nadds = 39,
},
{
    .id = 228,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3993,
    .sample_nbytes = 5,
    .add_nsamples = 29,
    .nadds = 137,
},
{
    .id = 229,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3382,
    .sample_nbytes = 28,
    .add_nsamples = 87,
    .nadds = 38,
},
{
    .id = 230,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 318,
    .sample_nbytes = 49,
    .add_nsamples = 194,
    .nadds = 2,
},
{
    .id = 231,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1962,
    .sample_nbytes = 51,
    .add_nsamples = 176,
    .nadds = 11,
},
{
    .id = 232,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3682,
    .sample_nbytes = 41,
    .add_nsamples = 22,
    .nadds = 168,
},
{
    .id = 233,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 911,
    .sample_nbytes = 43,
    .add_nsamples = 79,
    .nadds = 12,
},
{
    .id = 234,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1620,
    .sample_nbytes = 18,
    .add_nsamples = 192,
    .nadds = 9,
},
{
    .id = 235,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 523,
    .sample_nbytes = 29,
    .add_nsamples = 32,
    .nadds = 17,
},
{
    .id = 236,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2024,
    .sample_nbytes = 58,
    .add_nsamples = 152,
    .nadds = 13,
},
{
    .id = 237,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2532,
    .sample_nbytes = 37,
    .add_nsamples = 160,
    .nadds = 15,
},
{
    .id = 238,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3127,
    .sample_nbytes = 38,
    .add_nsamples = 182,
    .nadds = 17,
},
{
    .id = 239,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3979,
    .sample_nbytes = 31,
    .add_nsamples = 88,
    .nadds = 45,
},
{
    .id = 240,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2056,
    .sample_nbytes = 29,
    .add_nsamples = 179,
    .nadds = 12,
},
{
    .id = 241,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3505,
    .sample_nbytes = 53,
    .add_nsamples = 137,
    .nadds = 26,
},
{
    .id = 242,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1320,
    .sample_nbytes = 26,
    .add_nsamples = 73,
    .nadds = 18,
},
{
    .id = 243,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 834,
    .sample_nbytes = 32,
    .add_nsamples = 101,
    .nadds = 9,
},
{
    .id = 244,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 645,
    .sample_nbytes = 38,
    .add_nsamples = 109,
    .nadds = 6,
},
{
    .id = 245,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 360,
    .sample_nbytes = 31,
    .add_nsamples = 116,
    .nadds = 3,
},
{
    .id = 246,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3722,
    .sample_nbytes = 29,
    .add_nsamples = 189,
    .nadds = 19,
},
{
    .id = 247,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2632,
    .sample_nbytes = 59,
    .add_nsamples = 5,
    .nadds = 526,
},
{
    .id = 248,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3814,
    .sample_nbytes = 59,
    .add_nsamples = 195,
    .nadds = 20,
},
{
    .id = 249,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1341,
    .sample_nbytes = 53,
    .add_nsamples = 66,
    .nadds = 21,
},
{
    .id = 250,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1754,
    .sample_nbytes = 41,
    .add_nsamples = 48,
    .nadds = 36,
},
{
    .id = 251,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 885,
    .sample_nbytes = 16,
    .add_nsamples = 41,
    .nadds = 21,
},
{
    .id = 252,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3433,
    .sample_nbytes = 59,
    .add_nsamples = 177,
    .nadds = 20,
},
{
    .id = 253,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2873,
    .sample_nbytes = 3,
    .add_nsamples = 100,
    .nadds = 28,
},
{
    .id = 254,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 818,
    .sample_nbytes = 59,
    .add_nsamples = 134,
    .nadds = 7,
},
{
    .id = 255,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2476,
    .sample_nbytes = 2,
    .add_nsamples = 94,
    .nadds = 26,
},
{
    .id = 256,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 188,
    .sample_nbytes = 51,
    .add_nsamples = 184,
    .nadds = 1,
},
{
    .id = 257,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1334,
    .sample_nbytes = 13,
    .add_nsamples = 22,
    .nadds = 60,
},
{
    .id = 258,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 823,
    .sample_nbytes = 5,
    .add_nsamples = 86,
    .nadds = 10,
},
{
    .id = 259,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1218,
    .sample_nbytes = 33,
    .add_nsamples = 73,
    .nadds = 17,
},
{
    .id = 260,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1672,
    .sample_nbytes = 16,
    .add_nsamples = 117,
    .nadds = 15,
},
{
    .id = 261,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2877,
    .sample_nbytes = 59,
    .add_nsamples = 56,
    .nadds = 51,
},
{
    .id = 262,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2650,
    .sample_nbytes = 38,
    .add_nsamples = 108,
    .nadds = 24,
},
{
    .id = 263,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2326,
    .sample_nbytes = 34,
    .add_nsamples = 118,
    .nadds = 20,
},
{
    .id = 264,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 897,
    .sample_nbytes = 10,
    .add_nsamples = 61,
    .nadds = 15,
},
{
    .id = 265,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 981,
    .sample_nbytes = 17,
    .add_nsamples = 128,
    .nadds = 7,
},
{
    .id = 266,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1671,
    .sample_nbytes = 21,
    .add_nsamples = 103,
    .nadds = 16,
},
{
    .id = 267,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2383,
    .sample_nbytes = 16,
    .add_nsamples = 90,
    .nadds = 27,
},
{
    .id = 268,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 428,
    .sample_nbytes = 6,
    .add_nsamples = 117,
    .nadds = 3,
},
{
    .id = 269,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1276,
    .sample_nbytes = 7,
    .add_nsamples = 107,
    .nadds = 11,
},
{
    .id = 270,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2468,
    .sample_nbytes = 20,
    .add_nsamples = 54,
    .nadds = 46,
},
{
    .id = 271,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2278,
    .sample_nbytes = 56,
    .add_nsamples = 21,
    .nadds = 108,
},
{
    .id = 272,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3112,
    .sample_nbytes = 11,
    .add_nsamples = 93,
    .nadds = 33,
},
{
    .id = 273,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2950,
    .sample_nbytes = 12,
    .add_nsamples = 32,
    .nadds = 92,
},
{
    .id = 274,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1614,
    .sample_nbytes = 57,
    .add_nsamples = 181,
    .nadds = 9,
},
{
    .id = 275,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 740,
    .sample_nbytes = 41,
    .add_nsamples = 31,
    .nadds = 23,
},
{
    .id = 276,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 26,
    .sample_nbytes = 4,
    .add_nsamples = 179,
    .nadds = 0,
},
{
    .id = 277,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3147,
    .sample_nbytes = 42,
    .add_nsamples = 74,
    .nadds = 43,
},
{
    .id = 278,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3158,
    .sample_nbytes = 60,
    .add_nsamples = 151,
    .nadds = 20,
},
{
    .id = 279,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 419,
    .sample_nbytes = 61,
    .add_nsamples = 87,
    .nadds = 5,
},
{
    .id = 280,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 294,
    .sample_nbytes = 18,
    .add_nsamples = 158,
    .nadds = 1,
},
{
    .id = 281,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 288,
    .sample_nbytes = 56,
    .add_nsamples = 159,
    .nadds = 1,
},
{
    .id = 282,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1678,
    .sample_nbytes = 60,
    .add_nsamples = 154,
    .nadds = 11,
},
{
    .id = 283,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 536,
    .sample_nbytes = 44,
    .add_nsamples = 130,
    .nadds = 5,
},
{
    .id = 284,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1800,
    .sample_nbytes = 33,
    .add_nsamples = 181,
    .nadds = 9,
},
{
    .id = 285,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3906,
    .sample_nbytes = 17,
    .add_nsamples = 129,
    .nadds = 30,
},
{
    .id = 286,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2593,
    .sample_nbytes = 30,
    .add_nsamples = 137,
    .nadds = 19,
},
{
    .id = 287,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2641,
    .sample_nbytes = 41,
    .add_nsamples = 56,
    .nadds = 48,
},
{
    .id = 288,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3979,
    .sample_nbytes = 38,
    .add_nsamples = 197,
    .nadds = 20,
},
{
    .id = 289,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3382,
    .sample_nbytes = 7,
    .add_nsamples = 20,
    .nadds = 170,
},
{
    .id = 290,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1263,
    .sample_nbytes = 51,
    .add_nsamples = 2,
    .nadds = 631,
},
{
    .id = 291,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1871,
    .sample_nbytes = 12,
    .add_nsamples = 180,
    .nadds = 10,
},
{
    .id = 292,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1794,
    .sample_nbytes = 34,
    .add_nsamples = 200,
    .nadds = 9,
},
{
    .id = 293,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2796,
    .sample_nbytes = 19,
    .add_nsamples = 70,
    .nadds = 40,
},
{
    .id = 294,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3907,
    .sample_nbytes = 18,
    .add_nsamples = 167,
    .nadds = 24,
},
{
    .id = 295,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 856,
    .sample_nbytes = 51,
    .add_nsamples = 66,
    .nadds = 13,
},
{
    .id = 296,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3367,
    .sample_nbytes = 19,
    .add_nsamples = 55,
    .nadds = 62,
},
{
    .id = 297,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 958,
    .sample_nbytes = 15,
    .add_nsamples = 128,
    .nadds = 8,
},
{
    .id = 298,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2097,
    .sample_nbytes = 56,
    .add_nsamples = 186,
    .nadds = 11,
},
{
    .id = 299,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2646,
    .sample_nbytes = 60,
    .add_nsamples = 172,
    .nadds = 15,
},
{
    .id = 300,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2783,
    .sample_nbytes = 6,
    .add_nsamples = 137,
    .nadds = 21,
},
{
    .id = 301,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1355,
    .sample_nbytes = 35,
    .add_nsamples = 24,
    .nadds = 57,
},
{
    .id = 302,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1454,
    .sample_nbytes = 43,
    .add_nsamples = 16,
    .nadds = 91,
},
{
    .id = 303,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1622,
    .sample_nbytes = 22,
    .add_nsamples = 84,
    .nadds = 20,
},
{
    .id = 304,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2015,
    .sample_nbytes = 43,
    .add_nsamples = 135,
    .nadds = 14,
},
{
    .id = 305,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 410,
    .sample_nbytes = 49,
    .add_nsamples = 94,
    .nadds = 5,
},
{
    .id = 306,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 216,
    .sample_nbytes = 56,
    .add_nsamples = 69,
    .nadds = 3,
},
{
    .id = 307,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3286,
    .sample_nbytes = 32,
    .add_nsamples = 135,
    .nadds = 25,
},
{
    .id = 308,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 752,
    .sample_nbytes = 29,
    .add_nsamples = 69,
    .nadds = 10,
},
{
    .id = 309,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2375,
    .sample_nbytes = 32,
    .add_nsamples = 2,
    .nadds = 1187,
},
{
    .id = 310,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1750,
    .sample_nbytes = 27,
    .add_nsamples = 95,
    .nadds = 18,
},
{
    .id = 311,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2003,
    .sample_nbytes = 60,
    .add_nsamples = 140,
    .nadds = 15,
},
{
    .id = 312,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2807,
    .sample_nbytes = 16,
    .add_nsamples = 30,
    .nadds = 93,
},
{
    .id = 313,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1757,
    .sample_nbytes = 16,
    .add_nsamples = 75,
    .nadds = 24,
},
{
    .id = 314,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1531,
    .sample_nbytes = 25,
    .add_nsamples = 144,
    .nadds = 11,
},
{
    .id = 315,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2049,
    .sample_nbytes = 59,
    .add_nsamples = 75,
    .nadds = 27,
},
{
    .id = 316,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1063,
    .sample_nbytes = 9,
    .add_nsamples = 95,
    .nadds = 11,
},
{
    .id = 317,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1940,
    .sample_nbytes = 25,
    .add_nsamples = 58,
    .nadds = 33,
},
{
    .id = 318,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3648,
    .sample_nbytes = 44,
    .add_nsamples = 15,
    .nadds = 244,
},
{
    .id = 319,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3627,
    .sample_nbytes = 30,
    .add_nsamples = 27,
    .nadds = 135,
},
{
    .id = 320,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3848,
    .sample_nbytes = 10,
    .add_nsamples = 175,
    .nadds = 21,
},
{
    .id = 321,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3658,
    .sample_nbytes = 47,
    .add_nsamples = 112,
    .nadds = 32,
},
{
    .id = 322,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3293,
    .sample_nbytes = 8,
    .add_nsamples = 69,
    .nadds = 47,
},
{
    .id = 323,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2113,
    .sample_nbytes = 14,
    .add_nsamples = 79,
    .nadds = 26,
},
{
    .id = 324,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1994,
    .sample_nbytes = 2,
    .add_nsamples = 115,
    .nadds = 17,
},
{
    .id = 325,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 971,
    .sample_nbytes = 24,
    .add_nsamples = 45,
    .nadds = 22,
},
{
    .id = 326,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 901,
    .sample_nbytes = 14,
    .add_nsamples = 146,
    .nadds = 6,
},
{
    .id = 327,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2202,
    .sample_nbytes = 29,
    .add_nsamples = 94,
    .nadds = 24,
},
{
    .id = 328,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2004,
    .sample_nbytes = 33,
    .add_nsamples = 122,
    .nadds = 16,
},
{
    .id = 329,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3751,
    .sample_nbytes = 13,
    .add_nsamples = 193,
    .nadds = 19,
},
{
    .id = 330,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2562,
    .sample_nbytes = 53,
    .add_nsamples = 59,
    .nadds = 44,
},
{
    .id = 331,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 725,
    .sample_nbytes = 47,
    .add_nsamples = 35,
    .nadds = 20,
},
{
    .id = 332,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3274,
    .sample_nbytes = 25,
    .add_nsamples = 199,
    .nadds = 17,
},
{
    .id = 333,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 850,
    .sample_nbytes = 18,
    .add_nsamples = 105,
    .nadds = 9,
},
{
    .id = 334,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1999,
    .sample_nbytes = 50,
    .add_nsamples = 57,
    .nadds = 36,
},
{
    .id = 335,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 827,
    .sample_nbytes = 53,
    .add_nsamples = 126,
    .nadds = 7,
},
{
    .id = 336,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2170,
    .sample_nbytes = 1,
    .add_nsamples = 95,
    .nadds = 22,
},
{
    .id = 337,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2554,
    .sample_nbytes = 43,
    .add_nsamples = 200,
    .nadds = 13,
},
{
    .id = 338,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 342,
    .sample_nbytes = 45,
    .add_nsamples = 6,
    .nadds = 56,
},
{
    .id = 339,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1953,
    .sample_nbytes = 63,
    .add_nsamples = 118,
    .nadds = 16,
},
{
    .id = 340,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 218,
    .sample_nbytes = 63,
    .add_nsamples = 67,
    .nadds = 4,
},
{
    .id = 341,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 308,
    .sample_nbytes = 37,
    .add_nsamples = 155,
    .nadds = 2,
},
{
    .id = 342,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1824,
    .sample_nbytes = 29,
    .add_nsamples = 19,
    .nadds = 96,
},
{
    .id = 343,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3546,
    .sample_nbytes = 54,
    .add_nsamples = 24,
    .nadds = 147,
},
{
    .id = 344,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 875,
    .sample_nbytes = 49,
    .add_nsamples = 81,
    .nadds = 10,
},
{
    .id = 345,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2812,
    .sample_nbytes = 3,
    .add_nsamples = 37,
    .nadds = 75,
},
{
    .id = 346,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1408,
    .sample_nbytes = 62,
    .add_nsamples = 109,
    .nadds = 12,
},
{
    .id = 347,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2520,
    .sample_nbytes = 26,
    .add_nsamples = 144,
    .nadds = 17,
},
{
    .id = 348,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2596,
    .sample_nbytes = 11,
    .add_nsamples = 142,
    .nadds = 19,
},
{
    .id = 349,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2307,
    .sample_nbytes = 61,
    .add_nsamples = 145,
    .nadds = 16,
},
{
    .id = 350,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3150,
    .sample_nbytes = 41,
    .add_nsamples = 177,
    .nadds = 18,
},
{
    .id = 351,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3592,
    .sample_nbytes = 62,
    .add_nsamples = 89,
    .nadds = 41,
},
{
    .id = 352,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2685,
    .sample_nbytes = 10,
    .add_nsamples = 188,
    .nadds = 14,
},
{
    .id = 353,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1968,
    .sample_nbytes = 11,
    .add_nsamples = 24,
    .nadds = 82,
},
{
    .id = 354,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2341,
    .sample_nbytes = 52,
    .add_nsamples = 132,
    .nadds = 17,
},
{
    .id = 355,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1359,
    .sample_nbytes = 8,
    .add_nsamples = 150,
    .nadds = 10,
},
{
    .id = 356,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3918,
    .sample_nbytes = 60,
    .add_nsamples = 25,
    .nadds = 157,
},
{
    .id = 357,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2125,
    .sample_nbytes = 17,
    .add_nsamples = 168,
    .nadds = 12,
},
{
    .id = 358,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1246,
    .sample_nbytes = 42,
    .add_nsamples = 32,
    .nadds = 39,
},
{
    .id = 359,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1681,
    .sample_nbytes = 32,
    .add_nsamples = 112,
    .nadds = 16,
},
{
    .id = 360,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2905,
    .sample_nbytes = 49,
    .add_nsamples = 77,
    .nadds = 38,
},
{
    .id = 361,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 723,
    .sample_nbytes = 55,
    .add_nsamples = 15,
    .nadds = 48,
},
{
    .id = 362,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2766,
    .sample_nbytes = 58,
    .add_nsamples = 39,
    .nadds = 70,
},
{
    .id = 363,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3884,
    .sample_nbytes = 2,
    .add_nsamples = 115,
    .nadds = 34,
},
{
    .id = 364,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1616,
    .sample_nbytes = 3,
    .add_nsamples = 12,
    .nadds = 135,
},
{
    .id = 365,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 838,
    .sample_nbytes = 27,
    .add_nsamples = 55,
    .nadds = 16,
},
{
    .id = 366,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 11,
    .sample_nbytes = 5,
    .add_nsamples = 199,
    .nadds = 0,
},
{
    .id = 367,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2454,
    .sample_nbytes = 24,
    .add_nsamples = 87,
    .nadds = 29,
},
{
    .id = 368,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1353,
    .sample_nbytes = 28,
    .add_nsamples = 15,
    .nadds = 90,
},
{
    .id = 369,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 933,
    .sample_nbytes = 18,
    .add_nsamples = 1,
    .nadds = 932,
},
{
    .id = 370,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1943,
    .sample_nbytes = 13,
    .add_nsamples = 91,
    .nadds = 21,
},
{
    .id = 371,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2526,
    .sample_nbytes = 24,
    .add_nsamples = 188,
    .nadds = 13,
},
{
    .id = 372,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2680,
    .sample_nbytes = 61,
    .add_nsamples = 24,
    .nadds = 112,
},
{
    .id = 373,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 556,
    .sample_nbytes = 12,
    .add_nsamples = 127,
    .nadds = 4,
},
{
    .id = 374,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2329,
    .sample_nbytes = 25,
    .add_nsamples = 138,
    .nadds = 17,
},
{
    .id = 375,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3865,
    .sample_nbytes = 15,
    .add_nsamples = 194,
    .nadds = 19,
},
{
    .id = 376,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3704,
    .sample_nbytes = 63,
    .add_nsamples = 89,
    .nadds = 42,
},
{
    .id = 377,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2007,
    .sample_nbytes = 16,
    .add_nsamples = 161,
    .nadds = 12,
},
{
    .id = 378,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 169,
    .sample_nbytes = 30,
    .add_nsamples = 141,
    .nadds = 2,
},
{
    .id = 379,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2850,
    .sample_nbytes = 37,
    .add_nsamples = 90,
    .nadds = 31,
},
{
    .id = 380,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 827,
    .sample_nbytes = 29,
    .add_nsamples = 67,
    .nadds = 12,
},
{
    .id = 381,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 43,
    .sample_nbytes = 50,
    .add_nsamples = 21,
    .nadds = 3,
},
{
    .id = 382,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1486,
    .sample_nbytes = 33,
    .add_nsamples = 101,
    .nadds = 14,
},
{
    .id = 383,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 523,
    .sample_nbytes = 33,
    .add_nsamples = 83,
    .nadds = 6,
},
{
    .id = 384,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 941,
    .sample_nbytes = 22,
    .add_nsamples = 53,
    .nadds = 17,
},
{
    .id = 385,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 962,
    .sample_nbytes = 59,
    .add_nsamples = 131,
    .nadds = 8,
},
{
    .id = 386,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1910,
    .sample_nbytes = 48,
    .add_nsamples = 145,
    .nadds = 13,
},
{
    .id = 387,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2419,
    .sample_nbytes = 32,
    .add_nsamples = 186,
    .nadds = 14,
},
{
    .id = 388,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1706,
    .sample_nbytes = 6,
    .add_nsamples = 130,
    .nadds = 14,
},
{
    .id = 389,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2520,
    .sample_nbytes = 32,
    .add_nsamples = 73,
    .nadds = 35,
},
{
    .id = 390,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3388,
    .sample_nbytes = 60,
    .add_nsamples = 138,
    .nadds = 24,
},
{
    .id = 391,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2478,
    .sample_nbytes = 2,
    .add_nsamples = 151,
    .nadds = 16,
},
{
    .id = 392,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1897,
    .sample_nbytes = 40,
    .add_nsamples = 110,
    .nadds = 18,
},
{
    .id = 393,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1154,
    .sample_nbytes = 62,
    .add_nsamples = 25,
    .nadds = 46,
},
{
    .id = 394,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 689,
    .sample_nbytes = 36,
    .add_nsamples = 22,
    .nadds = 32,
},
{
    .id = 395,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2855,
    .sample_nbytes = 18,
    .add_nsamples = 197,
    .nadds = 15,
},
{
    .id = 396,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1057,
    .sample_nbytes = 57,
    .add_nsamples = 171,
    .nadds = 6,
},
{
    .id = 397,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1891,
    .sample_nbytes = 39,
    .add_nsamples = 132,
    .nadds = 14,
},
{
    .id = 398,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 629,
    .sample_nbytes = 25,
    .add_nsamples = 167,
    .nadds = 3,
},
{
    .id = 399,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2871,
    .sample_nbytes = 1,
    .add_nsamples = 115,
    .nadds = 24,
},
{
    .id = 400,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1859,
    .sample_nbytes = 32,
    .add_nsamples = 120,
    .nadds = 16,
},
{
    .id = 401,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1663,
    .sample_nbytes = 7,
    .add_nsamples = 96,
    .nadds = 18,
},
{
    .id = 402,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 382,
    .sample_nbytes = 45,
    .add_nsamples = 191,
    .nadds = 2,
},
{
    .id = 403,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3779,
    .sample_nbytes = 23,
    .add_nsamples = 39,
    .nadds = 97,
},
{
    .id = 404,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1792,
    .sample_nbytes = 59,
    .add_nsamples = 145,
    .nadds = 13,
},
{
    .id = 405,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2922,
    .sample_nbytes = 59,
    .add_nsamples = 153,
    .nadds = 20,
},
{
    .id = 406,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1203,
    .sample_nbytes = 26,
    .add_nsamples = 23,
    .nadds = 52,
},
{
    .id = 407,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3367,
    .sample_nbytes = 7,
    .add_nsamples = 62,
    .nadds = 54,
},
{
    .id = 408,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 177,
    .sample_nbytes = 18,
    .add_nsamples = 95,
    .nadds = 1,
},
{
    .id = 409,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 727,
    .sample_nbytes = 42,
    .add_nsamples = 184,
    .nadds = 3,
},
{
    .id = 410,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1473,
    .sample_nbytes = 1,
    .add_nsamples = 173,
    .nadds = 8,
},
{
    .id = 411,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1784,
    .sample_nbytes = 16,
    .add_nsamples = 59,
    .nadds = 30,
},
{
    .id = 412,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1356,
    .sample_nbytes = 45,
    .add_nsamples = 11,
    .nadds = 124,
},
{
    .id = 413,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1995,
    .sample_nbytes = 4,
    .add_nsamples = 118,
    .nadds = 17,
},
{
    .id = 414,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 349,
    .sample_nbytes = 6,
    .add_nsamples = 58,
    .nadds = 6,
},
{
    .id = 415,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2536,
    .sample_nbytes = 53,
    .add_nsamples = 41,
    .nadds = 62,
},
{
    .id = 416,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3700,
    .sample_nbytes = 9,
    .add_nsamples = 150,
    .nadds = 25,
},
{
    .id = 417,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 8,
    .sample_nbytes = 36,
    .add_nsamples = 71,
    .nadds = 1,
},
{
    .id = 418,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3534,
    .sample_nbytes = 19,
    .add_nsamples = 109,
    .nadds = 32,
},
{
    .id = 419,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3930,
    .sample_nbytes = 40,
    .add_nsamples = 73,
    .nadds = 54,
},
{
    .id = 420,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3769,
    .sample_nbytes = 60,
    .add_nsamples = 124,
    .nadds = 30,
},
{
    .id = 421,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1369,
    .sample_nbytes = 45,
    .add_nsamples = 125,
    .nadds = 10,
},
{
    .id = 422,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2658,
    .sample_nbytes = 23,
    .add_nsamples = 184,
    .nadds = 14,
},
{
    .id = 423,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 317,
    .sample_nbytes = 46,
    .add_nsamples = 65,
    .nadds = 4,
},
{
    .id = 424,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1717,
    .sample_nbytes = 56,
    .add_nsamples = 75,
    .nadds = 22,
},
{
    .id = 425,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 135,
    .sample_nbytes = 29,
    .add_nsamples = 97,
    .nadds = 2,
},
{
    .id = 426,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1600,
    .sample_nbytes = 37,
    .add_nsamples = 124,
    .nadds = 12,
},
{
    .id = 427,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2612,
    .sample_nbytes = 4,
    .add_nsamples = 21,
    .nadds = 125,
},
{
    .id = 428,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 751,
    .sample_nbytes = 37,
    .add_nsamples = 93,
    .nadds = 8,
},
{
    .id = 429,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2876,
    .sample_nbytes = 59,
    .add_nsamples = 17,
    .nadds = 170,
},
{
    .id = 430,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 937,
    .sample_nbytes = 13,
    .add_nsamples = 46,
    .nadds = 21,
},
{
    .id = 431,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3871,
    .sample_nbytes = 21,
    .add_nsamples = 135,
    .nadds = 28,
},
{
    .id = 432,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2079,
    .sample_nbytes = 15,
    .add_nsamples = 30,
    .nadds = 69,
},
{
    .id = 433,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2272,
    .sample_nbytes = 21,
    .add_nsamples = 2,
    .nadds = 1135,
},
{
    .id = 434,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1725,
    .sample_nbytes = 51,
    .add_nsamples = 87,
    .nadds = 19,
},
{
    .id = 435,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1490,
    .sample_nbytes = 36,
    .add_nsamples = 15,
    .nadds = 99,
},
{
    .id = 436,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2156,
    .sample_nbytes = 16,
    .add_nsamples = 155,
    .nadds = 13,
},
{
    .id = 437,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 478,
    .sample_nbytes = 19,
    .add_nsamples = 83,
    .nadds = 5,
},
{
    .id = 438,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2817,
    .sample_nbytes = 61,
    .add_nsamples = 156,
    .nadds = 18,
},
{
    .id = 439,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 48,
    .sample_nbytes = 20,
    .add_nsamples = 116,
    .nadds = 1,
},
{
    .id = 440,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 341,
    .sample_nbytes = 16,
    .add_nsamples = 178,
    .nadds = 1,
},
{
    .id = 441,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 971,
    .sample_nbytes = 43,
    .add_nsamples = 21,
    .nadds = 46,
},
{
    .id = 442,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 273,
    .sample_nbytes = 28,
    .add_nsamples = 76,
    .nadds = 3,
},
{
    .id = 443,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2535,
    .sample_nbytes = 63,
    .add_nsamples = 3,
    .nadds = 844,
},
{
    .id = 444,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3069,
    .sample_nbytes = 7,
    .add_nsamples = 145,
    .nadds = 22,
},
{
    .id = 445,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2270,
    .sample_nbytes = 5,
    .add_nsamples = 23,
    .nadds = 99,
},
{
    .id = 446,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2693,
    .sample_nbytes = 55,
    .add_nsamples = 137,
    .nadds = 20,
},
{
    .id = 447,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3039,
    .sample_nbytes = 42,
    .add_nsamples = 26,
    .nadds = 117,
},
{
    .id = 448,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 413,
    .sample_nbytes = 53,
    .add_nsamples = 29,
    .nadds = 14,
},
{
    .id = 449,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1301,
    .sample_nbytes = 18,
    .add_nsamples = 200,
    .nadds = 7,
},
{
    .id = 450,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 964,
    .sample_nbytes = 58,
    .add_nsamples = 3,
    .nadds = 321,
},
{
    .id = 451,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1849,
    .sample_nbytes = 49,
    .add_nsamples = 23,
    .nadds = 80,
},
{
    .id = 452,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2,
    .sample_nbytes = 21,
    .add_nsamples = 93,
    .nadds = 1,
},
{
    .id = 453,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2165,
    .sample_nbytes = 41,
    .add_nsamples = 154,
    .nadds = 14,
},
{
    .id = 454,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 559,
    .sample_nbytes = 12,
    .add_nsamples = 19,
    .nadds = 29,
},
{
    .id = 455,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 104,
    .sample_nbytes = 42,
    .add_nsamples = 58,
    .nadds = 1,
},
{
    .id = 456,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1210,
    .sample_nbytes = 23,
    .add_nsamples = 48,
    .nadds = 25,
},
{
    .id = 457,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3984,
    .sample_nbytes = 34,
    .add_nsamples = 19,
    .nadds = 209,
},
{
    .id = 458,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1570,
    .sample_nbytes = 25,
    .add_nsamples = 18,
    .nadds = 87,
},
{
    .id = 459,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1349,
    .sample_nbytes = 2,
    .add_nsamples = 101,
    .nadds = 13,
},
{
    .id = 460,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 758,
    .sample_nbytes = 25,
    .add_nsamples = 27,
    .nadds = 28,
},
{
    .id = 461,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 817,
    .sample_nbytes = 47,
    .add_nsamples = 142,
    .nadds = 5,
},
{
    .id = 462,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 589,
    .sample_nbytes = 43,
    .add_nsamples = 116,
    .nadds = 5,
},
{
    .id = 463,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3476,
    .sample_nbytes = 25,
    .add_nsamples = 175,
    .nadds = 20,
},
{
    .id = 464,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 962,
    .sample_nbytes = 27,
    .add_nsamples = 148,
    .nadds = 6,
},
{
    .id = 465,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1305,
    .sample_nbytes = 25,
    .add_nsamples = 29,
    .nadds = 44,
},
{
    .id = 466,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3499,
    .sample_nbytes = 59,
    .add_nsamples = 55,
    .nadds = 63,
},
{
    .id = 467,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3539,
    .sample_nbytes = 39,
    .add_nsamples = 69,
    .nadds = 52,
},
{
    .id = 468,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2462,
    .sample_nbytes = 37,
    .add_nsamples = 104,
    .nadds = 23,
},
{
    .id = 469,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 580,
    .sample_nbytes = 40,
    .add_nsamples = 130,
    .nadds = 5,
},
{
    .id = 470,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3836,
    .sample_nbytes = 7,
    .add_nsamples = 107,
    .nadds = 36,
},
{
    .id = 471,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 155,
    .sample_nbytes = 52,
    .add_nsamples = 140,
    .nadds = 2,
},
{
    .id = 472,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1222,
    .sample_nbytes = 6,
    .add_nsamples = 90,
    .nadds = 14,
},
{
    .id = 473,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2988,
    .sample_nbytes = 22,
    .add_nsamples = 100,
    .nadds = 30,
},
{
    .id = 474,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2492,
    .sample_nbytes = 7,
    .add_nsamples = 37,
    .nadds = 68,
},
{
    .id = 475,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1242,
    .sample_nbytes = 52,
    .add_nsamples = 68,
    .nadds = 18,
},
{
    .id = 476,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3687,
    .sample_nbytes = 44,
    .add_nsamples = 1,
    .nadds = 3686,
},
{
    .id = 477,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1295,
    .sample_nbytes = 58,
    .add_nsamples = 100,
    .nadds = 13,
},
{
    .id = 478,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1738,
    .sample_nbytes = 44,
    .add_nsamples = 14,
    .nadds = 125,
},
{
    .id = 479,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3388,
    .sample_nbytes = 54,
    .add_nsamples = 25,
    .nadds = 135,
},
{
    .id = 480,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3636,
    .sample_nbytes = 48,
    .add_nsamples = 174,
    .nadds = 20,
},
{
    .id = 481,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2894,
    .sample_nbytes = 6,
    .add_nsamples = 190,
    .nadds = 16,
},
{
    .id = 482,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3445,
    .sample_nbytes = 50,
    .add_nsamples = 184,
    .nadds = 18,
},
{
    .id = 483,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3167,
    .sample_nbytes = 49,
    .add_nsamples = 119,
    .nadds = 26,
},
{
    .id = 484,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3602,
    .sample_nbytes = 22,
    .add_nsamples = 134,
    .nadds = 26,
},
{
    .id = 485,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2658,
    .sample_nbytes = 17,
    .add_nsamples = 33,
    .nadds = 81,
},
{
    .id = 486,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2633,
    .sample_nbytes = 52,
    .add_nsamples = 152,
    .nadds = 17,
},
{
    .id = 487,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 688,
    .sample_nbytes = 59,
    .add_nsamples = 65,
    .nadds = 11,
},
{
    .id = 488,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 335,
    .sample_nbytes = 35,
    .add_nsamples = 5,
    .nadds = 66,
},
{
    .id = 489,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 20,
    .sample_nbytes = 49,
    .add_nsamples = 100,
    .nadds = 0,
},
{
    .id = 490,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1686,
    .sample_nbytes = 51,
    .add_nsamples = 181,
    .nadds = 10,
},
{
    .id = 491,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3272,
    .sample_nbytes = 2,
    .add_nsamples = 122,
    .nadds = 27,
},
{
    .id = 492,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2769,
    .sample_nbytes = 25,
    .add_nsamples = 10,
    .nadds = 277,
},
{
    .id = 493,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1294,
    .sample_nbytes = 38,
    .add_nsamples = 81,
    .nadds = 15,
},
{
    .id = 494,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3644,
    .sample_nbytes = 22,
    .add_nsamples = 130,
    .nadds = 29,
},
{
    .id = 495,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3603,
    .sample_nbytes = 53,
    .add_nsamples = 107,
    .nadds = 33,
},
{
    .id = 496,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2839,
    .sample_nbytes = 32,
    .add_nsamples = 65,
    .nadds = 43,
},
{
    .id = 497,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 978,
    .sample_nbytes = 34,
    .add_nsamples = 71,
    .nadds = 14,
},
{
    .id = 498,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 663,
    .sample_nbytes = 48,
    .add_nsamples = 161,
    .nadds = 5,
},
{
    .id = 499,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 688,
    .sample_nbytes = 41,
    .add_nsamples = 185,
    .nadds = 4,
},
{
    .id = 500,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1647,
    .sample_nbytes = 11,
    .add_nsamples = 101,
    .nadds = 16,
},
{
    .id = 501,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3243,
    .sample_nbytes = 38,
    .add_nsamples = 40,
    .nadds = 82,
},
{
    .id = 502,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1228,
    .sample_nbytes = 36,
    .add_nsamples = 127,
    .nadds = 9,
},
{
    .id = 503,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2850,
    .sample_nbytes = 49,
    .add_nsamples = 26,
    .nadds = 110,
},
{
    .id = 504,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2702,
    .sample_nbytes = 63,
    .add_nsamples = 149,
    .nadds = 19,
},
{
    .id = 505,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2165,
    .sample_nbytes = 8,
    .add_nsamples = 122,
    .nadds = 17,
},
{
    .id = 506,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1360,
    .sample_nbytes = 13,
    .add_nsamples = 48,
    .nadds = 29,
},
{
    .id = 507,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 955,
    .sample_nbytes = 44,
    .add_nsamples = 138,
    .nadds = 6,
},
{
    .id = 508,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3990,
    .sample_nbytes = 33,
    .add_nsamples = 172,
    .nadds = 24,
},
{
    .id = 509,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3280,
    .sample_nbytes = 30,
    .add_nsamples = 199,
    .nadds = 16,
},
{
    .id = 510,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1091,
    .sample_nbytes = 58,
    .add_nsamples = 177,
    .nadds = 6,
},
{
    .id = 511,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3187,
    .sample_nbytes = 3,
    .add_nsamples = 81,
    .nadds = 39,
},
{
    .id = 512,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3179,
    .sample_nbytes = 35,
    .add_nsamples = 59,
    .nadds = 53,
},
{
    .id = 513,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 297,
    .sample_nbytes = 27,
    .add_nsamples = 128,
    .nadds = 3,
},
{
    .id = 514,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1792,
    .sample_nbytes = 49,
    .add_nsamples = 132,
    .nadds = 13,
},
{
    .id = 515,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 607,
    .sample_nbytes = 64,
    .add_nsamples = 117,
    .nadds = 6,
},
{
    .id = 516,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3036,
    .sample_nbytes = 45,
    .add_nsamples = 182,
    .nadds = 17,
},
{
    .id = 517,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3502,
    .sample_nbytes = 62,
    .add_nsamples = 53,
    .nadds = 66,
},
{
    .id = 518,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 447,
    .sample_nbytes = 16,
    .add_nsamples = 182,
    .nadds = 2,
},
{
    .id = 519,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1249,
    .sample_nbytes = 28,
    .add_nsamples = 140,
    .nadds = 9,
},
{
    .id = 520,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 380,
    .sample_nbytes = 58,
    .add_nsamples = 122,
    .nadds = 3,
},
{
    .id = 521,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3749,
    .sample_nbytes = 28,
    .add_nsamples = 195,
    .nadds = 19,
},
{
    .id = 522,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3159,
    .sample_nbytes = 63,
    .add_nsamples = 142,
    .nadds = 22,
},
{
    .id = 523,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2457,
    .sample_nbytes = 53,
    .add_nsamples = 136,
    .nadds = 19,
},
{
    .id = 524,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2540,
    .sample_nbytes = 8,
    .add_nsamples = 134,
    .nadds = 19,
},
{
    .id = 525,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3986,
    .sample_nbytes = 24,
    .add_nsamples = 45,
    .nadds = 88,
},
{
    .id = 526,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3733,
    .sample_nbytes = 15,
    .add_nsamples = 161,
    .nadds = 23,
},
{
    .id = 527,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 103,
    .sample_nbytes = 6,
    .add_nsamples = 20,
    .nadds = 5,
},
{
    .id = 528,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1570,
    .sample_nbytes = 51,
    .add_nsamples = 66,
    .nadds = 24,
},
{
    .id = 529,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2454,
    .sample_nbytes = 37,
    .add_nsamples = 79,
    .nadds = 32,
},
{
    .id = 530,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 320,
    .sample_nbytes = 15,
    .add_nsamples = 126,
    .nadds = 3,
},
{
    .id = 531,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1427,
    .sample_nbytes = 51,
    .add_nsamples = 157,
    .nadds = 9,
},
{
    .id = 532,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3813,
    .sample_nbytes = 59,
    .add_nsamples = 22,
    .nadds = 174,
},
{
    .id = 533,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 98,
    .sample_nbytes = 15,
    .add_nsamples = 128,
    .nadds = 0,
},
{
    .id = 534,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1360,
    .sample_nbytes = 39,
    .add_nsamples = 122,
    .nadds = 11,
},
{
    .id = 535,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 841,
    .sample_nbytes = 4,
    .add_nsamples = 110,
    .nadds = 7,
},
{
    .id = 536,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3679,
    .sample_nbytes = 15,
    .add_nsamples = 21,
    .nadds = 176,
},
{
    .id = 537,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1279,
    .sample_nbytes = 45,
    .add_nsamples = 133,
    .nadds = 10,
},
{
    .id = 538,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 828,
    .sample_nbytes = 46,
    .add_nsamples = 188,
    .nadds = 5,
},
{
    .id = 539,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2090,
    .sample_nbytes = 49,
    .add_nsamples = 107,
    .nadds = 19,
},
{
    .id = 540,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2380,
    .sample_nbytes = 47,
    .add_nsamples = 39,
    .nadds = 61,
},
{
    .id = 541,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1597,
    .sample_nbytes = 43,
    .add_nsamples = 85,
    .nadds = 19,
},
{
    .id = 542,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2874,
    .sample_nbytes = 29,
    .add_nsamples = 91,
    .nadds = 31,
},
{
    .id = 543,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1956,
    .sample_nbytes = 45,
    .add_nsamples = 127,
    .nadds = 16,
},
{
    .id = 544,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 379,
    .sample_nbytes = 20,
    .add_nsamples = 121,
    .nadds = 3,
},
{
    .id = 545,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3998,
    .sample_nbytes = 51,
    .add_nsamples = 90,
    .nadds = 45,
},
{
    .id = 546,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1610,
    .sample_nbytes = 39,
    .add_nsamples = 2,
    .nadds = 804,
},
{
    .id = 547,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1023,
    .sample_nbytes = 58,
    .add_nsamples = 169,
    .nadds = 7,
},
{
    .id = 548,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3578,
    .sample_nbytes = 12,
    .add_nsamples = 97,
    .nadds = 37,
},
{
    .id = 549,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3187,
    .sample_nbytes = 19,
    .add_nsamples = 53,
    .nadds = 60,
},
{
    .id = 550,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1883,
    .sample_nbytes = 60,
    .add_nsamples = 94,
    .nadds = 20,
},
{
    .id = 551,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 146,
    .sample_nbytes = 5,
    .add_nsamples = 168,
    .nadds = 1,
},
{
    .id = 552,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1084,
    .sample_nbytes = 25,
    .add_nsamples = 109,
    .nadds = 9,
},
{
    .id = 553,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1467,
    .sample_nbytes = 35,
    .add_nsamples = 143,
    .nadds = 11,
},
{
    .id = 554,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2336,
    .sample_nbytes = 26,
    .add_nsamples = 139,
    .nadds = 16,
},
{
    .id = 555,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3640,
    .sample_nbytes = 18,
    .add_nsamples = 180,
    .nadds = 21,
},
{
    .id = 556,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 975,
    .sample_nbytes = 29,
    .add_nsamples = 184,
    .nadds = 6,
},
{
    .id = 557,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1421,
    .sample_nbytes = 56,
    .add_nsamples = 39,
    .nadds = 37,
},
{
    .id = 558,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 924,
    .sample_nbytes = 47,
    .add_nsamples = 28,
    .nadds = 33,
},
{
    .id = 559,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 897,
    .sample_nbytes = 28,
    .add_nsamples = 93,
    .nadds = 9,
},
{
    .id = 560,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3727,
    .sample_nbytes = 53,
    .add_nsamples = 114,
    .nadds = 33,
},
{
    .id = 561,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1738,
    .sample_nbytes = 10,
    .add_nsamples = 137,
    .nadds = 13,
},
{
    .id = 562,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2048,
    .sample_nbytes = 16,
    .add_nsamples = 136,
    .nadds = 16,
},
{
    .id = 563,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1857,
    .sample_nbytes = 12,
    .add_nsamples = 108,
    .nadds = 18,
},
{
    .id = 564,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2063,
    .sample_nbytes = 35,
    .add_nsamples = 7,
    .nadds = 294,
},
{
    .id = 565,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2437,
    .sample_nbytes = 10,
    .add_nsamples = 6,
    .nadds = 406,
},
{
    .id = 566,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 526,
    .sample_nbytes = 30,
    .add_nsamples = 12,
    .nadds = 44,
},
{
    .id = 567,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3194,
    .sample_nbytes = 13,
    .add_nsamples = 186,
    .nadds = 17,
},
{
    .id = 568,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3398,
    .sample_nbytes = 36,
    .add_nsamples = 34,
    .nadds = 100,
},
{
    .id = 569,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1961,
    .sample_nbytes = 14,
    .add_nsamples = 149,
    .nadds = 13,
},
{
    .id = 570,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 755,
    .sample_nbytes = 4,
    .add_nsamples = 149,
    .nadds = 6,
},
{
    .id = 571,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3923,
    .sample_nbytes = 45,
    .add_nsamples = 14,
    .nadds = 281,
},
{
    .id = 572,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3517,
    .sample_nbytes = 18,
    .add_nsamples = 90,
    .nadds = 39,
},
{
    .id = 573,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2719,
    .sample_nbytes = 48,
    .add_nsamples = 168,
    .nadds = 17,
},
{
    .id = 574,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 544,
    .sample_nbytes = 57,
    .add_nsamples = 127,
    .nadds = 5,
},
{
    .id = 575,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2010,
    .sample_nbytes = 15,
    .add_nsamples = 113,
    .nadds = 18,
},
{
    .id = 576,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3638,
    .sample_nbytes = 12,
    .add_nsamples = 134,
    .nadds = 28,
},
{
    .id = 577,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1793,
    .sample_nbytes = 17,
    .add_nsamples = 80,
    .nadds = 23,
},
{
    .id = 578,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3853,
    .sample_nbytes = 55,
    .add_nsamples = 160,
    .nadds = 25,
},
{
    .id = 579,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 306,
    .sample_nbytes = 52,
    .add_nsamples = 126,
    .nadds = 2,
},
{
    .id = 580,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2318,
    .sample_nbytes = 44,
    .add_nsamples = 42,
    .nadds = 56,
},
{
    .id = 581,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3098,
    .sample_nbytes = 2,
    .add_nsamples = 29,
    .nadds = 106,
},
{
    .id = 582,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 836,
    .sample_nbytes = 50,
    .add_nsamples = 65,
    .nadds = 12,
},
{
    .id = 583,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2755,
    .sample_nbytes = 35,
    .add_nsamples = 194,
    .nadds = 14,
},
{
    .id = 584,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1943,
    .sample_nbytes = 61,
    .add_nsamples = 126,
    .nadds = 16,
},
{
    .id = 585,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2793,
    .sample_nbytes = 37,
    .add_nsamples = 72,
    .nadds = 39,
},
{
    .id = 586,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 631,
    .sample_nbytes = 10,
    .add_nsamples = 125,
    .nadds = 5,
},
{
    .id = 587,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1751,
    .sample_nbytes = 24,
    .add_nsamples = 134,
    .nadds = 13,
},
{
    .id = 588,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1835,
    .sample_nbytes = 7,
    .add_nsamples = 80,
    .nadds = 22,
},
{
    .id = 589,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2928,
    .sample_nbytes = 6,
    .add_nsamples = 164,
    .nadds = 18,
},
{
    .id = 590,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2784,
    .sample_nbytes = 50,
    .add_nsamples = 115,
    .nadds = 24,
},
{
    .id = 591,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2456,
    .sample_nbytes = 50,
    .add_nsamples = 31,
    .nadds = 80,
},
{
    .id = 592,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3674,
    .sample_nbytes = 15,
    .add_nsamples = 193,
    .nadds = 19,
},
{
    .id = 593,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 717,
    .sample_nbytes = 18,
    .add_nsamples = 146,
    .nadds = 4,
},
{
    .id = 594,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 148,
    .sample_nbytes = 56,
    .add_nsamples = 8,
    .nadds = 19,
},
{
    .id = 595,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3464,
    .sample_nbytes = 58,
    .add_nsamples = 124,
    .nadds = 28,
},
{
    .id = 596,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1871,
    .sample_nbytes = 59,
    .add_nsamples = 62,
    .nadds = 30,
},
{
    .id = 597,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2824,
    .sample_nbytes = 7,
    .add_nsamples = 73,
    .nadds = 38,
},
{
    .id = 598,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 19,
    .sample_nbytes = 30,
    .add_nsamples = 20,
    .nadds = 0,
},
{
    .id = 599,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2762,
    .sample_nbytes = 56,
    .add_nsamples = 191,
    .nadds = 15,
},
{
    .id = 600,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2107,
    .sample_nbytes = 3,
    .add_nsamples = 63,
    .nadds = 33,
},
{
    .id = 601,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2267,
    .sample_nbytes = 50,
    .add_nsamples = 53,
    .nadds = 43,
},
{
    .id = 602,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2326,
    .sample_nbytes = 32,
    .add_nsamples = 19,
    .nadds = 122,
},
{
    .id = 603,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2170,
    .sample_nbytes = 22,
    .add_nsamples = 165,
    .nadds = 13,
},
{
    .id = 604,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3477,
    .sample_nbytes = 49,
    .add_nsamples = 93,
    .nadds = 37,
},
{
    .id = 605,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 887,
    .sample_nbytes = 36,
    .add_nsamples = 5,
    .nadds = 178,
},
{
    .id = 606,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3746,
    .sample_nbytes = 16,
    .add_nsamples = 187,
    .nadds = 21,
},
{
    .id = 607,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1276,
    .sample_nbytes = 55,
    .add_nsamples = 91,
    .nadds = 14,
},
{
    .id = 608,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2834,
    .sample_nbytes = 25,
    .add_nsamples = 111,
    .nadds = 26,
},
{
    .id = 609,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2742,
    .sample_nbytes = 60,
    .add_nsamples = 73,
    .nadds = 38,
},
{
    .id = 610,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1517,
    .sample_nbytes = 43,
    .add_nsamples = 15,
    .nadds = 101,
},
{
    .id = 611,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3260,
    .sample_nbytes = 28,
    .add_nsamples = 13,
    .nadds = 251,
},
{
    .id = 612,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2151,
    .sample_nbytes = 1,
    .add_nsamples = 81,
    .nadds = 26,
},
{
    .id = 613,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2089,
    .sample_nbytes = 42,
    .add_nsamples = 198,
    .nadds = 10,
},
{
    .id = 614,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 560,
    .sample_nbytes = 64,
    .add_nsamples = 66,
    .nadds = 9,
},
{
    .id = 615,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3681,
    .sample_nbytes = 20,
    .add_nsamples = 102,
    .nadds = 36,
},
{
    .id = 616,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3519,
    .sample_nbytes = 58,
    .add_nsamples = 147,
    .nadds = 24,
},
{
    .id = 617,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2111,
    .sample_nbytes = 38,
    .add_nsamples = 156,
    .nadds = 13,
},
{
    .id = 618,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3566,
    .sample_nbytes = 31,
    .add_nsamples = 145,
    .nadds = 25,
},
{
    .id = 619,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 843,
    .sample_nbytes = 47,
    .add_nsamples = 160,
    .nadds = 5,
},
{
    .id = 620,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 580,
    .sample_nbytes = 43,
    .add_nsamples = 1,
    .nadds = 579,
},
{
    .id = 621,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1821,
    .sample_nbytes = 6,
    .add_nsamples = 82,
    .nadds = 23,
},
{
    .id = 622,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3326,
    .sample_nbytes = 26,
    .add_nsamples = 130,
    .nadds = 25,
},
{
    .id = 623,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 275,
    .sample_nbytes = 19,
    .add_nsamples = 161,
    .nadds = 2,
},
{
    .id = 624,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2709,
    .sample_nbytes = 24,
    .add_nsamples = 63,
    .nadds = 42,
},
{
    .id = 625,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1967,
    .sample_nbytes = 53,
    .add_nsamples = 71,
    .nadds = 28,
},
{
    .id = 626,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3335,
    .sample_nbytes = 17,
    .add_nsamples = 179,
    .nadds = 19,
},
{
    .id = 627,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 988,
    .sample_nbytes = 50,
    .add_nsamples = 18,
    .nadds = 54,
},
{
    .id = 628,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2264,
    .sample_nbytes = 49,
    .add_nsamples = 142,
    .nadds = 15,
},
{
    .id = 629,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2888,
    .sample_nbytes = 51,
    .add_nsamples = 75,
    .nadds = 39,
},
{
    .id = 630,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 848,
    .sample_nbytes = 52,
    .add_nsamples = 92,
    .nadds = 10,
},
{
    .id = 631,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2692,
    .sample_nbytes = 24,
    .add_nsamples = 118,
    .nadds = 23,
},
{
    .id = 632,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1019,
    .sample_nbytes = 45,
    .add_nsamples = 193,
    .nadds = 6,
},
{
    .id = 633,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1072,
    .sample_nbytes = 63,
    .add_nsamples = 111,
    .nadds = 10,
},
{
    .id = 634,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2680,
    .sample_nbytes = 25,
    .add_nsamples = 197,
    .nadds = 14,
},
{
    .id = 635,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2347,
    .sample_nbytes = 49,
    .add_nsamples = 65,
    .nadds = 37,
},
{
    .id = 636,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3560,
    .sample_nbytes = 27,
    .add_nsamples = 63,
    .nadds = 57,
},
{
    .id = 637,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1803,
    .sample_nbytes = 37,
    .add_nsamples = 117,
    .nadds = 15,
},
{
    .id = 638,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2709,
    .sample_nbytes = 15,
    .add_nsamples = 190,
    .nadds = 15,
},
{
    .id = 639,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3145,
    .sample_nbytes = 55,
    .add_nsamples = 174,
    .nadds = 18,
},
{
    .id = 640,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1347,
    .sample_nbytes = 59,
    .add_nsamples = 6,
    .nadds = 224,
},
{
    .id = 641,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 188,
    .sample_nbytes = 48,
    .add_nsamples = 31,
    .nadds = 7,
},
{
    .id = 642,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1497,
    .sample_nbytes = 39,
    .add_nsamples = 91,
    .nadds = 17,
},
{
    .id = 643,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3000,
    .sample_nbytes = 27,
    .add_nsamples = 93,
    .nadds = 33,
},
{
    .id = 644,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2434,
    .sample_nbytes = 30,
    .add_nsamples = 105,
    .nadds = 23,
},
{
    .id = 645,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 171,
    .sample_nbytes = 5,
    .add_nsamples = 177,
    .nadds = 1,
},
{
    .id = 646,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1476,
    .sample_nbytes = 29,
    .add_nsamples = 121,
    .nadds = 13,
},
{
    .id = 647,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3899,
    .sample_nbytes = 51,
    .add_nsamples = 19,
    .nadds = 206,
},
{
    .id = 648,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1855,
    .sample_nbytes = 53,
    .add_nsamples = 67,
    .nadds = 27,
},
{
    .id = 649,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2324,
    .sample_nbytes = 1,
    .add_nsamples = 78,
    .nadds = 30,
},
{
    .id = 650,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3131,
    .sample_nbytes = 20,
    .add_nsamples = 130,
    .nadds = 24,
},
{
    .id = 651,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 917,
    .sample_nbytes = 19,
    .add_nsamples = 153,
    .nadds = 5,
},
{
    .id = 652,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 152,
    .sample_nbytes = 56,
    .add_nsamples = 159,
    .nadds = 0,
},
{
    .id = 653,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1710,
    .sample_nbytes = 34,
    .add_nsamples = 77,
    .nadds = 23,
},
{
    .id = 654,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 56,
    .sample_nbytes = 6,
    .add_nsamples = 89,
    .nadds = 0,
},
{
    .id = 655,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1104,
    .sample_nbytes = 57,
    .add_nsamples = 175,
    .nadds = 7,
},
{
    .id = 656,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 539,
    .sample_nbytes = 27,
    .add_nsamples = 169,
    .nadds = 3,
},
{
    .id = 657,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3013,
    .sample_nbytes = 42,
    .add_nsamples = 162,
    .nadds = 18,
},
{
    .id = 658,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1369,
    .sample_nbytes = 36,
    .add_nsamples = 173,
    .nadds = 7,
},
{
    .id = 659,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1889,
    .sample_nbytes = 36,
    .add_nsamples = 118,
    .nadds = 16,
},
{
    .id = 660,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1239,
    .sample_nbytes = 39,
    .add_nsamples = 135,
    .nadds = 9,
},
{
    .id = 661,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2385,
    .sample_nbytes = 40,
    .add_nsamples = 147,
    .nadds = 17,
},
{
    .id = 662,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3891,
    .sample_nbytes = 3,
    .add_nsamples = 17,
    .nadds = 229,
},
{
    .id = 663,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 320,
    .sample_nbytes = 36,
    .add_nsamples = 166,
    .nadds = 1,
},
{
    .id = 664,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1306,
    .sample_nbytes = 46,
    .add_nsamples = 1,
    .nadds = 1305,
},
{
    .id = 665,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3153,
    .sample_nbytes = 18,
    .add_nsamples = 195,
    .nadds = 17,
},
{
    .id = 666,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 653,
    .sample_nbytes = 32,
    .add_nsamples = 155,
    .nadds = 5,
},
{
    .id = 667,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2767,
    .sample_nbytes = 51,
    .add_nsamples = 12,
    .nadds = 231,
},
{
    .id = 668,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2841,
    .sample_nbytes = 10,
    .add_nsamples = 9,
    .nadds = 316,
},
{
    .id = 669,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2456,
    .sample_nbytes = 56,
    .add_nsamples = 69,
    .nadds = 35,
},
{
    .id = 670,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1888,
    .sample_nbytes = 12,
    .add_nsamples = 183,
    .nadds = 11,
},
{
    .id = 671,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1795,
    .sample_nbytes = 26,
    .add_nsamples = 82,
    .nadds = 22,
},
{
    .id = 672,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 878,
    .sample_nbytes = 2,
    .add_nsamples = 190,
    .nadds = 5,
},
{
    .id = 673,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 689,
    .sample_nbytes = 5,
    .add_nsamples = 114,
    .nadds = 6,
},
{
    .id = 674,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3461,
    .sample_nbytes = 32,
    .add_nsamples = 154,
    .nadds = 23,
},
{
    .id = 675,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2683,
    .sample_nbytes = 52,
    .add_nsamples = 6,
    .nadds = 448,
},
{
    .id = 676,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3420,
    .sample_nbytes = 61,
    .add_nsamples = 87,
    .nadds = 39,
},
{
    .id = 677,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3649,
    .sample_nbytes = 63,
    .add_nsamples = 149,
    .nadds = 24,
},
{
    .id = 678,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1313,
    .sample_nbytes = 18,
    .add_nsamples = 122,
    .nadds = 10,
},
{
    .id = 679,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1010,
    .sample_nbytes = 19,
    .add_nsamples = 85,
    .nadds = 11,
},
{
    .id = 680,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1510,
    .sample_nbytes = 21,
    .add_nsamples = 6,
    .nadds = 252,
},
{
    .id = 681,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 49,
    .sample_nbytes = 33,
    .add_nsamples = 108,
    .nadds = 1,
},
{
    .id = 682,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3164,
    .sample_nbytes = 61,
    .add_nsamples = 193,
    .nadds = 17,
},
{
    .id = 683,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3797,
    .sample_nbytes = 50,
    .add_nsamples = 16,
    .nadds = 238,
},
{
    .id = 684,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3439,
    .sample_nbytes = 23,
    .add_nsamples = 76,
    .nadds = 46,
},
{
    .id = 685,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 705,
    .sample_nbytes = 45,
    .add_nsamples = 103,
    .nadds = 6,
},
{
    .id = 686,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2217,
    .sample_nbytes = 10,
    .add_nsamples = 170,
    .nadds = 14,
},
{
    .id = 687,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2843,
    .sample_nbytes = 13,
    .add_nsamples = 194,
    .nadds = 14,
},
{
    .id = 688,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2511,
    .sample_nbytes = 57,
    .add_nsamples = 61,
    .nadds = 42,
},
{
    .id = 689,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 361,
    .sample_nbytes = 37,
    .add_nsamples = 138,
    .nadds = 2,
},
{
    .id = 690,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1553,
    .sample_nbytes = 30,
    .add_nsamples = 178,
    .nadds = 9,
},
{
    .id = 691,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 844,
    .sample_nbytes = 51,
    .add_nsamples = 60,
    .nadds = 14,
},
{
    .id = 692,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3755,
    .sample_nbytes = 61,
    .add_nsamples = 7,
    .nadds = 537,
},
{
    .id = 693,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2245,
    .sample_nbytes = 8,
    .add_nsamples = 48,
    .nadds = 47,
},
{
    .id = 694,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 402,
    .sample_nbytes = 17,
    .add_nsamples = 15,
    .nadds = 26,
},
{
    .id = 695,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 292,
    .sample_nbytes = 33,
    .add_nsamples = 120,
    .nadds = 3,
},
{
    .id = 696,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2441,
    .sample_nbytes = 48,
    .add_nsamples = 161,
    .nadds = 15,
},
{
    .id = 697,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2709,
    .sample_nbytes = 49,
    .add_nsamples = 104,
    .nadds = 26,
},
{
    .id = 698,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 976,
    .sample_nbytes = 3,
    .add_nsamples = 89,
    .nadds = 10,
},
{
    .id = 699,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1146,
    .sample_nbytes = 64,
    .add_nsamples = 197,
    .nadds = 6,
},
{
    .id = 700,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1779,
    .sample_nbytes = 39,
    .add_nsamples = 105,
    .nadds = 17,
},
{
    .id = 701,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 652,
    .sample_nbytes = 7,
    .add_nsamples = 170,
    .nadds = 3,
},
{
    .id = 702,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3258,
    .sample_nbytes = 15,
    .add_nsamples = 199,
    .nadds = 17,
},
{
    .id = 703,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2744,
    .sample_nbytes = 15,
    .add_nsamples = 17,
    .nadds = 162,
},
{
    .id = 704,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1699,
    .sample_nbytes = 13,
    .add_nsamples = 84,
    .nadds = 20,
},
{
    .id = 705,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2120,
    .sample_nbytes = 14,
    .add_nsamples = 34,
    .nadds = 63,
},
{
    .id = 706,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3830,
    .sample_nbytes = 30,
    .add_nsamples = 116,
    .nadds = 34,
},
{
    .id = 707,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1163,
    .sample_nbytes = 25,
    .add_nsamples = 96,
    .nadds = 12,
},
{
    .id = 708,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1491,
    .sample_nbytes = 23,
    .add_nsamples = 161,
    .nadds = 10,
},
{
    .id = 709,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1967,
    .sample_nbytes = 43,
    .add_nsamples = 129,
    .nadds = 15,
},
{
    .id = 710,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 262,
    .sample_nbytes = 45,
    .add_nsamples = 197,
    .nadds = 1,
},
{
    .id = 711,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1722,
    .sample_nbytes = 12,
    .add_nsamples = 146,
    .nadds = 12,
},
{
    .id = 712,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3600,
    .sample_nbytes = 2,
    .add_nsamples = 87,
    .nadds = 42,
},
{
    .id = 713,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3722,
    .sample_nbytes = 57,
    .add_nsamples = 169,
    .nadds = 22,
},
{
    .id = 714,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 226,
    .sample_nbytes = 25,
    .add_nsamples = 72,
    .nadds = 3,
},
{
    .id = 715,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 69,
    .sample_nbytes = 36,
    .add_nsamples = 95,
    .nadds = 1,
},
{
    .id = 716,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 600,
    .sample_nbytes = 51,
    .add_nsamples = 148,
    .nadds = 5,
},
{
    .id = 717,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2302,
    .sample_nbytes = 30,
    .add_nsamples = 64,
    .nadds = 36,
},
{
    .id = 718,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3177,
    .sample_nbytes = 56,
    .add_nsamples = 153,
    .nadds = 20,
},
{
    .id = 719,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 429,
    .sample_nbytes = 4,
    .add_nsamples = 49,
    .nadds = 8,
},
{
    .id = 720,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1905,
    .sample_nbytes = 16,
    .add_nsamples = 62,
    .nadds = 30,
},
{
    .id = 721,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2047,
    .sample_nbytes = 15,
    .add_nsamples = 42,
    .nadds = 48,
},
{
    .id = 722,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3971,
    .sample_nbytes = 37,
    .add_nsamples = 128,
    .nadds = 32,
},
{
    .id = 723,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1883,
    .sample_nbytes = 4,
    .add_nsamples = 33,
    .nadds = 57,
},
{
    .id = 724,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2568,
    .sample_nbytes = 38,
    .add_nsamples = 13,
    .nadds = 198,
},
{
    .id = 725,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2692,
    .sample_nbytes = 6,
    .add_nsamples = 34,
    .nadds = 80,
},
{
    .id = 726,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1247,
    .sample_nbytes = 45,
    .add_nsamples = 130,
    .nadds = 10,
},
{
    .id = 727,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3686,
    .sample_nbytes = 23,
    .add_nsamples = 127,
    .nadds = 30,
},
{
    .id = 728,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1316,
    .sample_nbytes = 31,
    .add_nsamples = 190,
    .nadds = 6,
},
{
    .id = 729,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1385,
    .sample_nbytes = 7,
    .add_nsamples = 167,
    .nadds = 9,
},
{
    .id = 730,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1139,
    .sample_nbytes = 54,
    .add_nsamples = 29,
    .nadds = 39,
},
{
    .id = 731,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2435,
    .sample_nbytes = 63,
    .add_nsamples = 74,
    .nadds = 33,
},
{
    .id = 732,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1468,
    .sample_nbytes = 29,
    .add_nsamples = 7,
    .nadds = 210,
},
{
    .id = 733,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2778,
    .sample_nbytes = 61,
    .add_nsamples = 124,
    .nadds = 23,
},
{
    .id = 734,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1820,
    .sample_nbytes = 12,
    .add_nsamples = 7,
    .nadds = 259,
},
{
    .id = 735,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3618,
    .sample_nbytes = 16,
    .add_nsamples = 67,
    .nadds = 54,
},
{
    .id = 736,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 960,
    .sample_nbytes = 30,
    .add_nsamples = 129,
    .nadds = 8,
},
{
    .id = 737,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2931,
    .sample_nbytes = 10,
    .add_nsamples = 47,
    .nadds = 62,
},
{
    .id = 738,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2989,
    .sample_nbytes = 30,
    .add_nsamples = 41,
    .nadds = 73,
},
{
    .id = 739,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3861,
    .sample_nbytes = 42,
    .add_nsamples = 56,
    .nadds = 69,
},
{
    .id = 740,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 508,
    .sample_nbytes = 35,
    .add_nsamples = 162,
    .nadds = 4,
},
{
    .id = 741,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3291,
    .sample_nbytes = 7,
    .add_nsamples = 48,
    .nadds = 69,
},
{
    .id = 742,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3952,
    .sample_nbytes = 46,
    .add_nsamples = 146,
    .nadds = 28,
},
{
    .id = 743,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3644,
    .sample_nbytes = 38,
    .add_nsamples = 194,
    .nadds = 19,
},
{
    .id = 744,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 858,
    .sample_nbytes = 7,
    .add_nsamples = 167,
    .nadds = 6,
},
{
    .id = 745,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1912,
    .sample_nbytes = 3,
    .add_nsamples = 164,
    .nadds = 11,
},
{
    .id = 746,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3269,
    .sample_nbytes = 3,
    .add_nsamples = 13,
    .nadds = 251,
},
{
    .id = 747,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3361,
    .sample_nbytes = 56,
    .add_nsamples = 169,
    .nadds = 20,
},
{
    .id = 748,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3307,
    .sample_nbytes = 26,
    .add_nsamples = 9,
    .nadds = 368,
},
{
    .id = 749,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1029,
    .sample_nbytes = 13,
    .add_nsamples = 85,
    .nadds = 13,
},
{
    .id = 750,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1178,
    .sample_nbytes = 60,
    .add_nsamples = 114,
    .nadds = 11,
},
{
    .id = 751,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2325,
    .sample_nbytes = 63,
    .add_nsamples = 65,
    .nadds = 35,
},
{
    .id = 752,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 200,
    .sample_nbytes = 32,
    .add_nsamples = 191,
    .nadds = 1,
},
{
    .id = 753,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1969,
    .sample_nbytes = 10,
    .add_nsamples = 140,
    .nadds = 14,
},
{
    .id = 754,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1416,
    .sample_nbytes = 55,
    .add_nsamples = 72,
    .nadds = 20,
},
{
    .id = 755,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 732,
    .sample_nbytes = 10,
    .add_nsamples = 156,
    .nadds = 5,
},
{
    .id = 756,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2219,
    .sample_nbytes = 39,
    .add_nsamples = 113,
    .nadds = 19,
},
{
    .id = 757,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3710,
    .sample_nbytes = 54,
    .add_nsamples = 13,
    .nadds = 286,
},
{
    .id = 758,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3978,
    .sample_nbytes = 27,
    .add_nsamples = 88,
    .nadds = 45,
},
{
    .id = 759,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3872,
    .sample_nbytes = 55,
    .add_nsamples = 148,
    .nadds = 26,
},
{
    .id = 760,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 373,
    .sample_nbytes = 33,
    .add_nsamples = 14,
    .nadds = 27,
},
{
    .id = 761,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3001,
    .sample_nbytes = 17,
    .add_nsamples = 132,
    .nadds = 22,
},
{
    .id = 762,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 171,
    .sample_nbytes = 9,
    .add_nsamples = 180,
    .nadds = 0,
},
{
    .id = 763,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 727,
    .sample_nbytes = 21,
    .add_nsamples = 198,
    .nadds = 4,
},
{
    .id = 764,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1111,
    .sample_nbytes = 7,
    .add_nsamples = 84,
    .nadds = 13,
},
{
    .id = 765,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3566,
    .sample_nbytes = 50,
    .add_nsamples = 167,
    .nadds = 21,
},
{
    .id = 766,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3659,
    .sample_nbytes = 64,
    .add_nsamples = 32,
    .nadds = 114,
},
{
    .id = 767,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3691,
    .sample_nbytes = 2,
    .add_nsamples = 177,
    .nadds = 21,
},
{
    .id = 768,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3811,
    .sample_nbytes = 42,
    .add_nsamples = 25,
    .nadds = 153,
},
{
    .id = 769,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 173,
    .sample_nbytes = 13,
    .add_nsamples = 32,
    .nadds = 5,
},
{
    .id = 770,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 937,
    .sample_nbytes = 55,
    .add_nsamples = 194,
    .nadds = 5,
},
{
    .id = 771,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2415,
    .sample_nbytes = 22,
    .add_nsamples = 178,
    .nadds = 13,
},
{
    .id = 772,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3674,
    .sample_nbytes = 62,
    .add_nsamples = 116,
    .nadds = 31,
},
{
    .id = 773,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1011,
    .sample_nbytes = 34,
    .add_nsamples = 1,
    .nadds = 1010,
},
{
    .id = 774,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3288,
    .sample_nbytes = 12,
    .add_nsamples = 118,
    .nadds = 28,
},
{
    .id = 775,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3394,
    .sample_nbytes = 62,
    .add_nsamples = 85,
    .nadds = 40,
},
{
    .id = 776,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 167,
    .sample_nbytes = 31,
    .add_nsamples = 164,
    .nadds = 1,
},
{
    .id = 777,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 627,
    .sample_nbytes = 38,
    .add_nsamples = 142,
    .nadds = 4,
},
{
    .id = 778,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1559,
    .sample_nbytes = 19,
    .add_nsamples = 74,
    .nadds = 22,
},
{
    .id = 779,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3783,
    .sample_nbytes = 31,
    .add_nsamples = 88,
    .nadds = 42,
},
{
    .id = 780,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3002,
    .sample_nbytes = 61,
    .add_nsamples = 58,
    .nadds = 52,
},
{
    .id = 781,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2167,
    .sample_nbytes = 39,
    .add_nsamples = 69,
    .nadds = 31,
},
{
    .id = 782,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 406,
    .sample_nbytes = 41,
    .add_nsamples = 159,
    .nadds = 2,
},
{
    .id = 783,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3556,
    .sample_nbytes = 10,
    .add_nsamples = 96,
    .nadds = 37,
},
{
    .id = 784,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3167,
    .sample_nbytes = 53,
    .add_nsamples = 151,
    .nadds = 21,
},
{
    .id = 785,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2752,
    .sample_nbytes = 11,
    .add_nsamples = 64,
    .nadds = 43,
},
{
    .id = 786,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 831,
    .sample_nbytes = 55,
    .add_nsamples = 74,
    .nadds = 11,
},
{
    .id = 787,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1726,
    .sample_nbytes = 5,
    .add_nsamples = 105,
    .nadds = 17,
},
{
    .id = 788,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3088,
    .sample_nbytes = 53,
    .add_nsamples = 54,
    .nadds = 58,
},
{
    .id = 789,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2574,
    .sample_nbytes = 60,
    .add_nsamples = 140,
    .nadds = 18,
},
{
    .id = 790,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3844,
    .sample_nbytes = 43,
    .add_nsamples = 40,
    .nadds = 97,
},
{
    .id = 791,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3886,
    .sample_nbytes = 10,
    .add_nsamples = 83,
    .nadds = 47,
},
{
    .id = 792,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3636,
    .sample_nbytes = 60,
    .add_nsamples = 28,
    .nadds = 130,
},
{
    .id = 793,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3603,
    .sample_nbytes = 46,
    .add_nsamples = 10,
    .nadds = 360,
},
{
    .id = 794,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 356,
    .sample_nbytes = 12,
    .add_nsamples = 82,
    .nadds = 4,
},
{
    .id = 795,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1018,
    .sample_nbytes = 34,
    .add_nsamples = 171,
    .nadds = 6,
},
{
    .id = 796,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2513,
    .sample_nbytes = 11,
    .add_nsamples = 135,
    .nadds = 19,
},
{
    .id = 797,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1944,
    .sample_nbytes = 26,
    .add_nsamples = 162,
    .nadds = 12,
},
{
    .id = 798,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 398,
    .sample_nbytes = 31,
    .add_nsamples = 81,
    .nadds = 5,
},
{
    .id = 799,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1447,
    .sample_nbytes = 50,
    .add_nsamples = 89,
    .nadds = 16,
},
{
    .id = 800,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3443,
    .sample_nbytes = 15,
    .add_nsamples = 141,
    .nadds = 25,
},
{
    .id = 801,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 945,
    .sample_nbytes = 11,
    .add_nsamples = 95,
    .nadds = 10,
},
{
    .id = 802,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 388,
    .sample_nbytes = 34,
    .add_nsamples = 152,
    .nadds = 3,
},
{
    .id = 803,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2003,
    .sample_nbytes = 7,
    .add_nsamples = 67,
    .nadds = 30,
},
{
    .id = 804,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1073,
    .sample_nbytes = 54,
    .add_nsamples = 128,
    .nadds = 8,
},
{
    .id = 805,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3909,
    .sample_nbytes = 22,
    .add_nsamples = 171,
    .nadds = 22,
},
{
    .id = 806,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 869,
    .sample_nbytes = 9,
    .add_nsamples = 156,
    .nadds = 5,
},
{
    .id = 807,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3143,
    .sample_nbytes = 4,
    .add_nsamples = 89,
    .nadds = 35,
},
{
    .id = 808,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3026,
    .sample_nbytes = 48,
    .add_nsamples = 172,
    .nadds = 18,
},
{
    .id = 809,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 819,
    .sample_nbytes = 36,
    .add_nsamples = 56,
    .nadds = 14,
},
{
    .id = 810,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2915,
    .sample_nbytes = 11,
    .add_nsamples = 115,
    .nadds = 25,
},
{
    .id = 811,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 699,
    .sample_nbytes = 62,
    .add_nsamples = 117,
    .nadds = 6,
},
{
    .id = 812,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2408,
    .sample_nbytes = 9,
    .add_nsamples = 104,
    .nadds = 23,
},
{
    .id = 813,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 883,
    .sample_nbytes = 53,
    .add_nsamples = 65,
    .nadds = 13,
},
{
    .id = 814,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1378,
    .sample_nbytes = 34,
    .add_nsamples = 13,
    .nadds = 105,
},
{
    .id = 815,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 215,
    .sample_nbytes = 61,
    .add_nsamples = 99,
    .nadds = 3,
},
{
    .id = 816,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1895,
    .sample_nbytes = 5,
    .add_nsamples = 144,
    .nadds = 13,
},
{
    .id = 817,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3775,
    .sample_nbytes = 2,
    .add_nsamples = 115,
    .nadds = 32,
},
{
    .id = 818,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2521,
    .sample_nbytes = 34,
    .add_nsamples = 168,
    .nadds = 15,
},
{
    .id = 819,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 6,
    .sample_nbytes = 59,
    .add_nsamples = 191,
    .nadds = 1,
},
{
    .id = 820,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 797,
    .sample_nbytes = 41,
    .add_nsamples = 58,
    .nadds = 14,
},
{
    .id = 821,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1131,
    .sample_nbytes = 23,
    .add_nsamples = 192,
    .nadds = 6,
},
{
    .id = 822,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3194,
    .sample_nbytes = 63,
    .add_nsamples = 199,
    .nadds = 17,
},
{
    .id = 823,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3466,
    .sample_nbytes = 61,
    .add_nsamples = 163,
    .nadds = 21,
},
{
    .id = 824,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1188,
    .sample_nbytes = 22,
    .add_nsamples = 4,
    .nadds = 296,
},
{
    .id = 825,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2870,
    .sample_nbytes = 3,
    .add_nsamples = 124,
    .nadds = 24,
},
{
    .id = 826,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3684,
    .sample_nbytes = 37,
    .add_nsamples = 159,
    .nadds = 24,
},
{
    .id = 827,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2726,
    .sample_nbytes = 20,
    .add_nsamples = 144,
    .nadds = 18,
},
{
    .id = 828,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2422,
    .sample_nbytes = 56,
    .add_nsamples = 99,
    .nadds = 25,
},
{
    .id = 829,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2381,
    .sample_nbytes = 57,
    .add_nsamples = 144,
    .nadds = 17,
},
{
    .id = 830,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2575,
    .sample_nbytes = 43,
    .add_nsamples = 46,
    .nadds = 56,
},
{
    .id = 831,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1127,
    .sample_nbytes = 34,
    .add_nsamples = 111,
    .nadds = 11,
},
{
    .id = 832,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3873,
    .sample_nbytes = 11,
    .add_nsamples = 33,
    .nadds = 118,
},
{
    .id = 833,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2437,
    .sample_nbytes = 28,
    .add_nsamples = 51,
    .nadds = 47,
},
{
    .id = 834,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3095,
    .sample_nbytes = 13,
    .add_nsamples = 61,
    .nadds = 50,
},
{
    .id = 835,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 599,
    .sample_nbytes = 24,
    .add_nsamples = 192,
    .nadds = 4,
},
{
    .id = 836,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3768,
    .sample_nbytes = 24,
    .add_nsamples = 28,
    .nadds = 135,
},
{
    .id = 837,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 874,
    .sample_nbytes = 6,
    .add_nsamples = 161,
    .nadds = 5,
},
{
    .id = 838,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 677,
    .sample_nbytes = 22,
    .add_nsamples = 53,
    .nadds = 13,
},
{
    .id = 839,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1975,
    .sample_nbytes = 55,
    .add_nsamples = 70,
    .nadds = 29,
},
{
    .id = 840,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 974,
    .sample_nbytes = 61,
    .add_nsamples = 19,
    .nadds = 51,
},
{
    .id = 841,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3364,
    .sample_nbytes = 28,
    .add_nsamples = 17,
    .nadds = 198,
},
{
    .id = 842,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2413,
    .sample_nbytes = 7,
    .add_nsamples = 195,
    .nadds = 13,
},
{
    .id = 843,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2446,
    .sample_nbytes = 30,
    .add_nsamples = 8,
    .nadds = 306,
},
{
    .id = 844,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3766,
    .sample_nbytes = 8,
    .add_nsamples = 31,
    .nadds = 122,
},
{
    .id = 845,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2915,
    .sample_nbytes = 20,
    .add_nsamples = 97,
    .nadds = 31,
},
{
    .id = 846,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 160,
    .sample_nbytes = 64,
    .add_nsamples = 42,
    .nadds = 4,
},
{
    .id = 847,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1297,
    .sample_nbytes = 4,
    .add_nsamples = 49,
    .nadds = 27,
},
{
    .id = 848,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 198,
    .sample_nbytes = 19,
    .add_nsamples = 87,
    .nadds = 3,
},
{
    .id = 849,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2267,
    .sample_nbytes = 38,
    .add_nsamples = 74,
    .nadds = 31,
},
{
    .id = 850,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2234,
    .sample_nbytes = 7,
    .add_nsamples = 165,
    .nadds = 14,
},
{
    .id = 851,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 429,
    .sample_nbytes = 10,
    .add_nsamples = 30,
    .nadds = 15,
},
{
    .id = 852,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3152,
    .sample_nbytes = 13,
    .add_nsamples = 113,
    .nadds = 27,
},
{
    .id = 853,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1865,
    .sample_nbytes = 58,
    .add_nsamples = 79,
    .nadds = 24,
},
{
    .id = 854,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1962,
    .sample_nbytes = 61,
    .add_nsamples = 160,
    .nadds = 13,
},
{
    .id = 855,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1133,
    .sample_nbytes = 62,
    .add_nsamples = 95,
    .nadds = 12,
},
{
    .id = 856,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1657,
    .sample_nbytes = 20,
    .add_nsamples = 21,
    .nadds = 79,
},
{
    .id = 857,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3758,
    .sample_nbytes = 49,
    .add_nsamples = 27,
    .nadds = 139,
},
{
    .id = 858,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3162,
    .sample_nbytes = 8,
    .add_nsamples = 43,
    .nadds = 74,
},
{
    .id = 859,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 616,
    .sample_nbytes = 11,
    .add_nsamples = 130,
    .nadds = 4,
},
{
    .id = 860,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 62,
    .sample_nbytes = 23,
    .add_nsamples = 101,
    .nadds = 1,
},
{
    .id = 861,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3691,
    .sample_nbytes = 28,
    .add_nsamples = 192,
    .nadds = 20,
},
{
    .id = 862,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 33,
    .sample_nbytes = 47,
    .add_nsamples = 58,
    .nadds = 0,
},
{
    .id = 863,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1209,
    .sample_nbytes = 5,
    .add_nsamples = 152,
    .nadds = 8,
},
{
    .id = 864,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1071,
    .sample_nbytes = 16,
    .add_nsamples = 158,
    .nadds = 6,
},
{
    .id = 865,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2488,
    .sample_nbytes = 63,
    .add_nsamples = 18,
    .nadds = 138,
},
{
    .id = 866,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1852,
    .sample_nbytes = 1,
    .add_nsamples = 132,
    .nadds = 15,
},
{
    .id = 867,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3570,
    .sample_nbytes = 50,
    .add_nsamples = 175,
    .nadds = 21,
},
{
    .id = 868,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2352,
    .sample_nbytes = 8,
    .add_nsamples = 30,
    .nadds = 79,
},
{
    .id = 869,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 459,
    .sample_nbytes = 9,
    .add_nsamples = 158,
    .nadds = 2,
},
{
    .id = 870,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1351,
    .sample_nbytes = 8,
    .add_nsamples = 153,
    .nadds = 8,
},
{
    .id = 871,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2430,
    .sample_nbytes = 12,
    .add_nsamples = 77,
    .nadds = 32,
},
{
    .id = 872,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1006,
    .sample_nbytes = 31,
    .add_nsamples = 125,
    .nadds = 8,
},
{
    .id = 873,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2105,
    .sample_nbytes = 14,
    .add_nsamples = 1,
    .nadds = 2104,
},
{
    .id = 874,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2925,
    .sample_nbytes = 54,
    .add_nsamples = 48,
    .nadds = 60,
},
{
    .id = 875,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 201,
    .sample_nbytes = 9,
    .add_nsamples = 193,
    .nadds = 2,
},
{
    .id = 876,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1363,
    .sample_nbytes = 2,
    .add_nsamples = 152,
    .nadds = 9,
},
{
    .id = 877,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 65,
    .sample_nbytes = 13,
    .add_nsamples = 106,
    .nadds = 0,
},
{
    .id = 878,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 759,
    .sample_nbytes = 39,
    .add_nsamples = 179,
    .nadds = 4,
},
{
    .id = 879,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2440,
    .sample_nbytes = 35,
    .add_nsamples = 171,
    .nadds = 14,
},
{
    .id = 880,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3592,
    .sample_nbytes = 3,
    .add_nsamples = 128,
    .nadds = 29,
},
{
    .id = 881,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1982,
    .sample_nbytes = 56,
    .add_nsamples = 189,
    .nadds = 10,
},
{
    .id = 882,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 285,
    .sample_nbytes = 6,
    .add_nsamples = 8,
    .nadds = 35,
},
{
    .id = 883,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2485,
    .sample_nbytes = 13,
    .add_nsamples = 37,
    .nadds = 67,
},
{
    .id = 884,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2968,
    .sample_nbytes = 35,
    .add_nsamples = 38,
    .nadds = 78,
},
{
    .id = 885,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1562,
    .sample_nbytes = 51,
    .add_nsamples = 71,
    .nadds = 22,
},
{
    .id = 886,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2675,
    .sample_nbytes = 42,
    .add_nsamples = 143,
    .nadds = 18,
},
{
    .id = 887,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2073,
    .sample_nbytes = 37,
    .add_nsamples = 1,
    .nadds = 2072,
},
{
    .id = 888,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3542,
    .sample_nbytes = 3,
    .add_nsamples = 65,
    .nadds = 55,
},
{
    .id = 889,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1596,
    .sample_nbytes = 33,
    .add_nsamples = 140,
    .nadds = 11,
},
{
    .id = 890,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 970,
    .sample_nbytes = 52,
    .add_nsamples = 4,
    .nadds = 243,
},
{
    .id = 891,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1784,
    .sample_nbytes = 62,
    .add_nsamples = 150,
    .nadds = 11,
},
{
    .id = 892,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 183,
    .sample_nbytes = 15,
    .add_nsamples = 40,
    .nadds = 4,
},
{
    .id = 893,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2771,
    .sample_nbytes = 54,
    .add_nsamples = 36,
    .nadds = 76,
},
{
    .id = 894,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2332,
    .sample_nbytes = 42,
    .add_nsamples = 162,
    .nadds = 15,
},
{
    .id = 895,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2290,
    .sample_nbytes = 13,
    .add_nsamples = 50,
    .nadds = 45,
},
{
    .id = 896,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1235,
    .sample_nbytes = 28,
    .add_nsamples = 36,
    .nadds = 34,
},
{
    .id = 897,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 368,
    .sample_nbytes = 17,
    .add_nsamples = 171,
    .nadds = 2,
},
{
    .id = 898,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 785,
    .sample_nbytes = 22,
    .add_nsamples = 18,
    .nadds = 44,
},
{
    .id = 899,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3396,
    .sample_nbytes = 22,
    .add_nsamples = 200,
    .nadds = 16,
},
{
    .id = 900,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 525,
    .sample_nbytes = 43,
    .add_nsamples = 108,
    .nadds = 5,
},
{
    .id = 901,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 124,
    .sample_nbytes = 47,
    .add_nsamples = 129,
    .nadds = 1,
},
{
    .id = 902,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1290,
    .sample_nbytes = 35,
    .add_nsamples = 169,
    .nadds = 7,
},
{
    .id = 903,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3489,
    .sample_nbytes = 18,
    .add_nsamples = 103,
    .nadds = 34,
},
{
    .id = 904,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 204,
    .sample_nbytes = 26,
    .add_nsamples = 63,
    .nadds = 4,
},
{
    .id = 905,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 604,
    .sample_nbytes = 43,
    .add_nsamples = 113,
    .nadds = 5,
},
{
    .id = 906,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 738,
    .sample_nbytes = 54,
    .add_nsamples = 29,
    .nadds = 26,
},
{
    .id = 907,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3105,
    .sample_nbytes = 9,
    .add_nsamples = 129,
    .nadds = 24,
},
{
    .id = 908,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2823,
    .sample_nbytes = 46,
    .add_nsamples = 169,
    .nadds = 16,
},
{
    .id = 909,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2551,
    .sample_nbytes = 7,
    .add_nsamples = 107,
    .nadds = 24,
},
{
    .id = 910,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3133,
    .sample_nbytes = 40,
    .add_nsamples = 131,
    .nadds = 24,
},
{
    .id = 911,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3254,
    .sample_nbytes = 12,
    .add_nsamples = 128,
    .nadds = 26,
},
{
    .id = 912,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2777,
    .sample_nbytes = 1,
    .add_nsamples = 118,
    .nadds = 24,
},
{
    .id = 913,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 944,
    .sample_nbytes = 30,
    .add_nsamples = 192,
    .nadds = 4,
},
{
    .id = 914,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2975,
    .sample_nbytes = 50,
    .add_nsamples = 11,
    .nadds = 271,
},
{
    .id = 915,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2411,
    .sample_nbytes = 50,
    .add_nsamples = 108,
    .nadds = 22,
},
{
    .id = 916,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2962,
    .sample_nbytes = 63,
    .add_nsamples = 161,
    .nadds = 18,
},
{
    .id = 917,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2781,
    .sample_nbytes = 41,
    .add_nsamples = 1,
    .nadds = 2781,
},
{
    .id = 918,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1661,
    .sample_nbytes = 19,
    .add_nsamples = 88,
    .nadds = 18,
},
{
    .id = 919,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 74,
    .sample_nbytes = 23,
    .add_nsamples = 121,
    .nadds = 0,
},
{
    .id = 920,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2609,
    .sample_nbytes = 40,
    .add_nsamples = 47,
    .nadds = 55,
},
{
    .id = 921,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 700,
    .sample_nbytes = 9,
    .add_nsamples = 17,
    .nadds = 42,
},
{
    .id = 922,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 781,
    .sample_nbytes = 8,
    .add_nsamples = 100,
    .nadds = 7,
},
{
    .id = 923,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2393,
    .sample_nbytes = 33,
    .add_nsamples = 97,
    .nadds = 25,
},
{
    .id = 924,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1367,
    .sample_nbytes = 64,
    .add_nsamples = 100,
    .nadds = 14,
},
{
    .id = 925,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 488,
    .sample_nbytes = 46,
    .add_nsamples = 98,
    .nadds = 4,
},
{
    .id = 926,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3459,
    .sample_nbytes = 22,
    .add_nsamples = 98,
    .nadds = 36,
},
{
    .id = 927,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 778,
    .sample_nbytes = 13,
    .add_nsamples = 151,
    .nadds = 5,
},
{
    .id = 928,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1292,
    .sample_nbytes = 33,
    .add_nsamples = 88,
    .nadds = 15,
},
{
    .id = 929,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 788,
    .sample_nbytes = 27,
    .add_nsamples = 55,
    .nadds = 14,
},
{
    .id = 930,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 907,
    .sample_nbytes = 29,
    .add_nsamples = 158,
    .nadds = 6,
},
{
    .id = 931,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3988,
    .sample_nbytes = 32,
    .add_nsamples = 29,
    .nadds = 137,
},
{
    .id = 932,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1211,
    .sample_nbytes = 36,
    .add_nsamples = 62,
    .nadds = 19,
},
{
    .id = 933,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2238,
    .sample_nbytes = 21,
    .add_nsamples = 142,
    .nadds = 15,
},
{
    .id = 934,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2716,
    .sample_nbytes = 15,
    .add_nsamples = 65,
    .nadds = 42,
},
{
    .id = 935,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1978,
    .sample_nbytes = 34,
    .add_nsamples = 101,
    .nadds = 19,
},
{
    .id = 936,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3088,
    .sample_nbytes = 17,
    .add_nsamples = 21,
    .nadds = 148,
},
{
    .id = 937,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3432,
    .sample_nbytes = 5,
    .add_nsamples = 16,
    .nadds = 214,
},
{
    .id = 938,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2284,
    .sample_nbytes = 4,
    .add_nsamples = 123,
    .nadds = 19,
},
{
    .id = 939,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2991,
    .sample_nbytes = 27,
    .add_nsamples = 139,
    .nadds = 21,
},
{
    .id = 940,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2539,
    .sample_nbytes = 5,
    .add_nsamples = 71,
    .nadds = 36,
},
{
    .id = 941,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3107,
    .sample_nbytes = 16,
    .add_nsamples = 160,
    .nadds = 19,
},
{
    .id = 942,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2460,
    .sample_nbytes = 32,
    .add_nsamples = 115,
    .nadds = 21,
},
{
    .id = 943,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2043,
    .sample_nbytes = 52,
    .add_nsamples = 195,
    .nadds = 10,
},
{
    .id = 944,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 610,
    .sample_nbytes = 38,
    .add_nsamples = 17,
    .nadds = 36,
},
{
    .id = 945,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1002,
    .sample_nbytes = 23,
    .add_nsamples = 181,
    .nadds = 5,
},
{
    .id = 946,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1074,
    .sample_nbytes = 24,
    .add_nsamples = 127,
    .nadds = 9,
},
{
    .id = 947,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3064,
    .sample_nbytes = 39,
    .add_nsamples = 64,
    .nadds = 47,
},
{
    .id = 948,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 2117,
    .sample_nbytes = 25,
    .add_nsamples = 121,
    .nadds = 18,
},
{
    .id = 949,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 227,
    .sample_nbytes = 25,
    .add_nsamples = 105,
    .nadds = 3,
},
{
    .id = 950,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2245,
    .sample_nbytes = 49,
    .add_nsamples = 24,
    .nadds = 94,
},
{
    .id = 951,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3800,
    .sample_nbytes = 7,
    .add_nsamples = 80,
    .nadds = 47,
},
{
    .id = 952,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1187,
    .sample_nbytes = 57,
    .add_nsamples = 13,
    .nadds = 92,
},
{
    .id = 953,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 762,
    .sample_nbytes = 1,
    .add_nsamples = 105,
    .nadds = 8,
},
{
    .id = 954,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2184,
    .sample_nbytes = 8,
    .add_nsamples = 166,
    .nadds = 14,
},
{
    .id = 955,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 857,
    .sample_nbytes = 8,
    .add_nsamples = 76,
    .nadds = 11,
},
{
    .id = 956,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 52,
    .sample_nbytes = 60,
    .add_nsamples = 143,
    .nadds = 0,
},
{
    .id = 957,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2422,
    .sample_nbytes = 64,
    .add_nsamples = 19,
    .nadds = 127,
},
{
    .id = 958,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1630,
    .sample_nbytes = 55,
    .add_nsamples = 71,
    .nadds = 23,
},
{
    .id = 959,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2178,
    .sample_nbytes = 31,
    .add_nsamples = 61,
    .nadds = 35,
},
{
    .id = 960,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1669,
    .sample_nbytes = 1,
    .add_nsamples = 11,
    .nadds = 152,
},
{
    .id = 961,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 809,
    .sample_nbytes = 48,
    .add_nsamples = 74,
    .nadds = 11,
},
{
    .id = 962,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 629,
    .sample_nbytes = 21,
    .add_nsamples = 37,
    .nadds = 16,
},
{
    .id = 963,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3292,
    .sample_nbytes = 58,
    .add_nsamples = 187,
    .nadds = 18,
},
{
    .id = 964,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1349,
    .sample_nbytes = 22,
    .add_nsamples = 28,
    .nadds = 48,
},
{
    .id = 965,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3441,
    .sample_nbytes = 11,
    .add_nsamples = 94,
    .nadds = 36,
},
{
    .id = 966,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 63,
    .sample_nbytes = 26,
    .add_nsamples = 107,
    .nadds = 1,
},
{
    .id = 967,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1706,
    .sample_nbytes = 42,
    .add_nsamples = 78,
    .nadds = 21,
},
{
    .id = 968,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3807,
    .sample_nbytes = 40,
    .add_nsamples = 184,
    .nadds = 21,
},
{
    .id = 969,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3028,
    .sample_nbytes = 53,
    .add_nsamples = 19,
    .nadds = 159,
},
{
    .id = 970,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 198,
    .sample_nbytes = 50,
    .add_nsamples = 111,
    .nadds = 1,
},
{
    .id = 971,
    .err = CCERR_OK,
    .digest_info = ccsha384_di,
    .seed_nsamples = 162,
    .sample_nbytes = 47,
    .add_nsamples = 194,
    .nadds = 1,
},
{
    .id = 972,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1746,
    .sample_nbytes = 44,
    .add_nsamples = 109,
    .nadds = 16,
},
{
    .id = 973,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3820,
    .sample_nbytes = 27,
    .add_nsamples = 77,
    .nadds = 49,
},
{
    .id = 974,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 2159,
    .sample_nbytes = 19,
    .add_nsamples = 168,
    .nadds = 12,
},
{
    .id = 975,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 2567,
    .sample_nbytes = 55,
    .add_nsamples = 160,
    .nadds = 17,
},
{
    .id = 976,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3882,
    .sample_nbytes = 44,
    .add_nsamples = 24,
    .nadds = 162,
},
{
    .id = 977,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3047,
    .sample_nbytes = 3,
    .add_nsamples = 48,
    .nadds = 64,
},
{
    .id = 978,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 515,
    .sample_nbytes = 36,
    .add_nsamples = 36,
    .nadds = 15,
},
{
    .id = 979,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1806,
    .sample_nbytes = 44,
    .add_nsamples = 71,
    .nadds = 26,
},
{
    .id = 980,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1214,
    .sample_nbytes = 25,
    .add_nsamples = 182,
    .nadds = 6,
},
{
    .id = 981,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3097,
    .sample_nbytes = 4,
    .add_nsamples = 126,
    .nadds = 24,
},
{
    .id = 982,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 1232,
    .sample_nbytes = 26,
    .add_nsamples = 108,
    .nadds = 12,
},
{
    .id = 983,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 688,
    .sample_nbytes = 45,
    .add_nsamples = 78,
    .nadds = 8,
},
{
    .id = 984,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 710,
    .sample_nbytes = 46,
    .add_nsamples = 183,
    .nadds = 3,
},
{
    .id = 985,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 3754,
    .sample_nbytes = 25,
    .add_nsamples = 121,
    .nadds = 31,
},
{
    .id = 986,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3013,
    .sample_nbytes = 25,
    .add_nsamples = 87,
    .nadds = 34,
},
{
    .id = 987,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3656,
    .sample_nbytes = 41,
    .add_nsamples = 44,
    .nadds = 84,
},
{
    .id = 988,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 3433,
    .sample_nbytes = 44,
    .add_nsamples = 77,
    .nadds = 45,
},
{
    .id = 989,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha224_di,
    .seed_nsamples = 1336,
    .sample_nbytes = 28,
    .add_nsamples = 18,
    .nadds = 74,
},
{
    .id = 990,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 1114,
    .sample_nbytes = 27,
    .add_nsamples = 163,
    .nadds = 6,
},
{
    .id = 991,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha384_di,
    .seed_nsamples = 760,
    .sample_nbytes = 62,
    .add_nsamples = 24,
    .nadds = 31,
},
{
    .id = 992,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3614,
    .sample_nbytes = 47,
    .add_nsamples = 154,
    .nadds = 23,
},
{
    .id = 993,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 1606,
    .sample_nbytes = 63,
    .add_nsamples = 93,
    .nadds = 18,
},
{
    .id = 994,
    .err = CCERR_OK,
    .digest_info = ccsha224_di,
    .seed_nsamples = 2196,
    .sample_nbytes = 1,
    .add_nsamples = 6,
    .nadds = 366,
},
{
    .id = 995,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha512_di,
    .seed_nsamples = 3064,
    .sample_nbytes = 12,
    .add_nsamples = 8,
    .nadds = 382,
},
{
    .id = 996,
    .err = CCERR_OK,
    .digest_info = ccsha256_di,
    .seed_nsamples = 3795,
    .sample_nbytes = 63,
    .add_nsamples = 29,
    .nadds = 131,
},
{
    .id = 997,
    .err = CCERR_OK,
    .digest_info = ccsha512_di,
    .seed_nsamples = 11,
    .sample_nbytes = 3,
    .add_nsamples = 164,
    .nadds = 1,
},
{
    .id = 998,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 995,
    .sample_nbytes = 43,
    .add_nsamples = 49,
    .nadds = 20,
},
{
    .id = 999,
    .err = CCERR_OUT_OF_ENTROPY,
    .digest_info = ccsha256_di,
    .seed_nsamples = 114,
    .sample_nbytes = 3,
    .add_nsamples = 74,
    .nadds = 1,
},
